/**
 * Sergey Kopeliovich (burunduk30@gmail.com)
 *
 * Идея: 
 *		Кидаем случайные треугольники, пока не получим YES
 *		Пока внутри есть хотя бы одна точка, расщепляемся по случайной точке
 *
 * Время: ans*n
 * Запросы: есть тесты, на которых ответ содержится только в n треугольниках => E_QUERIES ~= n^2
 *		Стресс на рандоме находит тесты: n^2 <= q <= 2n^2
 * 
 * Баллы: 41
 */

#include <bits/stdc++.h>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)

typedef long long ll;

struct pnt {
	int x, y;
	pnt operator - ( pnt p ) { return {x - p.x, y - p.y}; }
	ll operator * ( pnt p ) { return (ll)x * p.y - (ll)y * p.x; }
};
vector<pnt> p;

ll area( int i, int j, int k ) {
	return abs((p[i] - p[j]) * (p[j] - p[k]));
};
bool is_in( int p, int a, int b, int c ) {
	return area(a, b, c) == area(a, b, p) + area(a, c, p) + area(c, b, p);
};

void out( char c, const vector<int> &ind ) {
	printf("%c %ld", c, ind.size());
	for (int i : ind)
		printf(" %d", i + 1);
	puts("");
	fflush(stdout);
};
bool ask( const vector<int> &ind ) {
	out('?', ind);
	char s[9];
	assert(scanf("%s", s) == 1);
	return tolower(s[0]) == 'y';
};

int main() {
	int n;
	assert(scanf("%d", &n) == 1);
	p.resize(n);
	forn(i, n)
		assert(scanf("%d%d", &p[i].x, &p[i].y) == 2);
	
	int q;
	scanf("%d", &q);
	vector<int> ind;
	while (q--) {
		int i = -1, j = -1, k = -1;
		while (1) {
			i = rand() % n;
			j = rand() % n;
			k = rand() % n;
			if (i == j || j == k || k == i)
				continue;
			if (ask({i, j, k}))
				break;
		}
		while (1) {
			ind.clear();
			forn(t, n)
				if (t != i && t != j && t != k && is_in(t, i, j, k))
					ind.push_back(t);
			if (ind.empty())
				break;
			int t = ind[rand() % ind.size()];
			if (ask({i, j, t}))
				k = t;
			else if (ask({i, t, k}))
				j = t;
			else
				i = t;
		}
		out('!', {i, j, k});
	}
}
