/*
File name: rg_n.cpp
Tag: MAIN
Author: gorbunovr
Change time: Thu Mar 30 02:19:51 MSK 2017

*/
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <cstdlib>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <queue>
#include <ctime>
#include <string>
#include <cstring>
#include <random>
#define mp make_pair
#define pb push_back
#define NAME ""
#define y1 y1_423
#define list lista

using namespace std;

typedef long long ll;
typedef long double ld;

const int nmax = 1000 * 1000;
const int inf = 2000 * 1000 * 1000;
const ll infl = 1000ll * 1000ll * 1000ll * 1000ll * 1000ll * 1000ll;
const int mod = 1000 * 1000 * 1000 + 7;
const ld pi = acos(-1.0);

struct edge {
	int u, l, r;
};

struct seg {
	int can, l, r;
};

int n, t[nmax];
vector<edge> a[nmax];
vector<seg> answ[nmax], pref[nmax], suf[nmax];
seg answera[nmax];

seg merge(seg a, seg b) {
	if (!a.can || !b.can) {
		return {0, 0, 0};
	}
	if (b.r < a.l || a.r < b.l) {
		return {0, 0, 0};
	}
	return {1, max(a.l, b.l), min(a.r, b.r)};
}

seg merge(seg now, edge u, int t) {
	if (!now.can) return {0, 0, 0};
	if (max(now.l, u.l) > min(now.r, u.r)) {
		return {0, 0, 0};
	}
	if (u.l < now.l) {
		return {1, now.l, min(now.r, u.r)};
	} else {
		return {1, u.l - t, min(now.r, u.r)};
	}
}

seg dfs(int v, int p) {
	seg answer = {1, 0, inf};
	answ[v].clear();
	pref[v].clear();
	suf[v].clear();
	for (auto u : a[v]) {
		if (u.u == p) {
			answ[v].pb({1, 0, inf});
			continue;
		}
		seg now = dfs(u.u, v);
		answ[v].pb(merge(now, u, t[v]));
	}
	for (auto u : answ[v]) {
		answer = merge(answer, u);
	}
	pref[v].resize(answ[v].size() + 1);
	suf[v].resize(answ[v].size() + 1);
	pref[v][0] = {1, 0, inf};
	suf[v].back() = {1, 0, inf};
	for (int i = 1; i < (int)pref[v].size(); i++) {
		pref[v][i] = merge(pref[v][i - 1], answ[v][i - 1]);
	}
	for (int i = (int)suf[v].size() - 2; i >= 0; i--) {
		suf[v][i] = merge(suf[v][i + 1], answ[v][i]);
	}
	return answer;
}

void dfsa(int v, seg now, int p) {
	answera[v] = merge(now, pref[v].back());
	for (int i = 0; i < (int)a[v].size(); i++) {
		if (a[v][i].u == p) continue;
		dfsa(a[v][i].u, merge(merge(merge(now, pref[v][i]), suf[v][i + 1]), a[v][i], t[a[v][i].u]), v);
	}
}

int x, y, l, r;

int main() {
    freopen("servers.in", "r", stdin);
    freopen("servers.out", "w", stdout);
    
	scanf("%d", &n);
	for (int i = 0; i < n; i++) {
		scanf("%d", t + i);
	}
	for (int i = 0; i < n - 1; i++) {
		scanf("%d%d", &l, &r);
		x = i;
		y = i + 1;
		a[x].pb({y, l, r});
		a[y].pb({x, l, r});
	}
	dfs(0, -1);
	dfsa(0, {1, 0, inf}, -1);
	for (int i = 0; i < n; i++) {
		printf("%d\n", (answera[i].can ? answera[i].l : -1));
	}
	return 0;
}


