/*
File name: burn_tree_pm_n2.java
Tag: REJECTED
Author: pkunyavskiy
Change time: Thu Mar 30 02:29:17 MSK 2017

*/
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.StringTokenizer;
import java.io.*;


/**
 * @author Pavel Mavrin
 */
public class burn_tree_pm_n2 {


    private void solve() throws IOException {
        int n = nextInt();
        init(n);
        for (int i = 0; i < n; i++) {
            T[i] = nextInt();
        }
        for (int i = 0; i < n - 1; i++) {
            // int v = nextInt() - 1;
            // int u = nextInt() - 1;
            int l = nextInt();
            int r = nextInt();
            addEdge(i, i + 1, l, r);
        }
//        dfs(3, -1);
        for (int i = 0; i < n; i++) {
            dfs(i, -1);
            if (bad[i]) {
                out.println(-1);
            } else {
                out.println(ld[i]);
            }
        }
    }

    void init(int n) {
        this.n = n;
        this.m = (n - 1) * 2;
        last = 0;
        head = new int[n];
        nx = new int[m];
        dst = new int[m];
        T = new int[n];
        L = new int[m];
        R = new int[m];
        ld = new int[n];
        rd = new int[n];
        bad = new boolean[n];
        Arrays.fill(head, -1);
    }


    void addEdge(int v, int u, int l, int r) {
        nx[last] = head[v];
        dst[last] = u;
        L[last] = l;
        R[last] = r;
        head[v] = last;
        last++;
        nx[last] = head[u];
        dst[last] = v;
        L[last] = l;
        R[last] = r;
        head[u] = last;
        last++;
    }

    private void dfs(int x, int p) {
        int j = head[x];
        bad[x] = false;
        ld[x] = 0;
        rd[x] = Integer.MAX_VALUE;
        while (j >= 0) {
            int y = dst[j];
            if (y != p) {
                dfs(y, x);
                if (bad[y]) {
                    bad[x] = true;
                    return;
                }
                int ll = Math.max(L[j], ld[y]);
                int rr = Math.min(R[j], rd[y]);
                if (ll > rr) {
                    bad[x] = true;
                    return;
                }
                if (ll == L[j]) {
                    ll -= T[x];
                }
                ld[x] = Math.max(ld[x], ll);
                rd[x] = Math.min(rd[x], rr);
            }
            j = nx[j];
        }
        if (rd[x] < ld[x]) {
            bad[x] = true;
        }
//        System.out.println((x + 1) + " " + ld[x] + " " + rd[x]);
    }

    int n, m;
    int[] head, nx, dst;
    int last;
    private int[] T, L, R;
    private int[] ld, rd;
    private boolean[] bad;



    // ------------------

    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;
    {
        try {
            br = new BufferedReader(new FileReader("servers.in"));
            out = new PrintWriter("servers.out");
        } catch (IOException ignored) {
        }
    }

    String next() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public static void main(String[] args) throws IOException {
        new burn_tree_pm_n2().run();
    }

    private void run() throws IOException {
        solve();
        out.close();
    }

}
