/*
File name: segments_ma_n2_halfclev.cpp
Tag: TIME_LIMIT_EXCEEDED
Author: niyaznigmatul
Change time: Wed Mar 29 22:13:58 MSK 2017

*/
#include <cstdio>
#include <cassert>
#include <tuple>
#include <algorithm>
#include <numeric>
#include <vector>
using namespace std;

typedef long long llong;

#define eprintf(...) fprintf(stderr, __VA_ARGS__)

#ifndef LOCAL42
    #define TASK "internship"
#endif

vector<pair<int, int>> pts;

const int N = 1000500;
const llong inf = 1e17;

vector<int> A, WA;
vector<llong> SA;
vector<int> B, WB;
vector<llong> SB;

void read(int n, vector<int>& X, vector<int>& WX, vector<llong>& SX) {
    X.resize(n);
    WX.resize(n);
    SX.resize(n + 1);
    for (int i = 0; i < n; i++) {
        scanf("%d", &X[i]);
        --X[i];
    }
    for (int i = 0; i < n; i++) {
        scanf("%d", &WX[i]);
        SX[i + 1] = SX[i] + WX[i];
    }
}

struct cake {
    vector<llong> W;
    cake() {
        W.assign(B.size() + 1, 0ll);
    }
    pair<llong, int> getMax(int bot) {
        pair<llong, int> mx(-1, -1);
        for (int i = 0; i <= bot; i++) {
            if (mx.first < W[i] + SB[bot] - SB[i]) {
                mx = make_pair(W[i] + SB[bot] - SB[i], i);
            }
        }
        return mx;
    }
    void add(int from, int to, llong delta) {
        for (int i = from; i <= to; i++)
            W[i] += delta;
    }
};

struct conqueror {
    vector<pair<int, llong>> SL = {{-1, 0ll}};
    vector<pair<int, llong>> SR = {{-1, 0ll}};

    int mid;
    int last = -1;
    tuple<llong, int, int> ans;

    cake C;

    conqueror(int _mid) : mid(_mid)
    { }

    void feed(int x, int y, bool relaxOnly = false) {
        C.add(last + 1, y, SA.back());
        auto cur = C.getMax(y);
        if (get<0>(ans) < cur.first) {
            ans = make_tuple(cur.first, cur.second, y - 1);
        }

        if (relaxOnly) {
            return;
        }

        auto& S = (x < mid) ? SL : SR;
        S.emplace_back(y, (x < mid) ? SA[mid] : SA.back() - SA[mid]);
        llong w = (x < mid) ? (SA[mid] - SA[x + 1]) : (SA[x] - SA[mid]);
        while (S.back().second > w) {
            assert(S.size() >= 2);
            int from = S[(int)S.size() - 2].first + 1;
            int to = S[(int)S.size() - 1].first;
            C.add(from, to, -S.back().second + w);
            S.pop_back();
        }
        S.emplace_back(y, w);
        last = y;
    }
};

tuple<llong, int, int, int, int> restoreByB(int l, int r) {
    vector<int> usedB(B.begin() + l, B.begin() + r + 1);
    sort(usedB.begin(), usedB.end());
    tuple<int, int, int> best(0, 0, -1);
    int last = -1;
    for (int i = 0; i < (int)A.size(); i++) {
        if (binary_search(usedB.begin(), usedB.end(), A[i])) {
            last = -1;
            continue;
        }
        if (last == -1) {
            last = i;
        }
        if (get<0>(best) < i - last + 1) {
            best = make_tuple(i - last + 1, last, i);
        }
    }
    int al, ar;
    tie(ignore, al, ar) = best;
    return make_tuple(SA[ar + 1] - SA[al] + SB[r + 1] - SB[l], al, ar, l, r);
}

tuple<llong, int, int, int, int> solve() {
    llong tothorW = accumulate(WA.begin(), WA.end(), 0ll);
    int mid = 0;
    llong leftW = 0;
    while (leftW * 2 < tothorW) {
        leftW += WA[mid++];
    }
    conqueror C(mid);
    sort(pts.begin(), pts.end(), [] (pair<int, int> a, pair<int, int> b) { return a.second < b.second; });
    for (const auto& pt : pts) {
        C.feed(pt.first, pt.second);
    }
    C.feed(-42, B.size(), true /* relaxOnly */);
    auto resB = C.ans;
    auto res = restoreByB(get<1>(resB), get<2>(resB));
    //assert(get<0>(res) == get<0>(resB));
    return res;
}

int main() {
#ifdef TASK
    freopen(TASK ".in", "r", stdin);
    freopen(TASK ".out", "w", stdout);
#endif
    int n, m;
    scanf("%d %d", &n, &m);
    pts.resize(n + m, {-1, -1});
    read(n, A, WA, SA);
    read(m, B, WB, SB);
    for (int i = 0; i < (int)A.size(); i++) {
        pts[A[i]].first = i;
    }
    for (int i = 0; i < (int)B.size(); i++) {
        pts[B[i]].second = i;
    }
    pts.erase(remove_if(pts.begin(), pts.end(), [] (pair<int, int> pt) { return pt.first == -1 || pt.second == -1; }), pts.end());
    auto ansv = solve();
    A.swap(B);
    WA.swap(WB);
    SA.swap(SB);
    for (auto& pt : pts) {
        swap(pt.first, pt.second);
    }
    auto ansh = solve();
    swap(get<1>(ansh), get<3>(ansh));
    swap(get<2>(ansh), get<4>(ansh));
    eprintf("ansv = (%lld, %d, %d, %d, %d)\n", get<0>(ansv), get<1>(ansv), get<2>(ansv), get<3>(ansv), get<4>(ansv));
    eprintf("ansh = (%lld, %d, %d, %d, %d)\n", get<0>(ansh), get<1>(ansh), get<2>(ansh), get<3>(ansh), get<4>(ansh));

    {
        auto ans = max(ansv, ansh);
        llong totw;
        int l0, r0, l1, r1;
        tie(totw, l0, r0, l1, r1) = ans;
        l0++, r0++, l1++, r1++;
        if (r0 == 0)
            l0 = 0;
        if (r1 == 0)
            l1 = 0;
        printf("%lld\n%d %d\n%d %d\n", totw, l0, r0, l1, r1);
    }
}

