#include <stdio.h>
#include <vector>
#include <algorithm>

struct point
{
	long long x, y;
	int num;
};

struct triangle
{
	point a, b, c;
};

long long vect(const point &a, const point &b, const point &c)
{
	return (a.x - b.x) * (c.y - b.y) - (c.x - b.x) * (a.y - b.y);
}

point fund;

bool* used;

long long abs(long long x)
{
	return x >= 0 ? x : -x;
}

bool less1(const point &a, const point &b)
{
	if (used[a.num - 1])
	{
		return false;
	}
	if (used[b.num - 1])
	{
		return true;
	}
	if (a.x != b.x)
	{
		return a.x < b.x;
	}
	return a.y < b.y;
}

bool less2(const point &a, const point &b)
{
	if (used[a.num - 1])
	{
		return false;
	}
	if (used[b.num - 1])
	{
		return true;
	}
	return vect(a, fund, b) > 0;
}

bool in_tr(point a, point b, point c, point r)
{
	return abs(vect(a, r, b)) + abs(vect(b, r, c)) + abs(vect(a, r, c)) == abs(vect(a, b, c));
}

int main()
{
	int n, q;
	scanf("%d", &n);
	point arr[n];
	used = new bool[n];
	for (int i = 0; i < n; i++)
	{
		scanf("%lld%lld", &arr[i].x, &arr[i].y);
		arr[i].num = i + 1;
	}
	scanf("%d", &q);
	triangle quest[n * n];
	int ind_tr = 0;
	std::sort(arr, arr + n, less1);
	std::vector<point> con_env1;
	while (!used[arr[0].num - 1])
	{
		std::vector<point> con_env;
		fund = arr[0];
		std::sort(arr + 1, arr + n, less2);
		for (int i = 0; i < n && !used[arr[i].num - 1]; i++)
		{
			while (int(con_env.size()) >= 2)
			{
				if (vect(con_env[int(con_env.size()) - 2], con_env[int(con_env.size()) - 1], arr[i]) > 0)
				{
					used[con_env[int(con_env.size()) - 1].num - 1] = false;
					con_env.pop_back();
				}
				else
				{
					break;
				}
			}
			con_env.push_back(arr[i]);
			used[arr[i].num - 1] = true;
		}
		std::sort(arr, arr + n, less1);
		int ind = 1;
		if (int(con_env1.size()) > 0)
		{
			if (int(con_env.size()) == 1)
			{
				for (int i = 0; i < int(con_env1.size()); i++)
				{
					quest[ind_tr].a = con_env[0];
					quest[ind_tr].b = con_env1[i];
					quest[ind_tr].c = con_env1[(i + 1) % int(con_env1.size())];
					ind_tr++;
				}
			}
			else if (int(con_env.size()) == 2)
			{
				for (int i = 0; i < int(con_env1.size()); i++)
				{
					if (in_tr(con_env[0], con_env1[i], con_env1[(i + 1) % int(con_env1.size())], con_env[1]))
					{
						quest[ind_tr].a = con_env[1];
						quest[ind_tr].b = con_env1[i];
						quest[ind_tr].c = con_env1[(i + 1) % int(con_env1.size())];
						ind_tr++;
					}
					else
					{
						quest[ind_tr].a = con_env[0];
						quest[ind_tr].b = con_env1[i];
						quest[ind_tr].c = con_env1[(i + 1) % int(con_env1.size())];
						ind_tr++;
					}
				}
				for (int i = 0; i < int(con_env1.size()); i++)
				{
					quest[ind_tr].a = con_env[0];
					quest[ind_tr].b = con_env[1];
					quest[ind_tr].c = con_env1[i];
					ind_tr++;
				}
			}
			else
			{
				for (int i = 0; i < int(con_env.size()); i++)
				{
					quest[ind_tr].a = con_env[(i - 1 + int(con_env.size())) % int(con_env.size())];
					quest[ind_tr].b = con_env1[(ind - 1 + int(con_env1.size())) % int(con_env1.size())];
					quest[ind_tr].c = con_env[i];
					ind_tr++;
					while (vect(con_env1[ind], con_env[i], con_env[(i + 1) % int(con_env.size())]) > 0)
					{
						quest[ind_tr].a = con_env1[(ind - 1 + int(con_env1.size())) % int(con_env1.size())];
						quest[ind_tr].b = con_env[i];
						quest[ind_tr].c = con_env1[ind];
						ind_tr++;
						ind++;
						ind %= int(con_env1.size());
					}
				}
			}
		}
		con_env1 = con_env;
	}
	for (int w = 0; w < q; w++)
	{
		char ans[10];
		bool flag = false;
		if (int(con_env1.size()) > 2)
		{
			printf("? ");
			for (int i = 0; i < int(con_env1.size()); i++)
			{
				printf("%d ", con_env1[i].num);
			}
			printf("\n");
			fflush(stdout);
			scanf("%s", ans);
			if (ans[0] == 'Y')
			{
				printf("! ");
				for (int i = 0; i < int(con_env1.size()); i++)
				{
					printf("%d ", con_env1[i].num);
				}
				printf("\n");
				fflush(stdout);
				flag = true;
			}
		}
		for (int i = 0; i < ind_tr && !flag; i++)
		{
			printf("? %d %d %d\n", quest[i].a.num, quest[i].b.num, quest[i].c.num);
			fflush(stdout);
			scanf("%s", ans);
			if (ans[0] == 'Y')
			{
				printf("! %d %d %d\n", quest[i].a.num, quest[i].b.num, quest[i].c.num);
				fflush(stdout);
				flag = true;
			}
		}
	}
	return 0;
}
