#include <bits/stdc++.h>

using namespace std;

#define endl "\n"

typedef int64_t ll;
typedef uint64_t ull;

const size_t SIZE = 32;
const pair<int, int> NONE{-1, -1};

struct Restriction {
    vector<pair<int, int>> rules;
    vector<int> res, against;
    int bad = 0;

    Restriction(int n)
            : rules(n, NONE), res(SIZE, 0), against(n, 0) {}

    void add(int ind, int num, int val) {
        rules[ind] = {num, val};
        if ((res[num] > 0 and val == 0) or (res[num] < 0 and val == 1)) {
            ++against[num];
            if (against[num] == 1) {
                ++bad;
            }
        } else {
            if (val == 1) {
                ++res[num];
            } else {
                --res[num];
            }
        }
    }

    void remove(int ind) {
        auto &rule = rules[ind];
        if (rule == NONE) {
            return;
        }
        int &num = rule.first, &val = rule.second;
        if ((res[num] > 0 and val == 0) or (res[num] < 0 and val == 1)) {
            --against[num];
            if (against[num] == 0) {
                --bad;
            }
        } else {
            if (val == 1) {
                --res[num];
            } else {
                ++res[num];
            }
            if (res[num] == 0) {
                res[num] = against[num] * (1 - 2 * val);
                if (against[num] != 0) {
                    --bad;
                }
                against[num] = 0;
            }
        }
        rule = NONE;
    }

    int get() {
        if (bad > 0) {
            return -1;
        }
        int number = 0;
        for (int i = 0; i < SIZE; ++i) {
            if (res[i] > 0) {
                number += 1 << i;
            }
        }
        return number;
    }
};


void solve() {
    int n;
    cin >> n;
    Restriction restrictions(n);
    vector<bitset<SIZE>> nums;
    for (int i = 0; i < n; ++i) {
        ull num;
        cin >> num;
        nums.emplace_back(num);
    }
    for (int i = 0; i < n - 1; ++i) {
        auto &f = nums[i];
        auto &s = nums[i + 1];
        for (int j = SIZE - 1; j >= 0; --j) {
            if (s[j] != f[j]) {
                restrictions.add(i, j, s[j] > f[j] ? 0 : 1);
                break;
            }
        }
    }
    cout << restrictions.get() << endl;

    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        ull p, v;
        cin >> p >> v;
        --p;
        nums[p] = bitset<SIZE>(v);

        if (p < n - 1) {
            restrictions.remove(p);
        }
        if (p > 0) {
            restrictions.remove(p - 1);
        }
        if (p < n - 1) {
            auto &f = nums[p];
            auto &s = nums[p + 1];
            for (int j = SIZE - 1; j >= 0; --j) {
                if (s[j] != f[j]) {
                    restrictions.add(p, j, s[j] > f[j] ? 0 : 1);
                    break;
                }
            }
        }
        if (p > 0) {
            auto &f = nums[p - 1];
            auto &s = nums[p];
            for (int j = SIZE - 1; j >= 0; --j) {
                if (s[j] != f[j]) {
                    restrictions.add(p - 1, j, s[j] > f[j] ? 0 : 1);
                    break;
                }
            }
        }
        cout << restrictions.get() << endl;
    }
}


int main() {
#ifdef MINE
    freopen("../input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);


    solve();

    return 0;
}