#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef double dbl;

const int INF = 2e9;
const dbl EPS = 1e-9;
const dbl PI = acos(-1);

struct Point {
	int x, y;

	Point() {}

	Point(int a, int b) {
		x = a, y = b;
	}
};

struct Vector {
	int x, y;

	Vector() {
		x = y = 0;
	}

	Vector(Point a, Point b) {
		x = b.x - a.x;
		y = b.y - a.y;
	}
};

inline ll crossProduct(Vector a, Vector b) {
	return a.x * b.y - a.y * b.x;
}

struct Segment {
	Point a, b;

	Segment() {}

	Segment(Point a, Point b) {
		this->a = a;
		this->b = b;
	}

	inline bool inters(Segment s, bool need = 1) {
		Vector seg = Vector(a, b);
		int sign1 = (crossProduct(seg, Vector(a, s.a)) < 0 ? -1 : 1);
		int sign2 = (crossProduct(seg, Vector(a, s.b)) < 0 ? -1 : 1);
		bool good = 1;

		if (need) {
			good = s.inters(*this, false);
		}

		return good && (sign1 * sign2 <= 0);
	}
};

struct Polygon {
	vector<Point> ps;

	Polygon() {}

	Polygon(int n) {
		ps.resize(n);

		for (int i = 0; i < n; i++) {
			cin >> ps[i].x >> ps[i].y;
		}
	}

	inline bool isInside(Point a) {
		Segment seg = Segment(a, Point((int)1e9 + 7, (int)1e9 + 9));
		int cnt = 0;

		for (int i = 0; i < (int)ps.size(); i++) {
			int nx = (i + 1) % (int)ps.size();

			if (seg.inters(Segment(ps[i], ps[nx]))) cnt++;
		}
		
		return (cnt & 1);
	}
};

Polygon p;
vector<int> now;
vector<vector<int> > ps;

void gen(int i) {
	if ((int)now.size() == 3) {
		int cnt = 0;

		Polygon tmp;

		for (auto t : now) {
			tmp.ps.push_back(p.ps[t]);
		}

		for (auto p : p.ps) {
			if (tmp.isInside(p)) cnt++;
			if (cnt > 3) break;
		}

		if (cnt == 3) {
			ps.push_back(now);
		}

		return;
	}
	if (i == (int)p.ps.size()) return;

	gen(i + 1);
	now.push_back(i);
	gen(i + 1);
	now.pop_back();
}

inline bool query(int ind) {
	cout << "? " << ps.size() << " ";
	for (auto p : ps[ind]) {
		cout << p + 1 << " ";
	}
	cout << endl;
	string res;
	cin >> res;

	return (res == "Yes");
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(nullptr);
	cout.tie(nullptr);

#ifdef GA_ROI
	// freopen("/home/roi/prjs/file.in", "r", stdin);
	// freopen("/home/roi/prjs/file.out", "w", stdout);
#else
	// freopen("file.in", "r", stdin);
	// freopen("file.out", "w", stdout);
#endif

	int n;
	cin >> n;

	p = Polygon(n);

	int q;
	cin >> q;

	gen(0);

	while (q--) {
		for (int i = 0; i < (int)ps.size(); i++) {
			if (query(i)) {
				cout << "! " << ps[i].size() << " ";
				for (auto p : ps[i]) {
					cout << p + 1 << " ";
				}
				cout << endl;

				break;
			}
		}
	}

	return 0;
}
