#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef double dbl;

const ll INF = 1e18;
const dbl EPS = 1e-9;
const dbl PI = acos(-1);

struct Dist {
	ll d, g, last, path;

	inline bool friend operator <(const Dist &a, const Dist &b) {
		return a.d < b.d || (a.d == b.d && a.g > b.g) || (a.d == b.d && a.g == b.g && a.last > b.last) || (a.d == b.d && a.g == b.g && a.last > b.last && a.path < b.path);
	}
};

struct Edge {
	ll to, c, path;
};

int main() {
	ios::sync_with_stdio(0);
	cin.tie(nullptr);
	cout.tie(nullptr);

#ifdef GA_ROI
	freopen("/home/roi/prjs/file.in", "r", stdin);
	freopen("/home/roi/prjs/file.out", "w", stdout);
#else
	freopen("trains.in", "r", stdin);
	freopen("trains.out", "w", stdout);
#endif

	ll n, m;
	cin >> n >> m;

	vector<vector<Edge> > edges(n);

	for (ll i = 0; i < m; i++) {
		ll s, last;
		cin >> s >> last;
		last--;

		for (int j = 0; j < s; j++) {
			ll c, to;
			cin >> c >> to;
			to--;

			edges[last].push_back({to, c, i});
		}
	}

	vector<Dist> dist(n, {INF, -1, -1, -1});
	dist[0] = {0, 0, 0, -1};
	set<pair<Dist, ll> > q;
	q.insert({{0, 0, 0, -1}, 0});

	while (!q.empty()) {
		ll v = q.begin()->second;
		q.erase(q.begin());

		for (auto e : edges[v]) {
			Dist nx;
			nx.d = dist[v].d + e.c;
			nx.path = e.path;

			if (dist[v].path == e.path) {
				nx.g = dist[v].g - dist[v].last * dist[v].last;
				dist[v].last += e.c;
				nx.g += dist[v].last * dist[v].last;
			} else {
				nx.last = 0;
				nx.g = dist[v].g + e.c * e.c;
			}

			if (nx < dist[e.to]) {
				q.erase({dist[e.to], e.to});
				dist[e.to] = nx;
				q.insert({dist[e.to], e.to});
			}
		}
	}

	cout << dist[n - 1].d << " " << dist[n - 1].g << "\n";

	return 0;
}
