#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef double dbl;

const ll INF = 2e18;
const dbl EPS = 1e-9;
const dbl PI = acos(-1);

struct Node {
	int l, r;
	ll mn;

	inline bool friend operator <(const Node &a, const Node &b) {
		return a.mn > b.mn || (a.mn == b.mn && make_pair(a.l, a.r) < make_pair(b.l, b.r));
	}
};

inline ll pack(Node a) {
	return ((ll)a.l << 35) + ((ll)a.r << 17) + a.mn;
}

int n, a;
vector<Node> steps;
vector<vector<ll> > dp;

ll getAns(int now, int c) {
	if (dp[now][c] != -1) return dp[now][c];

	ll ans = (ll)now * (ll)1e9 - c;

	for (auto s : steps) {
		if (now + s.r > a) continue;

		ll tmp = INF;

		for (int i = s.l; i <= s.r; i++) {
			tmp = min(tmp, getAns(now + i, c + s.mn));
		}

		ans = max(ans, tmp);
	}

	return (dp[now][c] = ans);
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(nullptr);
	cout.tie(nullptr);

#ifdef GA_ROI
	freopen("/home/roi/prjs/file.in", "r", stdin);
	freopen("/home/roi/prjs/file.out", "w", stdout);
#else
	freopen("anti.in", "r", stdin);
	freopen("anti.out", "w", stdout);
#endif

	cin >> n >> a;

	steps.resize(n);

	for (int i = 0; i < n; i++) {
		int l, r, c;
		cin >> l >> r >> c;
		steps[i] = {l, r, c};
	}

	dp.resize(a + 1, vector<ll>(a * 200, -1));

	cout << getAns(0, 0) << "\n";

	return 0;
}
