#include <bits/stdc++.h>

using namespace std;

const long long INF = 1000000000000000000;
const long long cost = 1000000000;

struct Stack1 {
    vector<long long> mn;

    Stack1() {
        mn.push_back(INF);
    }

    void push(long long x) {
        mn.push_back(min(mn.back(), x));
    }

    void pop() {
        mn.pop_back();
    }

    long long getMin() {
        return mn.back();
    }

    bool isEmpty() {
        return mn.size() == 1;
    }
};

struct Stack2 {
    vector<long long> st, mn;

    Stack2() {
        mn.push_back(INF);
    }

    void push(long long x) {
        st.push_back(x);
        mn.push_back(min(mn.back(), x));
    }

    long long pop() {
        long long ans = st.back();
        st.pop_back();
        mn.pop_back();
        return ans;
    }

    long long getMin() {
        return mn.back();
    }

    bool isEmpty() {
        return st.empty();
    }
};

struct Queue {
    Stack1 s1;
    Stack2 s2;

    Queue() {
        s1 = Stack1();
        s2 = Stack2();
    }

    void push(long long x) {
        s2.push(x);
    }

    void pop() {
        if (s1.isEmpty()) {
            while (!s2.isEmpty()) {
                s1.push(s2.pop());
            }
        }
        s1.pop();
    }

    long long getMin() {
        return min(s1.getMin(), s2.getMin());
    }
};

int main() {
    int n, a;
    scanf("%d%d", &n, &a);
    vector<int> l(n), r(n), c(n);
    for (int i = 0; i < n; i++) {
        scanf("%d%d%d", &l[i], &r[i], &c[i]);
    }
    vector<Queue> qs(n);

    vector<long long> ans(a + 1);
    long long added = cost;
    ans[a] = 0;

    // Move windows

    for (int j = 0; j < n; j++) {
        if (a + l[j] - 1 <= a) {
            qs[j].push(ans[a + l[j] - 1]);
        }
    }

    for (int i = a - 1; i >= 0; i--) {
        long long cv = 0;
        // Choose min
        for (int j = 0; j < n; j++) {
            if (i + r[j] <= a) {
                long long mx = qs[j].getMin();
                cv = max(cv, mx - c[j] + added);
            }
        }
        ans[i] = cv - added;

        if (i != 0) {
            added += cost;

            // Move windows

            for (int j = 0; j < n; j++) {
                if (i + r[j] <= a) {
                    qs[j].pop();
                }
                if (i + l[j] - 1 <= a) {
                    qs[j].push(ans[i + l[j] - 1]);
                }
            }
        }
    }

    cout << ans[0] + added << endl;

    return 0;
}