#include <bits/stdc++.h>

#define pub push_back
#define ll long long
#define mp make_pair
#define all(a) a.begin(), a.end()

using namespace std;

struct point{
    ll x, y, num;
    point() {}
    point(ll x1, ll y1) { x = x1; y = y1; }
    point operator+ (const point nxt) const { return point(x + nxt.x, y + nxt.y); }
    point operator- (const point nxt) const { return point(x - nxt.x, y - nxt.y); }
    ll operator% (const point nxt) const { return x * nxt.y - y * nxt.x; }
    ll operator* (const point nxt) const { return x * nxt.x + y * nxt.y; }
    bool operator< (const point nxt) const { return mp(x, y) < mp(nxt.x, nxt.y); }
    bool operator!= (const point nxt) const { return mp(x, y) != mp(nxt.x, nxt.y); }
};

ll plTr(point a, point b, point c){
    return abs((a % b) + (b % c) + (c % a));
}

bool inTr(point t, point a, point b, point c){
    return plTr(a, b, c) == plTr(t, a, b) + plTr(t, a, c) + plTr(t, c, b);
}

int n, q;
point a[5007];

vector<point> convex(vector<point> a){
    sort(all(a));
    vector<point> t, q;
    for (int i = 0; i < a.size(); i++){
        while(t.size() >= 2 && ((a[i] - t[(int)t.size() - 2]) % (t[(int)t.size() - 1] - t[(int)t.size() - 2])) <= 0) t.pop_back();
        t.pub(a[i]);
        while(q.size() >= 2 && ((a[i] - q[(int)q.size() - 2]) % (q[(int)q.size() - 1] - q[(int)q.size() - 2])) >= 0) q.pop_back();
        q.pub(a[i]);
    }
    for (int i = (int)q.size() - 2; i >= 1; i--) t.pub(q[i]);
    return t;
}

bool ask(point a, point b, point c){
    cout << "? 3 " << a.num + 1 << ' ' << b.num + 1 << ' ' << c.num + 1 << "\n";
    cout.flush();
    string s;
    cin >> s;
    return (s == "Yes");
}

void prAns(point a, point b, point c){
    cout << "! 3 " << a.num + 1 << ' ' << b.num + 1 << ' ' << c.num + 1 << "\n";
    cout.flush();
}

void go(point a, point b, point c, vector<point> t){
    if (t.size() == 0){
        prAns(a, b, c);
        return;
    }
    int uk = rand() % (int)t.size();
    vector<point> now;
    if (ask(a, b, t[uk])){
        for (int i = 0; i < t.size(); i++) if (i != uk && inTr(t[i], a, b, t[uk])) now.pub(t[i]);
        go(a, b, t[uk], now);
        return;
    }
    if (ask(a, c, t[uk])){
        for (int i = 0; i < t.size(); i++) if (i != uk && inTr(t[i], a, c, t[uk])) now.pub(t[i]);
        go(a, c, t[uk], now);
        return;
    }
    if (ask(c, b, t[uk])){
        for (int i = 0; i < t.size(); i++) if (i != uk && inTr(t[i], c, b, t[uk])) now.pub(t[i]);
        go(c, b, t[uk], now);
        return;
    }
}

const bool is_testing = 0;
int main(){
    srand('D' + 'E' + 'N' + 'I' + 'S' + 'S' + 'O' + 'N');
    if (is_testing){
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    } else {

    }
    cin >> n;
    for (int i = 0; i < n; i++) cin >> a[i].x >> a[i].y, a[i].num = i;
    vector<point> t, d;
    for (int i = 0; i < n; i++) t.pub(a[i]);
    t = convex(t);
    int uk = 0;
    for (int i = 0; i < t.size(); i++) if (t[i].y < t[uk].y || (t[i].y == t[uk].y && t[i].x < t[uk].y)) uk = i;
    for (int i = 0; i < t.size(); i++){
        d.pub(t[uk++]);
        if (uk == t.size()) uk = 0;
    }
    cin >> q;
    while(q--){
        uk = 1;
        for (int i = 1; i < (int)d.size() - 1; i++){
            if (ask(d[0], d[i], d[i + 1])){
                uk = i;
                break;
            }
        }
        vector<point> now;
        for (int i = 0; i < n; i++) if (a[i] != d[0] && a[i] != d[uk] && a[i] != d[uk + 1] && inTr(a[i], d[0], d[uk], d[uk + 1])) now.pub(a[i]);
        go(d[0], d[uk], d[uk + 1], now);
    }
}
