# include <iostream>
# include <cstdio>
# include <vector>
# include <cstring>

using namespace std;

struct Pr
{
    int x, y;
    Pr(){}
    Pr(int _x, int _y)
    {
        x = _x;
        y = _y;
    }
    bool operator<(const Pr &other) const
    {
        if (x == other.x) return y < other.y;
        return x < other.x;
    }
};

const int MAX_N = 1e5, INF = 1e9;
int n;
int a[MAX_N];
Pr tree1[31][4 * MAX_N], tree2[31][4 * MAX_N], tree3[31][4 * MAX_N], tree4[31][4 * MAX_N];

void build(int v, int l, int r, const int &curr)
{
    if (r == l + 1)
    {
        if (a[l] & (1 << curr))
        {
            tree1[curr][v].x = 1; tree1[curr][v].y = l;
            tree2[curr][v].x = 1; tree2[curr][v].y = l;
            tree3[curr][v].x = 1; tree3[curr][v].y = l;
            tree4[curr][v].x = 1; tree4[curr][v].y = l;
        }
        else
        {
            tree1[curr][v].x = 0; tree1[curr][v].y = l;
            tree2[curr][v].x = 0; tree2[curr][v].y = l;
            tree3[curr][v].x = 0; tree3[curr][v].y = l;
            tree4[curr][v].x = 0; tree4[curr][v].y = l;
        }
        return;
    }
    int m = (l + r) / 2;
    build(2 * v + 1, l, m, curr);
    build(2 * v + 2, m, r, curr);
    if (tree1[curr][2 * v + 1].x == tree1[curr][2 * v + 2].x)
    {
        tree1[curr][v] = tree1[curr][2 * v + 1];
        tree3[curr][v] = tree3[curr][2 * v + 2];
    }
    else
    {
        tree1[curr][v] = max(tree1[curr][2 * v + 1], tree1[curr][2 * v + 2]);
        tree3[curr][v] = max(tree3[curr][2 * v + 1], tree3[curr][2 * v + 2]);
    }
    if (tree2[curr][2 * v + 1].x == tree2[curr][2 * v + 2].x)
    {
        tree2[curr][v] = tree2[curr][2 * v + 2];
        tree4[curr][v] = tree4[curr][2 * v + 1];
    }
    else
    {
        tree2[curr][v] = min(tree2[curr][2 * v + 1], tree2[curr][2 * v + 2]);
        tree4[curr][v] = min(tree4[curr][2 * v + 1], tree4[curr][2 * v + 2]);
    }
}

Pr get1(int v, int l, int r, const int &curr, const int &L, const int &R)
{
    if (l >= R || L >= r)
    {
        return Pr(-1, -1);
    }
    if (l >= L && R >= r)
    {
        return tree1[curr][v];
    }
    int m = (l + r) / 2;
    Pr f = get1(2 * v + 1, l, m, curr, L, R), s = get1(2 * v + 2, m, r, curr, L, R);
    if (f.x == s.x) return f;
    return max(f, s);
}

Pr get2(int v, int l, int r, const int &curr, const int &L, const int &R)
{
    if (l >= R || L >= r)
    {
        return Pr(INF, INF);
    }
    if (l >= L && R >= r)
    {
        return tree2[curr][v];
    }
    int m = (l + r) / 2;
    Pr f = get2(2 * v + 1, l, m, curr, L, R), s = get2(2 * v + 2, m, r, curr, L, R);
    if (f.x == s.x) return s;
    return min(f, s);
}

Pr get3(int v, int l, int r, const int &curr, const int &L, const int &R)
{
    if (l >= R || L >= r)
    {
        return Pr(-1, -1);
    }
    if (l >= L && R >= r)
    {
        return tree3[curr][v];
    }
    int m = (l + r) / 2;
    Pr f = get3(2 * v + 1, l, m, curr, L, R), s = get3(2 * v + 2, m, r, curr, L, R);
    if (f.x == s.x) return s;
    return max(f, s);
}

Pr get4(int v, int l, int r, const int &curr, const int &L, const int &R)
{
    if (l >= R || L >= r)
    {
        return Pr(INF, INF);
    }
    if (l >= L && R >= r)
    {
        return tree4[curr][v];
    }
    int m = (l + r) / 2;
    Pr f = get4(2 * v + 1, l, m, curr, L, R), s = get4(2 * v + 2, m, r, curr, L, R);
    if (f.x == s.x) return f;
    return min(f, s);
}

void change(int v, int l, int r, const int &curr, const int &x, const int &nw)
{
    if (r == l + 1)
    {
            tree1[curr][v].x = nw; tree1[curr][v].y = l;
            tree2[curr][v].x = nw; tree2[curr][v].y = l;
            tree3[curr][v].x = nw; tree3[curr][v].y = l;
            tree4[curr][v].x = nw; tree4[curr][v].y = l;
        return;
    }
    int m = (l + r) / 2;
    if (x < m)
    {
        change(2 * v + 1, l, m, curr, x, nw);
    }
    else
    {
        change(2 * v + 2, m, r, curr, x, nw);
    }
    if (tree1[curr][2 * v + 1].x == tree1[curr][2 * v + 2].x)
    {
        tree1[curr][v] = tree1[curr][2 * v + 1];
        tree3[curr][v] = tree3[curr][2 * v + 2];
    }
    else
    {
        tree1[curr][v] = max(tree1[curr][2 * v + 1], tree1[curr][2 * v + 2]);
        tree3[curr][v] = max(tree3[curr][2 * v + 1], tree3[curr][2 * v + 2]);
    }
    if (tree2[curr][2 * v + 1].x == tree2[curr][2 * v + 2].x)
    {
        tree2[curr][v] = tree2[curr][2 * v + 2];
        tree4[curr][v] = tree4[curr][2 * v + 1];
    }
    else
    {
        tree2[curr][v] = min(tree2[curr][2 * v + 1], tree2[curr][2 * v + 2]);
        tree4[curr][v] = min(tree4[curr][2 * v + 1], tree4[curr][2 * v + 2]);
    }
}

vector<int> get(int l, int r, int curr = 30)
{
    if (curr == -1)
    {
        return vector<int> (31, 2);
    }
    vector<int> res(31, -1);
    Pr mx = get1(0, 0, n, curr, l, r), mn = get2(0, 0, n, curr, l, r), mx2 = get3(0, 0, n, curr, l, r), mn2 = get4(0, 0, n, curr, l, r);
   // cout << l << " " << r << " " << curr << " " << mx.first << " " << mx.second << " " << mn.first << " " << mn.second << "\n";
    if (mx.x == 0 || mn.x == 1)
    {
        res = get(l, r, curr - 1);
        res[curr] = 2;
        return res;
    }
    if (a[l] & (1 << curr))
    {
        if (mx2.y > mn2.y)
        {
            res[0] = -1;
            return res;
        }
    }
    else
    {
        if (mx.y < mn.y)
        {
            res[0] = -1;
            return res;
        }
    }
    int frst;
    if (a[l] & (1 << curr))
    {
        if (mx.y > mn.y)
        {
            res[0] = -1;
            return res;
        }
        res[curr] = 1;
        frst = mn2.y;
    }
    else
    {
        if (mx.y < mn.y)
        {
            res[0] = -1;
            return res;
        }
        res[curr] = 0;
        frst = mx.y;
    }
    vector<int> o = get(l, frst, curr - 1), s = get(frst, r, curr - 1);
    if (o[0] == -1 || s[0] == -1)
    {
        res[0] = -1;
        return res;
    }
    for (int i = 0; i < curr; i++)
    {
        if ((o[i] == 0 && s[i] == 1) || (o[i] == 1 && s[i] == 0))
        {
            res[0] = -1;
            return res;
        }
        if (o[i] == 2)
        {
            res[i] = s[i];
            continue;
        }
        if (s[i] == 2)
        {
            res[i] = o[i];
            continue;
        }
        if (o[i] == 1 && s[i] == 1) res[i] = 1;
        else res[i] = 0;
    }
    return res;
}

int ans()
{
    vector<int> all = get(0, n);
  /*  for (int i : all) cout << i << " ";
    cout << "\n"; */
    if (all[0] == -1) return -1;
    int res = 0;
    for (int i = 0; i <= 30; i++)
    {
        if (all[i] == 1)
        {
            res |= (1 << i);
        }
    }
    return res;
}

int main()
{
   // freopen("input.txt", "r", stdin);
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
    }
    for (int i = 0; i <= 30; i++)
    {
        build(0, 0, n, i);
    }
    cout << ans() << "\n";
    int q;
    cin >> q;
    for (int i = 0; i < q; i++)
    {
        int p, u;
        cin >> p >> u;
        --p;
        for (int i = 0; i <= 30; i++)
        {
            int nw;
            if (u & (1 << i)) nw = 1;
            else nw = 0;
            change(0, 0, n, i, p, nw);
        }
        a[p] = u;
        cout << ans() << "\n";
    }
    return 0;
}
