#include <bits/stdc++.h>


using namespace std;


#define int long long
#define pb push_back

struct Point {
	int x = 0, y = 0;
	int id;

	Point(int _x, int _y, int _id=-1) {
		x = _x;
		y = _y;
		id = _id;
	}

	Point() {}


	int operator^(Point other) {
		return x * other.y - other.x * y;
	}

	friend ostream& operator<<(ostream &os, const Point &p) {
		os << p.x << " " << p.y;
		return os;
	}
};


int n;
vector<Point> base_points;


bool in(const vector<int> &poly) {
	cout << "? " << poly.size();
	for (int i = 0; i < poly.size(); i++) {
		cout << ' ' << poly[i] + 1;
	}
	cout << endl;
	string resp;
	cin >> resp;
	return resp == "Yes";
}

int square_x2(Point a, Point b, Point c) {
	return abs(Point(b.x - a.x, b.y - a.y) ^ Point(c.x - a.x, c.y - a.y)); 
}

bool in_triangle(const vector<int> &tri, int pid) {
	vector<Point> tr = {
		base_points[tri[0]],
		base_points[tri[1]],
		base_points[tri[2]]
	};
	Point p = base_points[pid];
	return square_x2(tr[0], tr[1], p)
		+ square_x2(tr[1], tr[2], p)
		+ square_x2(tr[2], tr[0], p) == square_x2(tr[0], tr[1], tr[2]);
}


vector<Point> convex_hully() {
	int down = 0;
	for (int i = 0; i < n; i++) {
		if (make_pair(base_points[i].y, base_points[i].x) < make_pair(base_points[down].y, base_points[down].x)) {
			down = i;
		}
	}

	vector<Point> v;
	for (int i = 0; i < base_points.size(); i++) {
		if (i != down) {
			v.pb(base_points[i]);
		}
	}
	Point dp = base_points[down];
	sort(v.begin(), v.end(), [dp](Point a, Point b){
		return atan2(a.y - dp.y, a.x - dp.x) < atan2(b.y - dp.y, b.x - dp.x);
	});

	vector<Point> rez { dp, v[0] };

	for (int i = 1; i < v.size(); i++) {
		Point base = rez.back();
		Point v1 = rez[rez.size() - 2];
		Point v2 = v[i];
		v1.x -= base.x;
		v1.y -= base.y;
		v2.x -= base.x;
		v2.y -= base.y;

		while (rez.size() >= 2 && ((v1 ^ v2) > 0)) {
			rez.pop_back();
			if (rez.size() >= 2) {
				base = rez.back();
				v1 = rez[rez.size() - 2];
				v2 = v[i];
				v1.x -= base.x;
				v1.y -= base.y;
				v2.x -= base.x;
				v2.y -= base.y;
			}
		}

		rez.push_back(v[i]);
	}
	return rez;
}

signed main() {
	// freopen("input.txt", "r", stdin);
	srand(1337);

	// cout << in_triangle({Point(1, 1), Point(4, 4), Point(4, 1)}, Point(3, 2));
	// return 0;
	cin >> n;
	base_points.resize(n);
	
	for (int i = 0; i < n; i++) {
		int x, y;
		cin >> x >> y;
		base_points[i] = Point(x, y, i);
	}

	vector<Point> convex = convex_hully();

	// for (Point p : convex) {
		// cout << p.id << " ";
	// }
	// return 0;

	// cout << in_triangle({0, 2, 5}, 3) << endl;
	// return 0;

	int cnt_q;
	cin >> cnt_q;
	for (int i = 0; i < cnt_q; i++) {
		vector<int> triangle{0, 1, 2};
		
		for (int i = 1; i < convex.size() - 1; i++) {
			if (in({convex[0].id, convex[i].id, convex[i + 1].id})) {
				triangle = {convex[0].id, convex[i].id, convex[i + 1].id};
			}
		}

		// cout << triangle[0] << " " << triangle[1] << " " << triangle[2] << endl;
		unordered_set<int> potential;
		for (int i = 0; i < n; i++) {
			potential.insert(i);
		}

		while (true) {
			bool can = true;
			vector<int> invalids;
			for (int i : potential) {
				if (i != triangle[0] && i != triangle[1] && i != triangle[2]) {
					if (in_triangle(triangle, i)) {
						if (in({triangle[0], triangle[1], i})) {
							triangle = {triangle[0], triangle[1], i};
							can = false;
							break;
						}
						if (in({triangle[1], triangle[2], i})) {
							triangle = {triangle[1], triangle[2], i};
							can = false;
							break;
						}
						if (in({triangle[0], triangle[2], i})) {
							triangle = {triangle[0], triangle[2], i};
							can = false;
							break;
						}
					} else {
						invalids.pb(i);
					}
				}
			}
			if (can) break;
			for (int inv : invalids) {
				potential.erase(inv);
			}
		}
		cout << "! 3 " << (triangle[0] + 1) << " " << (triangle[1] + 1) << " " << (triangle[2] + 1) << endl;
	}

}