#include <bits/stdc++.h>

using namespace std;

#define pb push_back

struct Block {
	char type;
	int count;
	int start;

	Block(char _type, int _count, int _start) {
		type = _type;
		count = _count;
		start = _start;
	}

	tuple<int, int, char> to_tuple() {
		return make_tuple(start, count, type);
	}

	bool operator<(const Block &other) const {
		return start < other.start;
	}
};

vector<Block> get_groups(const string &s) {
	vector<Block> groups {Block(s[0], 1, 0)};
	for (int i = 1; i < s.size(); i++) {
		char c = s[i];
		if (groups.back().type == c) {
			groups.back().count++;
		} else {
			groups.pb(Block(s[i], 1, i));
		}
	}
	return groups;
}


bool can_make(const string &s, char e) {
	auto groups = get_groups(s);
	vector<Block> stack { groups[0] };
	for (int i = 1; i < groups.size(); i++) {
		Block _new = groups[i];
		stack.pb(_new);
		bool action = true;
		while (stack.size() >= 2 && action) {
			action = false;
			int prev = stack.size() - 1;
			int prev_two = stack.size() - 2;
			if (stack[prev].type == stack[prev_two].type) {
				stack[prev_two].count += stack[prev].count;
				stack.pop_back();
				action = true;
			} else if (stack[prev].type == e) {
				if (stack[prev].count > stack[prev_two].count) {
					Block temp = stack[prev];
					temp.count += stack[prev_two].count;
					stack.pop_back();
					stack.pop_back();
					stack.pb(temp);
					action = true;
				}
			} else if (stack[prev_two].type == e) {
				if (stack[prev_two].count > stack[prev].count) {
					stack[prev_two].count += stack[prev].count;
					stack.pop_back();
					action = true;
				}
			}
		}
	}
	for (auto block : stack) {
		if (block.type != e) {
			return false;
		}
	}
	return true;
}

bool query(const string &from, const string &to) {
	auto to_groups = get_groups(to);
	for (int bid = 0; bid < to_groups.size(); bid++) {
		auto block = to_groups[bid];
		if (bid < to_groups.size() - 1) {
			if (from[block.start + block.count - 1] != block.type) {
				return false;
			}
		}
		if (bid > 0) {
			if (from[block.start] != block.type) {
				return false;
			}
		}
		if (!can_make(string(from.begin() + block.start, from.begin() + block.start + block.count), block.type)) {
			return false;
		}
	}
	return true;
}


signed main() {
	// freopen("storage.in", "r", stdin);
	// freopen()
	// cout << can_make, ("++-+-", '+');
	// auto groups = get_groups("---++");
	// for (auto x : groups) {
		// cout << x.type << " " << x.count << " " << x.start << endl;
	// }
	// return 0;
	int n;
	cin >> n;
	for (int i = 0; i < n; i++) {
		string from, to;
		cin >> from >> to;
		if (query(from, to)) {
			cout << "Yes" << endl;
		} else {
			cout << "No" << endl;
		}
	}
}