#include <bits/stdc++.h>

#define int int64_t

using namespace std;

struct Vector
{
    int x, y;
    explicit Vector(int x = 0, int y = 0) : x(x), y(y) {}
    Vector operator - () const
    {
        return Vector(-x, -y);
    }
    int norm() const
    {
        return x * x + y * y;
    }
    bool operator < (const Vector &o) const
    {
        return x == o.x ? y < o.y : x < o.x;
    }
};

int cross_prod(Vector a, Vector b)
{
    return a.x * b.y - a.y * b.x;
}

Vector operator + (Vector a, Vector b)
{
    return Vector(a.x + b.x, a.y + b.y);
}

Vector operator - (Vector a, Vector b)
{
    return a + (-b);
}

bool operator == (Vector a, Vector b)
{
    return ((a.x == b.x) && (a.y == b.y));
}

Vector B;
bool comp(Vector a, Vector b)
{
    return (cross_prod(a - B, b - B) > 0);
}

vector<Vector> conv(vector<Vector> s)
{
    vector<Vector> ret(1, B);
    for (Vector v : s)
    {
        while (ret.size() > 1)
        {
            Vector v1 = v - ret.back();
            Vector v2 = ret.back() - ret[ret.size() - 2];
            if (cross_prod(v1, v2) < 0)
                break;
            ret.pop_back();
        }
        ret.push_back(v);
    }
    return ret;
}

int32_t main()
{
    vector<vector<int> > triangles;
    int n;
    cin >> n;
    map<Vector, int> idx;
    vector<Vector> arr(n);
    for (int i = 0; i < n; i++)
    {
        cin >> arr[i].x >> arr[i].y;
        idx[arr[i]] = i + 1;
    }
    sort(arr.begin(), arr.end());
    B = arr[0];
    //cerr << B.x << " " << B.y << "\n";
    //cerr << arr[1].x << " " << arr[1].y << "\n";
    //cerr << arr[2].x << " " << arr[2].y << "\n";
    vector<Vector> ch;
    ch.push_back(arr[1]);
    ch.push_back(arr[2]);
    if (!comp(ch[0], ch[1]))
        swap(ch[0], ch[1]);
    triangles.push_back({idx[B], idx[ch[0]], idx[ch[1]]});
    for (int i = 3; i < n; i++)
    {
        cerr << i << "\n";
        vector<Vector> nch;
        for (Vector v : ch)
            if (comp(v, arr[i]))
                nch.push_back(v);
        nch.push_back(arr[i]);
        for (Vector v : ch)
            if (!comp(v, arr[i]))
                nch.push_back(v);
        /*for (auto v : nch)
            cerr << v.x << " " << v.y << "\n";
        cerr << "v\n";*/
        nch = conv(nch);
        nch.erase(nch.begin());
        int L = 0, R = 0;
        for(;;L++)
            if (L + 1 == ch.size() || L + 1 == nch.size() || !(ch[L + 1] == nch[L + 1]))
                break;
        for(;;++R)
            if (L + 1 == ch.size() || L + 1 == nch.size() || !(ch[ch.size() - 1 - (R + 1)] == nch[nch.size() - 1 - (R + 1)]))
                break;
        R = ch.size() - R - 1;
        //cerr << "LR : " << L << " " << R << "\n";
        for (int j = L; j < R; j++)
            triangles.push_back({idx[arr[i]], idx[ch[j]], idx[ch[j + 1]]});
        ch = nch;
        /*for (auto v : ch)
        {

            cerr << v.x << " " << v.y << "\n";
        }
        cerr << "------\n";*/
    }
    int m;
    cin >> m;
    for (int i = 0; i < m; i++)
    {
        vector<int> out;
        for (auto a : triangles)
        {
            for (auto V : a)
                cout << V << " ";
            cout << endl;
            string ans;
            cin >> ans;
            if (ans == "Yes")
                out = a;
        }
        cout << "!";
        for (int i : out)
            cout << " " << i;
        cout << endl;
    }
    return 0;
}
