#include <bits/stdc++.h>

using namespace std;

struct Vec {
    int ind;
    long long x, y;

    Vec() {}

    Vec(long long _x, long long _y) {
        x = _x;
        y = _y;
    }
};

inline istream& operator>>(istream& is, Vec& a) {
    is >> a.x >> a.y;
    return is;
}

inline ostream& operator<<(ostream& os, Vec a) {
    os << a.x << ' ' << a.y;
    return os;
}

inline bool operator<(Vec const& a, Vec const& b) {
    return (a.x < b.x || (a.x == b.x && a.y < b.y));
}

inline bool cmp(Vec const& a, Vec const& b) {
    return (a.x * b.y - a.y * b.x < 0ll);
}

inline bool isIn(Vec const& a, Vec const& b, Vec const& c) {
    cout << "? 3 " << a.ind << ' ' << b.ind << ' ' << c.ind << endl;
    string t;
    cin >> t;
    return (t == "Yes");
}

inline void setAns(Vec const& a, Vec const& b, Vec const& c) {
    cout << "! 3 " << a.ind << ' ' << b.ind << ' ' << c.ind << endl;
}

inline long long operator%(Vec a, Vec b) {
    return  (a.x * b.y - a.y * b.x);
}

inline Vec operator-(Vec a, Vec b) {
    return  Vec(a.x - b.x, a.y - b.y);
}


int main() {

    int n;
    cin >> n;
    vector<Vec> a(n);
    for (Vec& i : a)
        cin >> i;

    for (int i = 0; i < n; i++)
        a[i].ind = i + 1;

    for (int i = 0; i < n; i++) {
        if (a[i] < a[0]) {
            Vec t = a[i];
            a[i] = a[0];
            a[0] = t;
        }
    }

    for (int i = 1; i < n; i++) {
        a[i].x -= a[0].x;
        a[i].y -= a[0].y;
    }

    sort(a.begin() + 1, a.end(), cmp);

    for (int i = 1; i < n; i++) {
        a[i].x += a[0].x;
        a[i].y += a[0].y;
    }

    vector<Vec> convex;
    convex.push_back(a[0]);
    convex.push_back(a[1]);
    for (int i = 2; i < n; i++) {
        convex.push_back(a[i]);
        int m = (int)convex.size();
        while (m > 2 && (convex[m - 1] - convex[m - 3]) % (convex[m - 2] - convex[m - 3]) < 0ll) {
            Vec t = convex.back();
            convex.pop_back();
            convex.pop_back();
            convex.push_back(t);
            m = (int)convex.size();
        }
    }

    //for (auto i : convex)
    //    cout << i.ind << ' ';
    //cout << endl;

    int q;
    cin >> q;
    for (int T = 0; T < q; T++) {

        int l = 2, r = (int)convex.size() - 1;

        if (isIn(convex[0], convex[1], convex[l])) {
            r = l;
        } else {
            while (r - l > 1) {
                int m = (l + r) / 2;

                cout << "? " << m + 1 << ' ';
                for (int i = 0; i <= m; i++) {
                    cout << convex[i].ind;

                    if (i == m)
                        cout << endl;
                    else
                        cout << ' ';
                }

                string tmp;
                cin >> tmp;

                if (tmp == "Yes")
                    r = m;
                else
                    l = m;
            }
        }

        int tmpL = r - 1;

        //cerr << 1 << endl;

        for (int i = 0; i < n; i++)
            if (a[i].ind == convex[r].ind) {
                Vec t = a[i];
                a[i] = a[0];
                a[0] = t;
            }

        for (int i = 1; i < n; i++) {
            a[i].x -= a[0].x;
            a[i].y -= a[0].y;
        }

        sort(a.begin() + 1, a.end(), cmp);

        for (int i = 1; i < n; i++) {
            a[i].x += a[0].x;
            a[i].y += a[0].y;
        }

        for (int i = 1; i + 1 < n; i++)
            if (isIn(a[0], a[i], a[i + 1])) {
                setAns(a[0], a[i], a[i + 1]);
                break;
            }

        /*l = 2, r = n;

        if (isIn(a[0], a[1], a[l])) {
            setAns(a[0], a[1], a[2]);
        } else {
            while (r - l > 1) {
                int m = (l + r) / 2;

                if (isIn(a[0], a[1], a[m]))
                    r = m;
                else
                    l = m;
            }
            if (isIn(a[0], a[l], a[r])) {
                setAns(a[0], a[l], a[r]);
                continue;
            }
        }*/

        //----------------------------------------------------------

        //cerr << 2 << endl;

        for (int i = 0; i < n; i++)
            if (a[i].ind == convex[tmpL].ind) {
                Vec t = a[i];
                a[i] = a[0];
                a[0] = t;
            }

        for (int i = 1; i < n; i++) {
            a[i].x -= a[0].x;
            a[i].y -= a[0].y;
        }

        sort(a.begin() + 1, a.end(), cmp);

        for (int i = 1; i < n; i++) {
            a[i].x += a[0].x;
            a[i].y += a[0].y;
        }

        for (int i = 1; i + 1 < n; i++)
            if (isIn(a[0], a[i], a[i + 1])) {
                setAns(a[0], a[i], a[i + 1]);
                break;
            }

        /*l = 2, r = n;

        if (isIn(a[0], a[1], a[l])) {
            setAns(a[0], a[1], a[2]);
        } else {
            while (r - l > 1) {
                int m = (l + r) / 2;

                if (isIn(a[0], a[1], a[m]))
                    r = m;
                else
                    l = m;
            }
            setAns(a[0], a[l], a[r]);
        }*/

    }

    return 0;
}