#include <bits/stdc++.h>

using namespace std;

typedef long long int64;

int64 HASH = 516875648ll;
int64 MOD = 10000009ll;
const int N = 10000009;

int s[N];

inline void add(int64 val) {
    int64 _code = (val * HASH) % MOD;
    int code = (int)_code;
    while (s[code] != -1 && s[code] != val)
        code = (code + 1) % N;
    s[code] = (int)val;
}

inline bool contains(int64 val) {
    int64 _code = (val * HASH) % MOD;
    int code = (int)_code;
    while (s[code] != -1 && s[code] != val)
        code = (code + 1) % N;
    return (s[code] == val);
}

inline void clearSet(int64 val) {
    int64 _code = (val * HASH) % MOD;
    int code = (int)_code;
    while (s[code] != -1) {
        s[code] = -1;
        code = (code + 1) % N;
    }
}

int main() {
    ios_base::sync_with_stdio(false);

    memset(s, -1, sizeof(s));

    int n, m;
    cin >> n >> m;
    vector<int> a(n), x(n), b(m), y(m);
    for (int& i : a)
        cin >> i;
    for (int& i : x)
        cin >> i;
    for (int& i : b)
        cin >> i;
    for (int& i : y)
        cin >> i;


    int64 ans = 0ll;
    int l1, r1, l2, r2;

    for (int l = 0; l < n; l++)
        for (int r = l; r < n; r++) {
            int64 sum1 = 0ll;
            for (int i = l; i <= r; i++)
                add(a[i]), sum1 += 1ll * x[i];

            int64 sum2 = 0ll;
            int j = 0;
            for (int i = 0; i < m; i++)
                if (contains(b[i])) {
                    j = i + 1;
                    sum2 = 0ll;
                } else {
                    sum2 += 1ll * y[i];

                    if (sum1 + sum2 > ans) {
                        ans = sum1 + sum2;
                        l1 = l;
                        r1 = r;
                        l2 = j;
                        r2 = i;
                    }
                }

            for (int i = l; i <= r; i++)
                clearSet(a[i]);
        }

    cout << ans << endl << l1 + 1 << ' ' << r1 + 1 << endl << l2 + 1 << ' ' << r2 + 1 << endl;

    return 0;
}