#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const long long MAXN = 200005;
const long long INF = 1500000000;

pair <long long, long long> can[MAXN];
vector <long long> tm;
vector < pair <long long, long long> > leftgo, rightgo;

int main()
{
    ios_base::sync_with_stdio(false);

    long long n;
    cin >> n;
    tm.resize(n + 1);
    for(long long i = 1; i <= n; i++) cin >> tm[i];
    for(long long i = 1; i < n; i++) {
        cin >> can[i].first >> can[i].second;
    }
    leftgo.resize(n + 1);
    rightgo.resize(n + 1);

    //if(n > 5) cout << 1 / 0;
    bool teq = true;
    for(int i = 2; i <= n; i++) if(tm[i] != tm[i - 1]) teq = false;
    long long maxr = 0;
    for(int i = 1; i < n; i++) maxr = max(maxr, can[i].second);

    if(n < 800 && maxr <= 600)
    {
        for(int i = 1; i <= n; i++) {
            bool found = false;
            for(int j = 0; j <= 600; j++) {
                bool ok = true;
                //to left
                int now = j;
                for(int k = i - 1; k >= 1; k--) {
                    if(now >= can[k].first && now <= can[k].second) continue;
                    if(now < can[k].first && now + tm[k + 1] >= can[k].first) {
                        now = can[k].first;
                        continue;
                    }
                    ok = false;
                    break;
                }
                //to right
                now = j;
                for(int k = i + 1; k <= n; k++) {
                    if(now >= can[k - 1].first && now <= can[k - 1].second) continue;
                    if(now < can[k - 1].first && now + tm[k - 1] >= can[k - 1].first) {
                        now = can[k - 1].first;
                        continue;
                    }
                    ok = false;
                    break;
                }
                //check
                if(ok) {
                    cout << j << endl;
                    found = true;
                    break;
                }
            }
            if(!found) {
                cout << -1 << endl;
            }
        }
        return 0;
    }

    rightgo[n] = {0, INF};
    for(long long i = n - 1; i >= 1; i--) {
        rightgo[i] = {0, INF};
        rightgo[i].first = max(can[i].first - tm[i], rightgo[i + 1].first);
        rightgo[i].second = min(can[i].second, rightgo[i + 1].second);
        if(can[i].first > rightgo[i + 1].second) rightgo[i] = {INF, 0};
        if(can[i].second < rightgo[i + 1].first) rightgo[i] = {INF, 0};
    }

    leftgo[1] = {0, INF};
    for(long long i = 2; i <= n; i++) {
        leftgo[i] = {0, INF};
        leftgo[i].first = max(can[i - 1].first - tm[i], leftgo[i - 1].first);
        leftgo[i].second = min(can[i - 1].second, leftgo[i - 1].second);
        if(can[i - 1].first > leftgo[i - 1].second) leftgo[i] = {INF, 0};
        if(can[i - 1].second < leftgo[i - 1].first) leftgo[i] = {INF, 0};
    }

    /*cout << "Debug" << endl;
    for(long long i = 1; i <= n; i++) cout << rightgo[i].first << " " << rightgo[i].second << endl;
    cout << "Debug" << endl;
    for(long long i = 1; i <= n; i++) cout << leftgo[i].first << " " << leftgo[i].second << endl;*/

    pair <long long, long long> ans;
    for(long long i = 1; i <= n; i++) {
        ans.first = max(leftgo[i].first, rightgo[i].first);
        ans.second = min(leftgo[i].second, rightgo[i].second);
        if(ans.second < ans.first) cout << -1 << endl;
        else cout << ans.first << endl;
    }
    return 0;
}
