﻿#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#pragma comment(linker,"/STACK:1289178987623328")
using namespace std;
typedef long long ll;
void solve();
int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout.precision(30);
	solve();
}
struct node {
	int prior;
	ll val;
	int cnt;
	node *l, *r;
	bool rev;
	node(ll val) {
		this->l = this->r = NULL;
		this->cnt = 1;
		this->val = val;
		this->prior = rand();
	}
};
void push(node * t) {
	if (t == NULL || t->rev == 0)
		return;
	swap(t->l, t->r);
	if (t->l != NULL)
		t->l->rev ^= 1;
	if (t->r != NULL)
		t->r->rev ^= 1;
	t->rev = 0;
}
int cnt(node * t) {
	return (t == NULL ? 0: t->cnt);
}
void update(node * t) {
	if (!t)return;
	t->cnt = 1 + cnt(t->l) + cnt(t->r);
}
void split(node *t, node *&l, node *&r, int key,int add = 0) {
	if (t == NULL)
		return void(l = r = NULL);
	push(t);
	int cur = add + cnt(t->l);
	if (key <= cur)
		split(t->l, l, t->l, key, add), r = t;
	else
		split(t->r, t->r, r, key, add + 1 + cnt(t->l)), l = t;
	update(t);
}
void merge(node *&t, node *l, node *r) {
	push(l);
	push(r);
	if (!l)t = r;
	else if (!r)t = l;
	else if (l->prior > r->prior)
		merge(l->r, l->r, r), t = l;
	else
		merge(r->l, l, r->l), t = r;
	update(t);
}
node * root = NULL;
void solve() {
	ll n;
	while (cin >> n) {
		merge(root, root, new node(n));
	}
	root->rev = 1;
	while (root != NULL) {
		node *t1;
		split(root, t1, root, 1);
		cout << t1->val << " ";
	}
	cout << endl;
}