#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cstring>
#include <queue>
#include <string>
#include <cassert>
#include <bitset>

using namespace std;

int solve();

typedef long long ll;

int main() {
#ifdef ROII
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	solve();
}

struct edge { int to, len, num; };

vector<vector<edge> > E;
vector<vector<pair<ll, ll> > > Q, T;

const int dd = (int)1e6 + 1;
pair<ll, ll> dist[dd];
pair<ll, ll> cur[dd];
int used[dd];

bool cmp(pair<ll, ll> a, pair<ll, ll> b) {
	return a.first < b.first || a.first == b.first && a.second > b.second;
}

int solve() {

	int n, m;
	scanf("%d %d", &n, &m);

	E.resize(n);
	Q.resize(n);
	T.resize(m);

	for (int i = 0; i < m; i++) {
		int x;
		scanf("%d", &x);

		int v;
		scanf("%d", &v);
		v--;

		T[i].push_back({ v, -1 });

		for (int j = 0; j < x; j++) {
			int t, to;
			scanf("%d %d", &t, &to);
			to--;

			T[i].push_back({ to, t });

			Q[v].push_back({ i, j });
			E[v].push_back({ to, t, i });
			v = to;
		}
	}

	fill(dist, dist + n, make_pair((int)1e9, -1));
	dist[0] = { 0, 0 };

	while (1) {
		int ind = -1;
		for (int i = 0; i < n; i++) if (!used[i]) {
			if (ind == -1 || cmp(dist[i], dist[ind]))
				ind = i;
		}
		if (ind == -1) break;

		used[ind] = 1;

		for (auto c : Q[ind]) {
			ll cur = 0;
			for (int j = c.second + 1; j < (int)T[c.first].size(); j++) {
				cur += T[c.first][j].second;

				pair<ll, ll> t = { dist[ind].first + cur, dist[ind].second + cur * cur };

				if (cmp(t, dist[T[c.first][j].first])) {
					dist[T[c.first][j].first] = t;
				}
			}

		}
	}
	printf("%lld %lld\n", dist[n - 1].first, dist[n - 1].second);
	return 0;
}