#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <deque>
#include <list>
using namespace std;

struct frag
{
  int siz;
  char sym;

  frag(int siz = 0, char sym = '-') : siz(siz), sym(sym)
  {
  }
};

bool cantoone(string & s, int l, int r, char sym)
{
  int prev = l;
  list<frag> frags;
  frags.push_back(frag(1, s[l]));
  for (int i = l + 1; i <= r; i++)
  {
    if (s[i] == s[prev])
      frags.back().siz++;
    else
      prev = i, frags.push_back(frag(1, s[i]));
  }
  bool flag = false;
  for (auto i = frags.begin(); i != frags.end() || flag; ++i)
  {
    if (flag)
      flag = false, --i;
    if (i->sym != sym)
      continue;
    if (i != frags.begin())
    {
      auto prev = i;
      prev--;
      if (prev->siz < i->siz || prev->sym == i->sym)
      {
        i->siz += prev->siz;
        frags.erase(prev);
        flag = true;
        continue;
      }
    }
    auto next = i;
    ++next;
    if (next != frags.end())
    {
      if (next->siz < i->siz || next->sym == i->sym)
      {
        i->siz += next->siz;
        frags.erase(next);
        flag = true;
        continue;
      }
    }
  }
  if (frags.size() == 1 && frags.front().sym == sym)
    return true;
  else
    return false;
}

int main(void)
{
  int q;
  cin >> q;

  string s, t;

  for (int i = 0; i < q; i++)
  {
    cin >> s >> t;
    int pos = 0, prev = 0;
    int flag = true;
    while (pos < s.size())
    {
      while (pos < s.size() && s[pos] == s[prev])
        if (t[pos] != t[prev])
        {
          flag = false;
          break;
        }
        else
          pos++;
      prev = pos;
    }
    if (!flag)
    {
      cout << "No" << endl;
      continue;
    }
    pos = 0;
    prev = 0;
    flag = true;
    while (pos < s.size())
    {
      while (pos < s.size() && t[pos] == t[prev])
        pos++;
      if (prev != 0 && t[prev] != s[prev] && t[prev - 1] != s[prev - 1])
      {
        flag = false;
        break;
      }
      if (!cantoone(s, prev, pos - 1, t[prev]))
      {
        flag = false;
        break;
      }
      prev = pos;
    }
    if (flag)
      cout << "Yes" << endl;
    else
      cout << "No" << endl;
  }

  return 0;
}