#include <bits/stdc++.h>

#define f first
#define s second
#define pb push_back
#define len(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define forn(i, n) for (int i = 0; i < n; ++i)
#define int long long

using namespace std;

const double pi = acos(-1);
double EPS = 1e-7;

struct Point {
    int x, y;
    Point() = default;
    Point(int x, int y) : x(x), y(y) {}
};

struct Vector {
    int x, y;
    Vector() = default;
    Vector(int x, int y) : x(x), y(y) {}
    Vector(Point a, Point b) : x(b.x - a.x), y(b.y - a.y) {}
    int operator^(Vector b) { // скалярное
        return x * b.x + y * b.y;
    }
    int operator*(Vector b) { // векторное
        return x * b.y - y * b.x;
    }
};

double angle(Vector a, Vector b) {
    return atan2(a * b, a ^ b);
}

vector<Point> a;

double square(int i, int j, int k) {
    return fabs(Vector(a[i], a[j]) * Vector(a[i], a[k]));
}

struct Triangle {
    int i, j, k;
    Triangle() = default;
    Triangle(int i, int j, int k) : i(i), j(j), k(k) {}
    bool operator<(Triangle a) {
        return square(i, j, k) > square(a.i, a.j, a.k);
    }

};

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    //freopen(".in", "r", stdin);
    int n;
    cin >> n;
    a.resize(n);
    forn(i, n) cin >> a[i].x >> a[i].y;
    vector<Triangle> tr;
    forn(i, n) {
        forn(j, i) {
            forn(k, j) {
                bool fl = 1;
                forn(l, n) {
                    if (l == i || l == j || l == k) continue;
                    double an = 0;
                    an += fabs(angle(Vector(a[l], a[i]), Vector(a[l], a[k])));
                    an += fabs(angle(Vector(a[l], a[k]), Vector(a[l], a[j])));
                    an += fabs(angle(Vector(a[l], a[j]), Vector(a[l], a[i])));
                    //cout << l + 1 << ' ' << an << endl;
                    if (fabs(an - 2 * pi) < EPS) {
                        fl = 0;
                        break;
                    }
                }
                if (fl) {
                    //cout << i + 1 << ' ' << j + 1 << ' ' << k + 1 << endl;
                    tr.pb({i + 1, j + 1, k + 1});
                }
            }
        }
    }
    sort(all(tr));
    int q;
    cin >> q;
    forn(i, q) {
         for (auto tmp : tr) {
            cout << "? 3 " << tmp.i << ' ' << tmp.j << ' ' << tmp.k << endl;
            string s1;
            cin >> s1;
            if (s1 == "Yes") {
                cout << "! 3 " << tmp.i << ' ' << tmp.j << ' ' << tmp.k << endl;
                break;
            }
        }
    }
    return 0;
}
