#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = (int)1e6;

int n, q;
int data[N];
int tree[4 * N][2];
bool ok[4 * N];

inline void update(const int &i, const int &v) {
    if (i == 0) {
        return;
    }

    tree[v][0] = 0;
    tree[v][1] = 0;

    for (int j = 29; j >= 0; --j) {
        if ((data[i - 1] & (1 << j)) != (data[i] & (1 << j))) {
            if ((data[i - 1] & (1 << j)) != 0) {
                tree[v][0] += 1 << j;
            } else {
                tree[v][1] += 1 << j;
            }

            return;
        }
    }
}

inline void build_tree(const int v, const int l, const int r) {
    ok[v] = 0;
    if (r - l == 1) {
        update(l, v);
        return;
    }

    int m = (l + r) >> 1;
    build_tree(v * 2, l, m);
    build_tree(v * 2 + 1, m, r);

    if (ok[v * 2] || ok[v * 2 + 1]) {
        ok[v] = 1;
        return;
    }

    tree[v][0] = tree[v * 2][0] | tree[v * 2 + 1][0];
    tree[v][1] = tree[v * 2][1] | tree[v * 2 + 1][1];

    if ((tree[v][0] & tree[v][1]) != 0) {
        ok[v] = 1;
    }
}

inline void update_tree(const int v, const int l, const int r, const int pos) {
    if (pos < l || pos >= r) {
        return;
    }

    ok[v] = 0;
    if (r - l == 1) {
        update(l, v);
        return;
    }

    int m = (l + r) >> 1;
    update_tree(v * 2, l, m, pos);
    update_tree(v * 2 + 1, m, r, pos);

    if (ok[v * 2] || ok[v * 2 + 1]) {
        ok[v] = 1;
        return;
    }

    tree[v][0] = tree[v * 2][0] | tree[v * 2 + 1][0];
    tree[v][1] = tree[v * 2][1] | tree[v * 2 + 1][1];

    if ((tree[v][0] & tree[v][1]) != 0) {
        ok[v] = 1;
    }
}

inline int res() {
    if (ok[1]) {
        return -1;
    }

    return tree[1][0];
}

int main() {
    ios::sync_with_stdio(false);

    //freopen("order.in", "r", stdin);
    //freopen("order.out", "w", stdout);

    scanf("%d", &n);
    for (int i = 0; i < n; ++i) {
        scanf("%d", &data[i]);
    }

    build_tree(1, 0, n);
    //watch_tree(1, 0, n);
    printf("%d\n", res());

    scanf("%d", &q);
    int a, b;
    for (int i = 0; i < q; ++i) {
        scanf("%d%d", &a, &b);
        --a;
        data[a] = b;
        update_tree(1, 0, n, a);
        update_tree(1, 0, n, a + 1);

        //watch_tree(1, 0, n);

        printf("%d\n", res());
    }

    return 0;
}
