#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = (int)1e6;

int n, q;
int data[N];
int tree[4 * N][31];
bool ok[4 * N];

inline void update(const int &i, const int &v) {
    if (i == 0) {
        return;
    }

    for (int j = 30; j >= 0; --j) {
        tree[v][j] = 0;
        if ((data[i - 1] & (1 << j)) != (data[i] & (1 << j))) {
            if ((data[i - 1] & (1 << j)) != 0) {
                tree[v][j] = 1;
            } else {
                tree[v][j] = -1;
            }

            for (int k = j - 1; k >= 0; --k) {
                tree[v][k] = 0;
            }

            return;
        }
    }
}

inline void build_tree(int v, int l, int r) {
    ok[v] = 0;
    if (r - l == 1) {
        update(l, v);
        return;
    }

    int m = (l + r) >> 1;
    build_tree(v * 2, l, m);
    build_tree(v * 2 + 1, m, r);

    if (ok[v * 2] || ok[v * 2 + 1]) {
        ok[v] = 1;
        return;
    }

    for (int j = 30; j >= 0; --j) {
        tree[v][j] = 0;
        if (tree[v * 2][j] == 1 && tree[v * 2 + 1][j] == -1 ||
            tree[v * 2][j] == -1 && tree[v * 2 + 1][j] == 1) {
            ok[v] = 1;
            return;
        } else {
            if (tree[v * 2][j] != 0) {
                tree[v][j] = tree[v * 2][j];
            } else {
                tree[v][j] = tree[v * 2 + 1][j];
            }
        }
    }
}

inline void update_tree(int v, int l, int r, int &pos) {
    if (pos < l || pos >= r) {
        return;
    }

    ok[v] = 0;
    if (r - l == 1) {
        update(l, v);
        return;
    }

    int m = (l + r) >> 1;
    update_tree(v * 2, l, m, pos);
    update_tree(v * 2 + 1, m, r, pos);

    if (ok[v * 2] || ok[v * 2 + 1]) {
        ok[v] = 1;
        return;
    }

    for (int j = 30; j >= 0; --j) {
        tree[v][j] = 0;
        if (tree[v * 2][j] == 1 && tree[v * 2 + 1][j] == -1 ||
            tree[v * 2][j] == -1 && tree[v * 2 + 1][j] == 1) {
            ok[v] = 1;
            return;
        } else {
            if (tree[v * 2][j] != 0) {
                tree[v][j] = tree[v * 2][j];
            } else {
                tree[v][j] = tree[v * 2 + 1][j];
            }
        }
    }
}

inline int res() {
    if (ok[1]) {
        return -1;
    }

    int mask = 0;
    for (int j = 30; j >= 0; --j) {
        mask += (tree[1][j] == 1 ? (1 << j) : 0);
    }

    return mask;
}

inline void watch_tree(int v, int l, int r) {
    cout << v << ": " << (ok[v] ? 1 : 0)  << endl;
    for (int j = 0; j < 31; ++j) {
        cout << tree[v][j] << " ";
    }
    cout << endl;

    if (r - l == 1) {
        return;
    }

    int m = (l + r) >> 1;
    watch_tree(v * 2, l, m);
    watch_tree(v * 2 + 1, m, r);
}

int main() {
    scanf("%d", &n);
    for (int i = 0; i < n; ++i) {
        scanf("%d", &data[i]);
    }

    build_tree(1, 0, n);
    //watch_tree(1, 0, n);
    printf("%d\n", res());

    scanf("%d", &q);
    int a, b;
    for (int i = 0; i < q; ++i) {
        scanf("%d%d", &a, &b);
        --a;
        data[a] = b;
        update_tree(1, 0, n, a);
        update_tree(1, 0, n, a + 1);

        //watch_tree(1, 0, n);

        printf("%d\n", res());
    }

    return 0;
}
