#include <iostream>
#include <cstring>
#include <vector>

using namespace std;

int sizeOf(pair< pair<int, int>, bool > p) {
    return p.first.second - p.first.first + 1;
}

bool check(string s1, string s2) {
    if (s1.size() != s2.size()) return false;
    int n = s1.size();
    vector< pair< pair<int, int>, bool > > segments;
    for (int i = 0; i < n; i++) {
        int left = i;
        while (i < n && s1[i] == s1[left]) i++;
        i--;
        int right = i;
        segments.push_back( make_pair(make_pair(left, right), s1[i] == '+') );
    }
    #define left first.first
    #define right first.second

    vector< pair< pair<int, int>, bool > > updated_segments;

    for (int i = 0; i < segments.size(); i++) {

        updated_segments.push_back(segments[i]);

        while (updated_segments.size() >= 2) {
            int id = updated_segments.size() - 1;
            if (updated_segments[id].second == updated_segments[id - 1].second) {
                auto p = updated_segments[id];
                auto p1 = updated_segments[id - 1];
                updated_segments.pop_back();
                updated_segments.pop_back();
                updated_segments.push_back(make_pair(make_pair(p1.left, p.right), p.second));
            } else if (updated_segments[id].second && sizeOf(updated_segments[id]) > sizeOf(updated_segments[id - 1])) {
                auto p = updated_segments[id];
                auto p1 = updated_segments[id - 1];
                updated_segments.pop_back();
                updated_segments.pop_back();
                updated_segments.push_back(make_pair(make_pair(p1.left, p.right), true));
            } else if (updated_segments[id - 1].second && sizeOf(updated_segments[id]) < sizeOf(updated_segments[id - 1])) {
                auto p = updated_segments[id];
                auto p1 = updated_segments[id - 1];
                updated_segments.pop_back();
                updated_segments.pop_back();
                updated_segments.push_back(make_pair(make_pair(p1.left, p.right), true));
            } else {
                break;
            }
        }
    }


    for (int i = 0; i < updated_segments.size(); i++)
        if (!updated_segments[i].second) return false;

    return true;
}

int main() {
    int q = 0;
    cin >> q;
    for (int i = 0; i < q; i++) {

        string s1, s2;
        cin >> s1 >> s2;

        cout << (check(s1, s2) ? "Yes" : "No") << '\n';
    }
    cout.flush();
    return 0;
}
