#include <bits/stdc++.h>
using namespace std;

const int INF = 1e9 + 1;

struct Point
{
    long long x, y;
    int ind;
    Point(long long _x, long long _y, int _ind = -1): x(_x), y(_y), ind(_ind) {}
    operator <(const Point &a) const
    {
        return x < a.x || (x == a.x && y < a.y);
    }
    Point operator -(const Point &a) const
    {
        return {x - a.x, y - a.y, -1};
    }
    long long vp(const Point &a)
    {
        return x * a.y - y * a.x;
    }
    long long len2()
    {
        return x * x + y * y;
    }
};

struct Triangle
{
    int a, b, c;
    Triangle(const Point &a, const Point &b, const Point &c): a(a.ind), b(b.ind), c(c.ind) {}
};

vector<Point> p;


bool check(const Triangle &a)
{
    cout << "? 3 " << a.a + 1 << ' ' << a.b + 1 << ' ' << a.c + 1 << endl;
    string str;
    cin >> str;
    return str == "Yes";
}

void answer(const Triangle &a)
{
    cout << "! 3 " << a.a + 1 << ' ' << a.b + 1 << ' ' << a.c + 1 << endl;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        int x, y;
        cin >> x >> y;
        p.push_back({x, y, i});
    }
    vector<Triangle> tria;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < i; j++)
            for (int k = 0; k < j; k++)
            {
                bool bl = true;
                for (int L = 0; L < n && bl; L++)
                {
                    if (L != i && L != j && L != k)
                    {
                        int cnt = 0;
                        long long x1 = p[i].x, y1 = p[i].y, y2 = p[j].y, x2 = p[j].x;
                        if (y1 > y2)
                        {
                            swap(y2, y1);
                            swap(x2, x1);
                        }
                        if (y1 != y2 && y1 < p[L].y && p[L].y <= y2 && (Point(x2, y2) - Point(x1, y1)).vp(p[L] - Point(x1, y1)) >= 0)
                            cnt++;

                        x1 = p[i].x, y1 = p[i].y, y2 = p[k].y, x2 = p[k].x;
                        if (y1 > y2)
                        {
                            swap(y2, y1);
                            swap(x2, x1);
                        }
                        if (y1 != y2 && y1 < p[L].y && p[L].y <= y2 && (Point(x2, y2) - Point(x1, y1)).vp(p[L] - Point(x1, y1)) >= 0)
                            cnt++;

                        x1 = p[j].x, y1 = p[j].y, y2 = p[k].y, x2 = p[k].x;
                        if (y1 > y2)
                        {
                            swap(y2, y1);
                            swap(x2, x1);
                        }
                        if (y1 != y2 && y1 < p[L].y && p[L].y <= y2 && (Point(x2, y2) - Point(x1, y1)).vp(p[L] - Point(x1, y1)) >= 0)
                            cnt++;

                        if (cnt & 1)
                            bl = false;
                    }
                }
                if (bl)
                {
                    tria.push_back({p[i], p[j], p[k]});
                }
            }
    int q;
    cin >> q;
    for (int test = 0; test < q; test++)
    {
        random_shuffle(tria.begin(), tria.end());
        for (Triangle elem: tria)
        {
            if (check(elem))
            {
                answer(elem);
                break;
            }
        }
    }
}
/*
6
3 0
0 2
2 4
4 2
5 5
6 1
*/
