#include <bits/stdc++.h>

using namespace std;

bool get_bit(int mask, int i) {
    return (mask & (1 << i)) > 0;
}

int n;
vector<int> b;

struct fenwick_tree {
    vector<int> t;
    int n_;

    fenwick_tree() {
        n_ = 0;
    }

    fenwick_tree(vector<int>& a) {
        n_ = a.size();
        t.assign(n, 0);
        for (int i = 0; i < n; i++) {
            change(i, a[i]);
        }
    }

    int on_pref(int i) {
        int sum = 0;
        for (; i >= 0; i = (i & (i + 1)) - 1) {
            sum += t[i];
        }
        return sum;
    }

    int sum(int l, int r) {
        return on_pref(r) - on_pref(l - 1);
    }

    void change(int i, int x) {
        int cur = sum(i, i);
        int add = 0;
        if (cur == x) {
            return;
        } else if (cur == 0 && x == 1) {
            add = 1;
        } else if (cur == 1 && x == 0) {
            add = -1;
        }
        for (; i < n_; i = (i | (i + 1))) {
            t[i] += add;
        }
    }
};

vector<fenwick_tree> a;

bool get_ans(int l, int r, int lev) {
    if (lev == -1) {
        return true;
    }
    int sum = a[lev].sum(l, r);
    if (sum == 0 || sum == r - l + 1) {
        bool kek = get_ans(l, r, lev - 1);
        if (!kek) return false;
        return true;
    }
    if (a[lev].sum(l, l) == 1) {
        int bl = l;
        int br = r + 1;
        while (bl < br) {
            int bm = (bl + br) / 2;
            sum = a[lev].sum(l, bm);
            if (sum == bm - l + 1) {
                bl = bm + 1;
            } else {
                br = bm;
            }
        }
        bl--;
        if (a[lev].sum(bl + 1, r) != 0) {
            b[lev] = -1;
            return false;
        }
        bool kekl = get_ans(l, bl, lev - 1);
        bool kekr = get_ans(bl + 1, r, lev - 1);
        if (!kekl || !kekr) {
            return false;
        }
        if (b[lev] < 1) {
            b[lev] = -1;
            return false;
        } else if (b[lev] == 2) {
            b[lev] = 1;
        }
    } else {
        int bl = l;
        int br = r + 1;
        while (bl < br) {
            int bm = (bl + br) / 2;
            sum = a[lev].sum(l, bm);
            if (sum == 0) {
                bl = bm + 1;
            } else {
                br = bm;
            }
        }
        bl--;
        if (a[lev].sum(bl + 1, r) != r - bl) {
            b[lev] = -1;
            return false;
        }
        bool kekl = get_ans(l, bl, lev - 1);
        bool kekr = get_ans(bl + 1, r, lev - 1);
        if (!kekl || !kekr) {
            return false;
        }
        if (b[lev] == 1 || b[lev] == -1) {
            b[lev] = -1;
            return false;
        } else if (b[lev] == 2) {
            b[lev] = 0;
        }
    }
    return true;
}

int get_b() {
    b.assign(33, 2);
    get_ans(0, n - 1, 31);
    int ans = 0;
    for (int i = 31; i >= 0; i--) {
        if (b[i] == 2 || b[i] == 0) {
            continue;
        } else if (b[i] == -1) {
            return -1;
        } else if (b[i] == 1) {
            ans += (1ll << i);
        }
    }
    return ans;
}

main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    vector<int> aa(n);
    b.assign(32, 0);
    int num = 0;
    vector<vector<int>> vs(32, vector<int>(n, 0));
    for (int i = 0; i < n; i++) {
        cin >> num;
        aa[i] = num;
        for (int k = 31; k >= 0; k--) {
            vs[k][i] = get_bit(num, k);
        }
    }
    a.assign(32, fenwick_tree());
    for (int i = 0; i < 32; i++) {
        a[i] = fenwick_tree(vs[i]);
    }
    int q_ans = get_b();
    cout << q_ans << '\n';
    int q;
    cin >> q;
    int j, x;
    for (int i = 0; i < q; i++) {
        cin >> j >> x;
        j--;
        for (int k = 0; k < 32; k++) {
            if (get_bit(aa[j], k) != get_bit(x, k)) {
                a[k].change(j, get_bit(x, k));
            }
        }
        aa[j] = x;
        q_ans = get_b();
        cout << q_ans << '\n';
    }
    int kek = 0;
}
