#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <cassert>

using namespace std;

struct Kek {
    vector <int> v;
    Kek(string s = "") {
        v.clear();
        for (int i = (int)s.length() - 1; i >= 0; i--)
            v.push_back(s[i] - '0');
    }
};

void print(Kek a) {
    for (int i = (int)a.v.size() - 1; i >= 0; i--)
        cout << a.v[i];
    cout << endl;
}

Kek operator +(Kek a, Kek b) {
    Kek c;
    while (a.v.size() > b.v.size())
        b.v.push_back(0);
    while (a.v.size() < b.v.size())
        a.v.push_back(0);
    int l = 0;
    for (int i = 0; i < (int)a.v.size(); i++) {
        c.v.push_back((a.v[i] + b.v[i] + l) % 10);
        l = (a.v[i] + b.v[i] + l) / 10;
    }
    c.v.push_back(l);
    while (c.v.back() == 0 && c.v.size() > 1)
        c.v.pop_back();
    return c;
}
string get(string s) {
    if (s[0] != '-')
        return s;
    string str = "";
    for (int i = 1; i < (int)s.length(); i++)
        str += s[i];
    return str;
}

bool operator <(Kek a, Kek b) {
    if ((int)a.v.size() != (int)b.v.size())
        return a.v.size() < b.v.size();
    for (int i = 0; i < (int)a.v.size(); i++)
        if (a.v[i] != b.v[i])
            return a.v[i] < b.v[i];
}

Kek operator -(Kek a, Kek b) {
    Kek c;
    while (a.v.size() > b.v.size())
        b.v.push_back(0);
    while (a.v.size() < b.v.size())
        a.v.push_back(0);
    int e = 0;
    for (int i = 0; i < (int)a.v.size(); i++) {
        int p = (a.v[i] - b.v[i] - e);
        e = 0;
        if (p < 0)
            e = 1, p += 10;
        c.v.push_back(p);
    }

    while (c.v.back() == 0 && c.v.size() > 1)
        c.v.pop_back();

    return c;
}

int main() {
    assert(freopen("sum.in", "r", stdin));
    assert(freopen("sum.out", "w", stdout));

    ios_base::sync_with_stdio(false);

    string s1, s2; cin >> s1 >> s2;
    if (s1[0] != '-' && s2[0] != '-') {
        Kek a(s1), b(s2);
        print(a + b);
        return 0;
    } else if (s1[0] == '-' && s2[0] == '-') {
        cout << "-";
        s1 = get(s1), s2 = get(s2);
        print(Kek(s1) + Kek(s2));
        return 0;
    }
    Kek a(get(s1)), b(get(s2));

    if (s1[0] == '-' && b < a)
        cout << "-";
    else if (s2[0] == '-' && a < b)
        cout << "-";

    if (a < b)
        swap(a, b);

    print(a - b);

    return 0;
}
