#include<iostream>
#include<vector>
#include<string>
#include<queue>

using namespace std;

#define int long long

vector<int> p, h, c;
vector<int> lb, rb;

int get(int x) {
	if (p[x] == x)
		return x;
	return p[x] = get(p[x]);
}

void unite(int a, int b) {
	int pa = get(a), pb = get(b);
	if (pa == pb)
		return;
	if (h[pa] > h[pb]) {
		p[pb] = pa;
		lb[pa] = min(lb[pa], lb[pb]);
		rb[pa] = max(rb[pa], rb[pb]);
		h[pa] += h[pb];
	}
	else {
		p[pa] = pb;
		lb[pb] = min(lb[pa], lb[pb]);
		rb[pb] = max(rb[pa], rb[pb]);
		h[pb] += h[pa];
	}
}

bool try_unite(int jun, int sen, int dom) {
	int ijun = get(jun), isen = get(sen);
	int vjun = c[ijun], vsen = c[isen];
	int sjun = h[ijun], ssen = h[isen];
	if (vjun == vsen) {
		unite(ijun, isen);
		return true;
	}
	if (vjun == !dom && vsen == dom && sjun < ssen) {
		unite(ijun, isen);
		return true;
	}
	return false;
}

int seg_solve(int l, int r, int plus, string& s, int n) {
	queue<int> q;
	for (int i = l; i < r; i++) {
		p[i] = i;
		h[i] = 1;
		lb[i] = i, rb[i] = i + 1;
		c[i] = s[i] == '+';
		q.push(i);
	}
	while (!q.empty()) {
		int id = q.front();
		q.pop();
		int cl = lb[get(id)];
		int cr = rb[get(id)];
		int was = false;
		if (cl - 1 >= l) {
			was = was || try_unite(cl - 1, cl, -1);
		}
		if (cr < r) {
			was = was || try_unite(cr, cr - 1, -1);
		}
		if (was)
			q.push(id);
	}
	for (int i = l; i < r; i++) {
		q.push(i);
	}
	while (!q.empty()) {
		int id = q.front();
		q.pop();
		int cl = lb[get(id)];
		int cr = rb[get(id)];
		int was = false;
		if (cl - 1 >= l) {
			was = was || try_unite(cl - 1, cl, plus);
		}
		if (cr < r) {
			was = was || try_unite(cr, cr - 1, plus);
		}
		if (was)
			q.push(id);
	}
	return c[get(l)] == plus && h[get(l)] == (r - l);
}

void solve() {
	string s, t;
	cin >> s >> t;
	int n = s.size();	
	p.resize(n);
	h.resize(n);
	c.resize(n);
	lb.resize(n);
	rb.resize(n);
	int last = 0;
	bool ok = true;
	for (int i = 1; i < n; i++) {
		if (t[i] != t[i - 1]) {
			ok &= s[i - 1] != s[i] && (s[i - 1] == t[last]);
			ok &= seg_solve(last, i, t[last] == '+', s, i - last);
			last = i;
		}
	}
	ok &= seg_solve(last, n, t[last] == '+', s, n - last);
	if (ok)
		cout << "Yes\n";
	else
		cout << "No\n";
}

int32_t main() {
	//freopen("input.in", "r", stdin);
	ios_base::sync_with_stdio(false);
	int q;
	cin >> q;
	while (q--)
		solve();
}