#include <iostream>
#include <list>
#include <queue>
#include <set>

#define sz(a_) ll((a_).size())

using namespace std;

using ll = long long;

constexpr ll maxa = 2e5+100;
constexpr ll maxn = 120;
constexpr ll pr = 1000000000ll;
constexpr ll inf = 1e17;

struct ex {
    ll l, r, c;
};

ll g[maxa];
ex exs[maxn];

ll le[maxa*2+100];
ll ri[maxa*2+100];
ll val[maxa*2+100];

void build_tree(ll i, ll l, ll r)
{
    le[i] = l;
    ri[i] = r;
    val[i] = inf;
    if (r-l > 1) {
        ll m = (l+r)/2;
        build_tree(i*2+1, l, m);
        build_tree(i*2+2, m, r);
    }
}

void update(ll i, ll pos, ll nv)
{
    if (pos < le[i] || pos >= ri[i]) {
        return;
    }
    if (nv < val[i]) {
        val[i] = nv;
    }
    if (ri[i]-le[i] > 1) {
        update(i*2+1, pos, nv);
        update(i*2+2, pos, nv);
    }
}

ll get(ll i, ll l, ll r)
{
    if (l <= le[i] && r >= ri[i]) {
        return val[i];
    }
    if (l >= ri[i] || r <= le[i]) {
        return inf;
    }
    if (val[i] == inf) {
        return inf;
    }
    ll tmp = get(i*2+1, l, r);
    ll tmp2 = get(i*2+2, l, r);
    if (tmp > tmp2) {
        return tmp2;
    } else {
        return tmp;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll n, a;
    scanf("%d%d", &n, &a);
    for (ll i = 0; i < n; ++i) {
        scanf("%d%d%d", &(exs[i].l), &(exs[i].r), &(exs[i].c));
    }
    build_tree(0, 0, a+1);
    for (ll i = a; i >= 0; --i) {
        ll best = 0;
        for (ll j = 0; j < n; ++j) {
            if (i+exs[j].r > a) {
                continue;
            }
            ll l = i+exs[j].l, r = i+exs[j].r;
            ll nb = get(0, l, r+1);
            nb -= exs[j].c+pr*i;
            if (nb > best) {
                best = nb;
            }
        }
        g[i] = best;
        update(0, i, pr*i+g[i]);
    }
    printf("%lld\n", g[0]);
    return 0;
}