#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <cassert>
#include <climits>
#include <functional>
#include <vector>

using namespace std;

typedef unsigned int index;

void ogr(int a, int b, index *ans)
{
	for (index i = 29; i != (index)-1; i--)
	{
		int f = (((1 << i) & a) > 0 ? 1 : 0);
		int s = (((1 << i) & b) > 0 ? 1 : 0);
		if (f == s)
			ans[i] = 0;
		if (f < s)
		{
			ans[i] = 1;
			for (index j = i - 1; j != (index)-1; j--)
				ans[j] = 0;
			break;
		}
		if (s < f)
		{
			ans[i] = 2;
			for (index j = i - 1; j != (index)-1; j--)
				ans[j] = 0;
			break;
		}
	}
}

int ans(int **sumo)/*{{{*/
{
	/*
	for (index i = 0; i < 30; i++)
	{
		for (index j = 0; j < 3; j++)
			cout << sumo[i][j] << " ";
		cout << endl;
	}
	*/
	int anss = 0;
	for (index i = 0; i < 30; i++)
	{
		if (sumo[i][1] > 0 and sumo[i][2] > 0)
		{
			return -1;
		}
		else if (sumo[i][2] > 0)
		{
			anss += (1 << i);
		}
	}
	return anss;
}/*}}}*/

void regen_plus(int a, int b, int **sumo, index *as)/*{{{*/
{
	ogr(a, b, as);
	for (index j = 0; j < 30; j++)
	{
		++sumo[j][as[j]];
	}
}/*}}}*/

void regen_minus(int a, int b, int **sumo, index *as)/*{{{*/
{
	ogr(a, b, as);
	for (index j = 0; j < 30; j++)
	{
		--sumo[j][as[j]];
	}
}/*}}}*/

int main()
{
#ifdef ONPC
	assert(freopen("a.in", "r", stdin));
	assert(freopen("a.out", "w", stdout));
#else
	assert(freopen("order.in", "r", stdin));
	assert(freopen("order.out", "w", stdout));
#endif
	ios::sync_with_stdio(false);
	size_t n;
	cin >> n;
	int *mas = new int[n];
	for (index i = 0; i < n; i++)
		cin >> mas[i];
	int **sumo = new int *[30];
	for (index i = 0; i < 30; i++)
	{
		sumo[i] = new int[3];
		for (index j = 0; j < 3; j++)
			sumo[i][j] = 0;
	}
	index *as = new index[30];
	for (index i = 0; i < n - 1; i++)
	{
		regen_plus(mas[i], mas[i + 1], sumo, as);
	}
	cout << ans(sumo) << "\n";
	size_t q;
	cin >> q;
	for (index io = 0; io < q; io++)
	{
		index i;
		int a;
		cin >> i >> a;
		i--;
		if (i > 0)
		{
			regen_minus(mas[i - 1], mas[i], sumo, as);
		}
		if (i < n - 1)
		{
			regen_minus(mas[i], mas[i + 1], sumo, as);
		}
		mas[i] = a;
		if (i > 0)
		{
			regen_plus(mas[i - 1], mas[i], sumo, as);
		}
		if (i < n - 1)
		{
			regen_plus(mas[i], mas[i + 1], sumo, as);
		}
		cout << ans(sumo) << "\n";
	}
}
