#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <cmath>
#include <climits>
#include <vector>
#include <functional>

using namespace std;

typedef unsigned int index;

int main()
{
#ifdef ONPC
	assert(freopen("a.in", "r", stdin));
	assert(freopen("a.out", "w", stdout));
#else
#endif
	ios::sync_with_stdio(false);
	size_t n, m;
	cin >> n >> m;
	vector<index> g(n + m, (index)-1);
	vector<bool> used(n + m);
	vector<int> c1(n), c2(m);
	vector<index> md1(n);
	for (index i = 0; i < n; i++)
	{
		cin >> md1[i];
		md1[i]--;
	}
	for (index i = 0; i < n; i++)
	{
		cin >> c1[i];
	}
	for (index i = 0; i < m; i++)
	{
		index x;
		cin >> x;
		x--;
		g[x] = i;
	}
	for (index i = 0; i < m; i++)
	{
		cin >> c2[i];
	}
	long long bans = -1;
	index l1, l2, r1, r2;
	for (index i1 = 0; i1 < n; i1++)
	{
		long long sum = 0;
		for (index j = i1; j <= n; j++)
		{
			long long nbest = -1;
			index nl, nr;
			long long cur = 0;
			index start = 0;
			for (index i = 0; i < m; i++)
			{
				if (used[i])
				{
					if (cur > nbest)
					{
						nbest = cur;
						nl = start;
						nr = i - 1;
					}
					cur = 0;
					start = i + 1;
				}
				else
				{
					cur += c2[i];
				}
			}
			if (cur > nbest)
			{
				nbest = cur;
				nl = start;
				nr = (index)m - 1;
			}
			if (nbest + sum > bans)
			{
				bans = nbest + sum;
				l1 = i1;
				r1 = j - 1;
				l2 = nl;
				r2 = nr;
			}
			if (j < n)
			{
				sum += c1[j];
				if (g[md1[j]] != (index)-1)
				{
					used[g[md1[j]]] = true;
				}
			}
		}
		for (index j = i1; j < n; j++)
			if (g[md1[j]] != (index)-1)
			{
				used[g[md1[j]]] = false;
			}
	}
	cout << bans << endl;
	if (l1 <= r1 and l1 <= n and r1 <= n)
	{
		cout << l1 + 1 << " " << r1 + 1 << endl;
	}
	else
	{
		cout << "0 0" << endl;
	}
	if (l2 <= r2 and l2 <= m and r2 <= m)
	{
		cout << l2 + 1 << " " << r2 + 1 << endl;
	}
	else
	{
		cout << "0 0" << endl;
	}
}
