#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int)(x).size())
#define endl '\n'

typedef long long llong;

const int INF = 2e9 + 29;
const llong LINF = 3e18;

const bool judge = true, stress = false;

int cnt_tests = 1;

string a, b;

void inp() {
    cin >> a >> b;
}

struct DSU {
    vector<int> anc, rang, S;
    vector<pair<int, int> > inf;
    DSU(int n) {
        anc.resize(n);
        rang.resize(n, 1);
        inf.resize(n);
        S.resize(n, 1);
        for (int i = 0; i < n; i++) {
            anc[i] = i;
            inf[i] = {i, i};
        }
    }
    DSU() {}
    int get(int x) {
        if (anc[x] == x)
            return x;
        return anc[x] = get(anc[x]);
    }
    void unite(int x, int y) {
        x = get(x);
        y = get(y);
        if (x == y)
            return;
        if (rang[y] > rang[x])
            swap(x, y);
        if (rang[x] == rang[y])
            rang[x]++;
        anc[y] = x;
        inf[x] = {min(inf[x].fi, inf[y].fi), max(inf[x].se, inf[y].se)};
        S[x] += S[y];
    }
};

bool check(int l, int r, char want) {
    if (l - 1 >= 0 && a[l - 1] == a[l]) {
        return false;
    }
    if (r + 1 < sz(a) && a[r] == a[r + 1]) {
        return false;
    }

    int i, j;
    DSU dsu(r - l + 1);
    for (i = l; i <= r; i++) {
        for (j = i; j <= r; j++) {
            if (a[i] != a[j]) {
                i = j - 1;
                break;
            } else {
                dsu.unite(i - l, j - l);
            }
            if (j == r) {
                i = j;
                dsu.unite(i - l, j - l);
                break;
            }
        }
    }
    bool good = true;
    while (good) {
        good = false;
        for (int i = l; i <= r; i++) {
            if (a[l + dsu.get(i - l)] != want) {
                pair<int, int> cur = dsu.inf[dsu.get(i - l)];
                if (cur.fi - 1 >= 0) {
                    if (dsu.S[dsu.get(cur.fi - 1)] > dsu.S[dsu.get(i - l)]) {
                        dsu.unite(dsu.get(cur.fi - 1), dsu.get(i - l));
                        cur = dsu.inf[dsu.get(i - l)];
                        if (cur.se + 1 < sz(dsu.rang)) {
                            dsu.unite(dsu.get(cur.se + 1), dsu.get(i - l));
                            cur = dsu.inf[dsu.get(i - l)];
                        }
                        good = true;
                        continue;
                    }
                }
                if (cur.se + 1 < sz(dsu.rang)) {
                    if (dsu.S[dsu.get(cur.se + 1)] > dsu.S[dsu.get(i - l)]) {
                        dsu.unite(dsu.get(cur.se + 1), dsu.get(i - l));
                        cur = dsu.inf[dsu.get(i - l)];
                        if (cur.fi - 1 >= 0) {
                            dsu.unite(dsu.get(cur.fi - 1), dsu.get(i - l));
                            cur = dsu.inf[dsu.get(i - l)];
                        }
                        good = true;
                        continue;
                    }
                }
            }
        }
    }
    if ((dsu.S[dsu.get(0)] == (r - l + 1)) && a[l + dsu.get(0)] == want) {
        for (int i = l; i <= r; i++) {
            a[i] = b[i];
        }
        return true;
    }
    return false;
}

void solve() {
    int n = sz(b), i, j;
    for (i = 0; i < n; i++) {
        for (j = i; j < n; j++) {
            if (b[j] != b[i]) {
                if (!check(i, j - 1, b[i])) {
                    cout << "No\n";
                    return;
                }
                i = j - 1;
                break;
            }
            if (j == n - 1) {
                if (!check(i, j, b[i])) {
                    cout << "No\n";
                    return;
                }
                i = j;
                break;
            }
        }
    }
    cout << "Yes\n";
    return;
}

void run() {
    if (!stress) {
        inp();
        solve();
    }
}

int main() {
    srand(time(0));
    if (judge) {
        ios_base::sync_with_stdio(false);
        cin.tie(0);
        cout.tie(0);
    } else {
        freopen("input.txt", "r", stdin);
    }
    cin >> cnt_tests;
    for (int i = 0; i < cnt_tests; i++) {
        run();
    }
    cout << endl;
    return 0;
}
