#include <bits/stdc++.h>
using namespace std;
#define DB(v) cerr << #v << ' ' << v << endl
#define sz(v) int(v.size())
#define For(i, a, b) for(int i = a;i <= b; ++i)
#define fi first
#define se second

typedef pair <int,int> pii;
typedef long long i64;

struct edge
{
    int from, to, color, weight;
    edge (int a = 0, int b = 0, int c = 0, int d = 0) {
        tie(from, to, color, weight) = make_tuple(a, b, c, d);
    }
};

const int N = 1e3 + 9;
const i64 INF = 1e9 + 9;
int n;
i64 dist[N][N];
i64 dist_one [N][N];
i64 quality [N][N];

//vector <edge> connect [N][N];

vector <edge> path [N];

void upd_path (int q) {
    int siz = sz(path[q]);
    vector <i64> pref_sum (siz);
    pref_sum[0] = 0;
    for(int i = 1;i < siz; ++i) {
        pref_sum[i] = pref_sum[i - 1] + path[q][i - 1].weight;
        for(int j = 0;j < i; ++j) {
            int cur_from = path[q][j].from, cur_to = path[q][i].from;
            dist_one[cur_from][cur_to] = min(dist_one[cur_from][cur_to], pref_sum[i] - pref_sum[j]);
        }
    }
}

int main()
{
#ifdef HOME
    freopen("input.txt","r",stdin);
#endif // HOME
    ios::sync_with_stdio(NULL); cin.tie(NULL);

    cin >> n;

    For(i, 1, n) {
        For(j, 1, n) {
            dist[i][j] = INF;
            dist_one[i][j] = INF;
        }
    }

    For(i, 1, n) {
        dist[i][i] = 0;
        dist_one[i][i] = 0;
    }

    int Q; cin >> Q;
    For(q, 1, Q) {
        int s;
        cin >> s;
        int from, weight, to; cin >> from;
        For(i, 1, s) {
            cin >> weight >> to;
           // connect[from][to].push_back(edge(from, to, q, eight));
            dist[from][to] = min(dist[from][to], weight * 1LL);
            path[q].push_back(edge(from, to, q, weight));
            from = to;
        }
        path[q].push_back(edge(to, 0, 0, 0));
    }

    For(k, 1, n) {
        For(i, 1, n) {
            For(j, 1, n) {
                dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);
            }
        }
    }

    For(q, 1, Q)
        upd_path(q);

   /* For(i, 1, n) {
        For(j, 1, n) {
            cout << dist[i][j] << ' ';
        }
        cout << endl;
    }
    cout << endl;

    For(i, 1, n) {
        For(j, 1, n) {
            cout << dist_one[i][j] << ' ';
        }
        cout << endl;
    }
    cout << endl;*/

    For(i, 1, n) {
        For(j, 1, n) {
            if(dist[i][j] != INF && dist[i][j] == dist_one[i][j]) {
                quality[i][j] = dist[i][j] * dist[i][j];
            }
        }
    }

     /*For(i, 1, n) {
        For(j, 1, n) {
            cout << quality[i][j] << ' ';
        }
        cout << endl;
    }*/


    For(k, 1, n) {
        For(i, 1, n) {
            For(j, 1, n) {
                if(dist[i][j] == dist[i][k] + dist[k][j]) {
                    quality[i][j] = max(quality[i][j], quality[i][k] + quality[k][j]);
                }
            }
        }
    }

    cout << dist[1][n] << ' ' << quality[1][n];
    return 0;
}
