#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <cstring>
#include <cassert>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <numeric>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;

int solve();

int main() {
#ifdef PoDuReM
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	return solve();
}

const ll dd = (ll)1e4 + 7;

struct pt {
	ll x, y, i;

	pt() {}
	pt(pt a, pt b) {
		x = b.x - a.x, y = b.y - a.y;
	}

	bool operator < (pt Q) {
		return x == Q.x ? y < Q.y : x < Q.x;
	}

	ll operator ^ (pt Q) {
		return 1ll * x * Q.y - 1ll * y * Q.x;
	}
} A[dd], B[dd];

char cur[4];
map<pair<pair<ll, ll>, ll>, bool> M;
ll cnt = 0, N;

bool get(pt A, pt B, pt C) {

	if (M.find({ { A.i, B.i }, C.i }) != M.end()) return M[{ { A.i, B.i }, C.i }];
	if (M.find({ { A.i, C.i }, B.i }) != M.end()) return M[{ { A.i, C.i }, C.i }];
	if (M.find({ { B.i, A.i }, C.i }) != M.end()) return M[{ { B.i, A.i }, C.i }];
	if (M.find({ { B.i, C.i }, A.i }) != M.end()) return M[{ { B.i, C.i }, A.i }];
	if (M.find({ { C.i, A.i }, B.i }) != M.end()) return M[{ { C.i, A.i }, B.i }];
	if (M.find({ { C.i, B.i }, A.i }) != M.end()) return M[{ { C.i, B.i }, A.i }];

	printf("? 3 %lld %lld %lld\n", A.i + 1, B.i + 1, C.i + 1);
	fflush(stdout);

	scanf("%s", cur);
	return M[{ { A.i, B.i }, C.i }] = (cur[0] == 'Y');
}

bool hoho(pt A, pt B, pt C, pt O) {
	auto sign = [](ll V) { return V < 0 ? -1 : ll(V > 0); };
	ll G1 = sign(pt(O, A) ^ pt(A, B));
	ll G2 = sign(pt(O, B) ^ pt(B, C));
	ll G3 = sign(pt(O, C) ^ pt(C, A));
	return G1 != 0 && G2 != 0 && G3 != 0 && G1 == G2 && G2 == G3;
}

ll go(pt A, pt B, pt C, vector<pt> V, bool f) {
	if (!f && !get(A, B, C)) return 0;
	if ((ll)V.size() == 0) {
		printf("! 3 %lld %lld %lld\n", A.i + 1, B.i + 1, C.i + 1);
		fflush(stdout);
		return 1;
	}
	int ind = rand() % (ll)V.size();
	ll t = rand() % 3;
	if (t == 0) {
		vector<pt> nw;
		for (pt i : V) if (hoho(A, B, V[ind], i))
			nw.push_back(i);
		if (go(A, B, V[ind], nw, 0))
			return 1;

		nw = vector<pt>(0);
		for (pt i : V) if (hoho(A, C, V[ind], i))
			nw.push_back(i);
		if (go(A, C, V[ind], nw, 0))
			return 1;

		nw = vector<pt>(0);
		for (pt i : V) if (hoho(C, B, V[ind], i))
			nw.push_back(i);
		if (go(C, B, V[ind], nw, 1))
			return 1;
	} else if (t == 1) {
		vector<pt> nw;
		for (pt i : V) if (hoho(A, C, V[ind], i))
			nw.push_back(i);
		if (go(A, C, V[ind], nw, 0))
			return 1;

		nw = vector<pt>(0);
		for (pt i : V) if (hoho(A, B, V[ind], i))
			nw.push_back(i);
		if (go(A, B, V[ind], nw, 0))
			return 1;

		nw = vector<pt>(0);
		for (pt i : V) if (hoho(C, B, V[ind], i))
			nw.push_back(i);
		if (go(C, B, V[ind], nw, 1))
			return 1;
	} else {
		vector<pt> nw;
		for (pt i : V) if (hoho(B, C, V[ind], i))
			nw.push_back(i);
		if (go(B, C, V[ind], nw, 0))
			return 1;

		nw = vector<pt>(0);
		for (pt i : V) if (hoho(A, B, V[ind], i))
			nw.push_back(i);
		if (go(A, B, V[ind], nw, 0))
			return 1;

		nw = vector<pt>(0);
		for (pt i : V) if (hoho(A, C, V[ind], i))
			nw.push_back(i);
		if (go(A, C, V[ind], nw, 1))
			return 1;
	}
	return 0;
}

bool check(ll m) {
	printf("? %lld ", m + 1);
	for (ll i = 0; i <= m; ++i)
		printf("%lld ", A[i].i + 1);
	puts("");
	fflush(stdout);

	scanf("%s", cur);
	return cur[0] == 'Y';
}

int solve() {
	srand(6543456);
	ll n;
	scanf("%lld", &n);
	N = n;
	for (ll i = 0; i < n; ++i)
		scanf("%lld %lld", &A[i].x, &A[i].y), A[i].i = i, B[i] = A[i];

	pt O = *min_element(A, A + n);
	sort(A, A + n, [&](pt a, pt b) {
		ll J = pt(O, a) ^ pt(a, b);
		if (J == 0) return a < b;
		return J < 0;
	});

	ll iA = 0;
	for (ll i = 0; i < n; ++i) {
		while (iA > 1 && (pt(A[iA - 2], A[iA - 1]) ^ pt(A[iA - 1], A[i])) >= 0)
			--iA;
		A[iA++] = A[i];
	}
	n = iA;

	ll q;
	scanf("%lld", &q);
	while (q--) {
		M.clear();
		cnt = 0;
		ll l = 1, r = n - 1;
		while (r - l > 1) {
			ll m = (l + r) / 2;
			if (check(m))
				r = m;
			else
				l = m;
		}
		vector<pt> J;
		for (ll i = 0; i < N; ++i) if (hoho(A[0], A[l], A[r], B[i]))
			J.push_back(B[i]);
		go(A[0], A[l], A[r], J, 1);
	}
	return 0;
}