#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll maxn = 2000001;
const ll inf = numeric_limits<ll>::max() / 2 - 100;
const ll nn = 1e9;
ll n, a;

struct exper {
    ll l, r, c;

    exper() {}
};

vector<exper> vec;

ll minans[maxn];
ll tree[maxn * 8];

void build(ll v, ll vl, ll vr) {
    if (vl + 1 == vr) {
        return;
    }
    ll mid = (vl + vr) >> 1;
    build(2 * v + 1, vl, mid);
    build(2 * v + 2, mid, vr);
    tree[v] = min(tree[2 * v + 1], tree[2 * v + 2] + nn * (mid - vl));
}

void add(ll v, ll vl, ll vr, ll pos, ll val) {
    if (vl + 1 == vr) {
        tree[v] = val;
        return;
    }
    ll mid = (vl + vr) >> 1;
    if (mid > pos) add(2 * v + 1, vl, mid, pos, val);
    else add(2 * v + 2, mid, vr, pos, val);
    tree[v] = min(tree[2 * v + 1], tree[2 * v + 2] + nn * (mid - vl));
}

ll getmin(ll v, ll vl, ll vr, ll l, ll r) {
    if (vl >= l && vr <= r)
        return tree[v];
    if (vl >= r || vr <= l)
        return inf;
    ll mid = (vl + vr) >> 1;
    ll m1 = getmin(2 * v + 1, vl, mid, l, r);
    ll m2 = getmin(2 * v + 2, mid, vr, l, r);
    return min(m1, m2 + nn * (mid - vl));
}

ll getans(ll v) {
    if (minans[v] != -1) return minans[v];
    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        if (v + vec[i].r < a) {
            ll newans = 0;
            ll myadd = -v * nn;
            newans = getmin(0, 0, a, v + vec[i].l, v + vec[i].r + 1) + myadd;
            /*
            for (int j = vec[i].l; j <= vec[i].r; ++j) {
                newans = min(newans, getans(v + j) + j * nn);
            }*/
            newans -= vec[i].c;
            ans = max(ans, newans);
        }
    }
    add(0, 0, a, v, ans);
    return minans[v] = ans;
}

int run() {
    for (int i = 0; i < maxn; ++i) {
        minans[i] = -1;
    }
    cin >> n >> a;
    a++;
    build(0, 0, a);
    vec.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> vec[i].l >> vec[i].r >> vec[i].c;
    }
    for (int i = a - 1; i >= 0; i--) {
        getans(i);
        //cerr << i << ": " << getans(i) << endl;
    }
    cout << minans[0];
    return 0;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    run();
    return 0;
}