#include <bits/stdc++.h>
using namespace std;
typedef long long int ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int maxn = (const int) (1e4 + 5);

struct edge {
    int from;
    int path_num;
    ll timer;
};

int n, m;
vector<edge> vec[maxn];
set<pll> st;
ll found[maxn];
ll secs[maxn];
ll path_sums[maxn];
ll path_nums[maxn];

map<int, ll> memes[maxn];
ll kek[maxn];
vector<bool> used;

void recalc(int v, ll sum) {
    for (auto e : vec[v]) {
        int from = e.from;
        ll timer = e.timer;
        if (used[from])
            continue;

        ll maybe_timer = sum + timer;

        if (maybe_timer < found[from])
            found[from] = maybe_timer;
    }
}

void calc_timer(int v) {
    kek[v] = 0;
    for (int i = 0; i < n; i++) {
        if (!used[i])
            continue;
        if (!memes[v].count(i))
            continue;
        ll val = memes[v][i];
        if (found[v] - val != found[i])
            continue;
        kek[v] = max(kek[v], kek[i] + val * val);
    }
    //cerr << v << ": " << kek[v] << endl;
}

int main() {
    scanf("%d%d", &n, &m);
    for (int i = 0; i < m; i++) {
        int s;
        scanf("%d", &s);
        vector<int> tmp((unsigned long) (2 * s + 1));
        for (int z = 0; z < 2 * s + 1; z++)
            scanf("%d", &tmp[z]);
        for (int z = 1; z + 1 < 2 * s + 1; z += 2) {
            int from = tmp[z - 1] - 1;
            ll timer = tmp[z];
            int to = tmp[z + 1] - 1;

            edge e;
            e.from = from;
            e.path_num = i;
            e.timer = timer;

            vec[to].push_back(e);
        }

        for (int a = 1; a + 1 < 2 * s + 1; a += 2) {
            ll timer = 0;
            for (int b = a; b + 1 < 2 * s + 1; b += 2) {
                int from = tmp[a - 1] - 1;
                timer += tmp[b];
                int to = tmp[b + 1] - 1;
                if (!memes[from].count(to))
                    memes[from][to] = LLONG_MAX;
                memes[from][to] = min(memes[from][to], timer);
            }
        }
    }

    fill(found, found + n, LLONG_MAX);
    fill(kek, kek + n, -1);
    fill(secs, secs + n, LLONG_MAX);
    fill(path_sums, path_sums + n, 0);
    found[n - 1] = 0;
    secs[n - 1] = 0;
    path_nums[n - 1] = -1;

    /*
    for (int i = 0; i < n; i++)
        st.insert({found[i], i});

    for (int i = 0; i < n; i++) {
        pll cur = *st.begin();
        st.erase(st.begin());
        recalc(cur.second, cur.first);
    }
     */

    used.resize(n);
    vector<int> veced;
    for (int i = 0; i < n; i++) {
        int ind;
        ll val = LLONG_MAX;
        for (int z = 0; z < n; z++) {
            if (used[z])
                continue;
            if (val > found[z]) {
                val = found[z];
                ind = z;
            }
        }
        veced.push_back(ind);
        used[ind] = true;
        recalc(ind, found[ind]);
        calc_timer(ind);
    }

    reverse(veced.begin(), veced.end());

    cout << found[0] << " " << kek[0] << endl;
}

/*
5 2
4 1 3 2 3 3 5 5 10 4
3 4 2 2 1 3 4 1

 2 1
1 1 3 2

 5 2
3 1 1 2 2 3 3 4
3 2 2 3 3 4 4 5

 3 3
1 2 50 3
1 1 50 2
2 1 50 2 50 3

 4 2
 2 1 2 2 2 3
 2 2 2 3 2 4

 6 4
 2 1 2 2 2 3
 2 2 2 3 2 4
 2 3 2 4 2 5
 2 4 2 5 2 6

 5 2
 3 1 2 2 2 3 2 4
 3 2 2 3 2 4 2 5
 */