#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
typedef long long int ll;
typedef pair<int, int> pii;

template <typename T> using ordered_set = tree<T, null_type, less<T>,
        rb_tree_tag, tree_order_statistics_node_update>;

int n;

int g_left(ordered_set<pii> & st, string & s, int v) {
    if (v == 0)
        return 0;
    int order = st.order_of_key({v, -1});
    pii res = (*st.find_by_order(order - 1));
    return res.second - res.first + 1;
}

int g_right(ordered_set<pii> & st, string & s, int v) {
    if (v == s.size() - 1)
        return 0;
    int order = st.order_of_key({v, INT_MAX});
    pii res = (*st.find_by_order(order));
    return res.second - res.first + 1;
}

void color(ordered_set<pii> & st, string & s, int a, int b) {
    int order = st.order_of_key({a, -1});
    pii res_a = (*st.find_by_order(order - 1));
    order = st.order_of_key({b, INT_MAX});
    pii res_b = (*st.find_by_order(order));

    st.erase({a, b});
    st.insert({res_a.first, res_b.second});

    for (int i = a; i <= b; i++) {
        if (s[i] == '-')
            s[i] = '+';
        else
            s[i] = '-';
    }
}

bool can_simple(string a, string b) {
    ordered_set<pii> st;
    int len = (int)a.size();
    vector<pii> vec;
    int cur = INT_MAX;
    for (int z = 0; z < len; z++) {
        if (a[z] == b[z]) {
            if (cur <= z - 1)
                vec.push_back({cur, z - 1});
            cur = INT_MAX;
        } else {
            cur = min(cur, z);
        }
    }
    if (cur <= len - 1)
        vec.push_back({cur, len - 1});

    int kz = 0;
    int ok = 0;
    if (a[0] == b[0])
        ok = 1;

    for (int z = 0; z < len; z++) {
        if (ok == 1) {
            if (a[z] == b[z]) {

            } else {
                st.insert({kz, z - 1});
                ok ^= 1;
            }
        } else {
            if (a[z] != b[z]) {

            } else {
                st.insert({kz, z - 1});
                ok ^= 1;
            }
        }
    }
    st.insert({kz, len - 1});

    while (vec.size() > 0) {
        bool can = false;
        int cnt = -1;
        for (auto it : vec) {
            cnt++;
            int maximal = max(g_left(st, a, it.first),
                              g_right(st, a, it.second));
            if (maximal > it.second - it.first + 1) {
                color(st, a, it.first, it.second);
                can = true;
                break;
            }
        }
        if (!can)
            break;
        vec.erase(vec.begin() + cnt);
    }

    return vec.size() == 0;
}

bool is_correct(string & a, string & b) {
    int len = (int) a.size();

    vector<pii> res_b;
    char ch = b[0];
    int cur = 0;
    for (int i = 0; i < len; i++) {
        if (b[i] != ch) {
            res_b.push_back({cur, i - 1});
            cur = i;
            ch = b[i];
        }
    }
    res_b.push_back({cur, len - 1});

    vector<pii> res_a;
    ch = a[0];
    cur = 0;
    for (int i = 0; i < len; i++) {
        if (a[i] != ch) {
            res_a.push_back({cur, i - 1});
            cur = i;
            ch = a[i];
        }
    }
    res_a.push_back({cur, len - 1});


    vector<string> vec_str_a;
    vector<string> vec_str_b;
    int ptr = 0;
    for (int i = 0; i < res_b.size(); i++) {
        pii pb = res_b[i];
        vector<pii> as;
        while (ptr < res_a.size()) {
            pii p = res_a[ptr];
            if (p.first <= pb.second && p.second > pb.second)
                return false;
            if (p.first > pb.second)
                break;
            ptr++;
            as.push_back(p);
        }

        string tmp_a, tmp_b;
        for (int z = pb.first; z <= pb.second; z++)
            tmp_a += a[z];
        for (int z = pb.first; z <= pb.second; z++)
            tmp_b += b[z];

        if (!can_simple(tmp_a, tmp_b))
            return false;

        vec_str_a.push_back(tmp_a);
        vec_str_b.push_back(tmp_b);
    }

    for (int i = 1; i < vec_str_a.size(); i++) {
        char res = vec_str_b[i][0];
        char diff = (res == '-' ? '+' : '-');
        if (vec_str_a[i][0] == diff && vec_str_a[i - 1][vec_str_a[i - 1].size() - 1] == res)
            return false;
    }

    return true;
}

int main() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        string a, b;
        cin >> a >> b;

        if (is_correct(a, b))
            cout << "Yes" << endl;
        else
            cout << "No" << endl;
    }
}

/*
 1
 ----+++++
 ++++-----

 1
 ++-+--+-+-++
 ++++----++++

 3
 ++- +++
 ++-- ++++
 ++-+--+- ++++++++

 1
 ++-+--+- ++++++++

 3
 ++-+-- ++----
 ++-+-- +++---
 -++- -++-
 */