#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <stack>
#include <map>

using namespace std;

const int MX = 1e5 + 11;;
const int more = 1000 * 1000 * 1000;
const long long INF = 1e18;
vector<long long> t(3 * MX), p(3 * MX);

void push(int v) {
	t[v << 1] += p[v];
	t[(v << 1) | 1] += p[v];
	p[v << 1] += p[v];
	p[(v << 1) | 1] += p[v];
	p[v] = 0;
	return;
}

void up(int v, int tl, int tr, int r) {
	if (tl == tr) {
		t[v] += more;
	}
	else {
		int tm = (tl + tr) >> 1;
		if (r > tm) {
			t[v << 1] += more;
			p[v << 1] += more;
			up((v << 1) | 1, tm + 1, tr, r);
		}
		else {
			up(v << 1, tl, tm, r);
		}
		t[v] = min(t[v << 1], t[(v << 1) | 1]);
	}
	return;
}

void update(int v, int tl, int tr, int pos, long long val) {
	if (tl == tr)
		t[v] = val;
	else {
		int tm = (tl + tr) >> 1;
		if (pos <= tm)
			update(v << 1, tl, tm, pos, val);
		else
			update((v << 1) | 1, tm + 1, tr, pos, val);
		t[v] = min(t[v << 1], t[(v << 1) | 1]);
	}
	return;
}

long long get(int v, int tl, int tr, int l, int r) {
	if (l > r)
		return INF;
	if (tl == l && tr == r)
		return t[v];
	push(v);
	int tm = (tl + tr) >> 1;
	return min(get(v << 1, tl, tm, l, min(r, tm)), get((v << 1) | 1, tm + 1, tr, max(l, tm + 1), r));
}

int main() {
	ios_base::sync_with_stdio(false);
	int n, a;
	cin >> n >> a;
	vector<int> c(n), l(n), r(n);
	for (int i = 0; i < n; i++)
		cin >> l[i] >> r[i] >> c[i];
	vector<long long> ans(a + 1);
	for (int i = 0; i <= a; i++) {
		for (int j = 0; j < n; j++) {
			if (r[j] <= i)
				ans[i] = max(ans[i], get(1, 0, MX - 1, i - r[j], i - l[j]) - c[j]);
		}
		update(1, 0, MX - 1, i, ans[i]);
		up(1, 0, MX - 1, i);
	}
	cout << ans[a];
	return 0;
}