#include <iostream>
#include <vector>
#include <fstream>
#include <algorithm>
#include <set>
#include <deque>


using namespace std;


struct Point
{
	int x;
	int y;
	int id;
	Point(){};
	Point(int _x, int _y, int _id)
	{
		x = _x;
		y = _y;
		id = _id;
	}
	bool operator < (Point const& oth) const
	{
		return (y != oth.y ? y < oth.y : x < oth.x);
	}
};


struct Vector
{
	int x;
	int y;
	Vector(Point a, Point b)
	{
		x = b.x - a.x;
		y = b.y - a.y;
	}
	long long operator * (Vector const& oth)
	{
		return 1ll * x * oth.y - 1ll * oth.x * y;
	}
};


bool scanline_cmp(Point const& a, Point const& b)
{
	return (a.x != b.x ? a.x < b.x : a.y < b.y);
}


istream & operator >> (istream & in, Point & a)
{
	in >> a.x >> a.y;
	return in;
}
	

ostream & operator << (ostream & out, Point & a)
{
	out << "P(" << a.x << "; " << a.y << ")";
	return out;
}

int main()
{
	int n;
	cin >> n;
	vector<Point> kek(n);
	vector<vector<int>> field;
	for (int i = 1; i <= n; i++)
	{
		cin >> kek[i - 1];
		kek[i - 1].id = i;
	}
	sort(kek.begin(), kek.end(), scanline_cmp);
	set<Point> pts;
	for (auto p : kek)
	{
		/*
		cerr << p << endl;
		cerr << "{ ";
		for (auto pp : pts)
		{
			cerr << pp << ' ';
		}
		cerr << "}" << endl;
		//*/

		auto it = pts.begin();
		deque<Point> dl;
		for (int i = 0; i < (int) pts.size() - 1; i++)
		{
			if (Vector(*it, *next(it)) * Vector(*it, p) < 0)
			{
				field.push_back({it->id, next(it)->id, p.id});
				if (dl.empty()) 
					dl.push_back((*it));
				dl.push_back(*next(it));
			}
			it++;
		}
		if (!dl.empty() && dl.front().y < p.y) dl.pop_front();
		if (!dl.empty() && dl.back().y > p.y) dl.pop_back();
		while (!dl.empty())
		{
			pts.erase(dl.front());
			dl.pop_front();
		}
		pts.insert(p);

		/*
		cerr << "{ ";
		for (auto pp : pts)
		{
			cerr << pp << ' ';
		}
		cerr << "}" << endl;
		//*/
	}
	reverse(kek.begin(), kek.end());
	pts.clear();
	for (auto p : kek)
	{
		/*
		cerr << p << endl;
		cerr << "{ ";
		for (auto pp : pts)
		{
			cerr << pp << ' ';
		}
		cerr << "}" << endl;
		//*/

		auto it = pts.begin();
		deque<Point> dl;
		for (int i = 0; i < (int) pts.size() - 1; i++)
		{
			if (Vector(*it, *next(it)) * Vector(*it, p) > 0)
			{
				field.push_back({it->id, next(it)->id, p.id});
				if (dl.empty()) 
					dl.push_back((*it));
				dl.push_back(*next(it));
			}
			it++;
		}
		if (!dl.empty() && dl.front().y < p.y) dl.pop_front();
		if (!dl.empty() && dl.back().y > p.y) dl.pop_back();
		while (!dl.empty())
		{
			pts.erase(dl.front());
			dl.pop_front();
		}
		pts.insert(p);
		/*
		cerr << "{ ";
		for (auto pp : pts)
		{
			cerr << pp << ' ';
		}
		cerr << "}" << endl;
		//*/
	}

	int q;
	cin >> q;
	for (int i = 0; i < q; i++)
	{
		for (auto i : field)
		{
			cout << "? " << i.size() << ' ';
			for (auto id : i) cout << id << ' ';
			cout << endl;
			string ans;
			cin >> ans;
			if (ans == "Yes")
			{
				cout << "! " << i.size() << ' ';
				for (auto id : i) cout << id << ' ';
				cout << endl;
				break;
			}
		}
	}
	
	//cerr << "Don't forget to comment all your cerrs!" << endl;
}