#include <iostream>
#include <vector>


using namespace std;


const int V = 1e6 + 7;
vector<pair<int,int>> g[V];


const long long INF = 1ll << 60;
long long dst[V];
long long p[V];
bool vis[V];


void dijkstra(int n)
{
	fill(dst, dst + V, INF);
	fill(p, p + V, INF);
	fill(vis, vis + V, 0);
	int s = 1;
	dst[s] = 0;
	p[s] = 0;
	for (int i = 0; i < n; i++)
	{
		int cur = V - 1;
		for (int j = 1; j <= n; j++)
		{
			//cerr << j << ": " << dst[j] << " v " << dst[cur] << endl;
			if (!vis[j] && ((dst[j] < dst[cur]) || ((dst[j] == dst[cur]) && (p[j] < p[cur]))))
			{
				cur = j;
			}
		}
		//cerr << cur << endl;
		vis[cur] = 1;
		for (auto i : g[cur])
		{
			int go = i.first;
			int cost = i.second;
			//cerr << "-> " << go << endl;
			if (!vis[go])
			{
				if (dst[go] > dst[cur] + cost)
				{
					dst[go] = dst[cur] + cost;
					p[go] = p[cur] + cost * cost;
				}
			}
		}
	}
}


int main()
{
	int n, k;
	cin >> n >> k;
	for (int i = 0; i < k; i++)
	{
		int s;
		cin >> s;
		int a;
		cin >> a;
		for (int j = 0; j < s; j++)
		{
			int c, b;
			cin >> c >> b;
			g[a].push_back({b, c});
			a = b;
		}
	}
	/*
	for (int v = 1; v <= n; v++)
	{
		cerr << "V: " << v << endl;
		for (auto i : g[v])
		{
			cerr << "-> " << i.first << ' ' << i.second << endl;
		}
	}
	//*/
	dijkstra(n);
	cout << dst[n] << ' ' << p[n] << endl;
}