#include <iostream>
#include <vector>


using namespace std;


const int V = 1e6 + 7;
vector<vector<int>> g[V];


const long long INF = 1ll << 60;
long long dst[V];
long long p[V];
int prv[V];
bool vis[V];


void dijkstra(int n)
{
	fill(dst, dst + V, INF);
	fill(p, p + V, INF);
	fill(vis, vis + V, 0);
	fill(prv, prv + V, -1);
	int s = 1;
	dst[s] = 0;
	p[s] = 0;
	for (int _ = 0; _ < n; _++)
	{
		int cur = V - 1;
		for (int j = 1; j <= n; j++)
		{
			//cerr << j << ": (" << dst[j] << "; " << p[j] << ") v (" << dst[cur] << "; " << p[cur] << ")" << endl;
			if (!vis[j] && ((dst[j] < dst[cur]) || ((dst[j] == dst[cur]) && (p[j] < p[cur]))))
			{
				cur = j;
			}
		}
		//cerr << "CUR: " << cur << endl;
		vis[cur] = 1;
		for (auto i : g[cur])
		{
			int go = i[0];
			int cost = i[1];
			int id = i[2];
			//cerr << "-> " << go << endl;
			if (!vis[go] && id != prv[cur])
			{
				if (dst[go] > dst[cur] + cost)
				{
					dst[go] = dst[cur] + cost;
					p[go] = p[cur] + cost * cost;
					prv[go] = id;
				}
				if (dst[go] == dst[cur] + cost && p[go] < p[cur] + cost * cost)
				{
					p[go] = p[cur] + cost * cost;
					prv[go] = id;
				}
			}
		}
	}
}


int main()
{
	int n, k;
	cin >> n >> k;
	for (int i = 1; i <= k; i++)
	{
		//cerr << " - " << i << " - " << endl;
		int s;
		cin >> s;
		int a;
		cin >> a;
		vector<int> vert;
		vert.push_back(a);
		vector<int> psum;
		psum.push_back(0);
		for (int j = 0; j < s; j++)
		{
			int c, b;
			cin >> c >> b;
			vert.push_back(b);
			psum.push_back(c + psum.back());
		}
		for (int a = 0; a < s; a++)
		{
			for (int b = a + 1; b < s + 1; b++)
			{
				//cerr << a << ' ' << b << ' ' << psum[b] - psum[a] << endl;
				g[vert[a]].push_back({vert[b], psum[b] - psum[a], i});
			}
			//cerr << "KEK" << endl;
		}
	}
	/*
	for (int v = 1; v <= n; v++)
	{
		cerr << "V: " << v << endl;
		for (auto i : g[v])
		{
			cerr << "-> " << i[0] << ' ' << i[1] << ' ' << i[2] << endl;
		}
	}
	//*/
	dijkstra(n);
	cout << dst[n] << ' ' << p[n] << endl;
}