#include <stdio.h>
#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define sz(a) (int)a.size()
#define fi first
#define se second
#define mp(a, b) make_pair(a, b)

using namespace std;

const int N = 5000000;
const int B = 31;

struct bit
{
    bool ok;
    int need, not_need, any;
    bit()
    {
        ok = true;
        need = 0;
        not_need = 0;
        any = 0;
    }
};

bit merge_(int a, int b)
{
    bit res;
    bool ok = false;
    repb(i, B - 1, -1)
        if (ok)
            res.any |= (1 << i);
        else if (((a >> i) & 1) == ((b >> i) & 1))
            res.any |= (1 << i);
        else
        {
            if (((a >> i) & 1) < ((b >> i) & 1))
                res.not_need |= (1 << i);
            else
                res.need |= (1 << i);
            ok = true;
        }
    return res;
}

bit merge_(bit b1, bit b2)
{
    bit res;
    if (!b1.ok || !b2.ok)
    {
        res.ok = false;
        return res;
    }
    repb(i, B - 1, -1)
        if (((b1.need >> i) & 1) || ((b2.need >> i) & 1))
        {
            if (!(((b1.not_need >> i) & 1) || ((b2.not_need >> i) & 1)))
                res.need |= (1 << i);
            else
            {
                res.ok = false;
                return res;
            }
        }
        else if (((b1.not_need >> i) & 1) || ((b2.not_need >> i) & 1))
        {
            if (!(((b1.need >> i) & 1) || ((b2.need >> i) & 1)))
                res.not_need |= (1 << i);
            else
            {
                res.ok = false;
                return res;
            }
        }
        else
        {
            res.any |= (1 << i);
        }
    return res;
}

int get(bit b)
{
    int res = 0;
    if (!b.ok)
        return -1;
    repb(i, B - 1, -1)
        if ((b.need >> i) & 1)
            res |= (1 << i);
    return res;
}

int n;
int a[N * 4];
int cnt_v = 1;
bit tree[N * 4];
int l[N * 4], r[N * 4], len[N * 4];

bit merge_t(int x1, int x2)
{
    bit res = merge_(tree[x1], tree[x2]);
    if (l[x2] < n && len[x1] && len[x2])
        res = merge_(res, merge_(a[r[x1] - 1], a[l[x2]]));
    return res;
}

void build1(int n)
{
    while (cnt_v < n)
        cnt_v <<= 1;
}

void build(int x, int lx, int rx)
{
    l[x] = lx; r[x] = rx; len[x] = rx - lx;
    if (rx - lx == 1)
        tree[x].any = (1 << B) - 1;
    else
    {
        build((x << 1) + 1, lx, (lx + rx) >> 1);
        build((x << 1) + 2, (lx + rx) >> 1, rx);
        tree[x] = merge_t((x << 1) + 1, (x << 1) + 2);
    }
}

void upd(int x, int p, int v)
{
    if (p < l[x] || p >= r[x])
        return;
    else if (r[x] - l[x] == 1)
        a[p] = v;
    else
    {
        upd((x << 1) + 1, p, v);
        upd((x << 1) + 2, p, v);
        tree[x] = merge_t((x << 1) + 1, (x << 1) + 2);
    }
}

int main()
{
    //reopen("a.in", "r", stdin);
    //freopen("a.out", "w", stdout);
    scanf("%d", &n);
    //srand(239);
    //n = 1000000;
    rep(i, 0, n)
        scanf("%d", &a[i]);
        //a[i] = rand() >> 15 | rand();
    build1(n);
    build(0, 0, cnt_v);
    /*rep(i, 0, cnt_v * 2 - 1)
        cout << tree[i].need << " ";
    cout << endl;
    rep(i, 0, cnt_v * 2 - 1)
        cout << tree[i].not_need << " ";
    cout << endl;
    rep(i, 0, cnt_v * 2 - 1)
        cout << tree[i].any << " ";
    cout << endl;*/
    int q;
    scanf("%d", &q);
    //q = 1000000;
    printf("%d\n", get(tree[0]));
    rep(i, 0, q)
    {
        int p, v;
        scanf("%d %d", &p, &v);
        //p = (rand() >> 15 | rand()) % n + 1, v = (rand() >> 15 | rand());
        p--;
        upd(0, p, v);
        printf("%d\n", get(tree[0]));
    }
    return 0;
}
