#include <stdio.h>
#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define fi first
#define se second
#define sz(a) (int)a.size()
#define mp(a, b) make_pair(a, b)

using namespace std;

const int N = 2000000 + 1;
const int inf = (int)1e9;
const ll oo = (ll)1e18 + 1;

struct exper
{
    int l, r, cost;
    exper() {}
    exper(int l, int r, int cost) : l(l), r(r), cost(cost) {}
    void read() { scanf("%d %d %d", &l, &r, &cost); }
};

bool operator < (exper e1, exper e2)
{
    return e1.r < e2.r;
}

struct MinQueue
{
    deque<ll> q;
    MinQueue() {}
    void add(ll x)
    {
        while (!q.empty() && q.front() > x)
            q.pop_front();
        q.push_front(x);
    }
    void del(ll x)
    {
        if (!q.empty() && q.back() == x)
            q.pop_back();
    }
    ll get()
    {
        if (!q.empty())
            return q.back();
        else
            return oo;
    }
};

int best[N + 1];

void solve(int n, exper *a, int X)
{
    vector<pair<int, int> > e;
    rep(i, 0, n)
    {
        e.push_back(mp(a[i].l, a[i].cost));
        e.push_back(mp(a[i].r + 1, -a[i].cost));
    }
    sort(e.begin(), e.end());
    multiset<int> s;
    int pos = 0;
    best[0] = -1;
    rep(i, 1, X + 1)
    {
        while (pos < sz(e) && e[pos].fi <= i)
        {
            if (e[pos].se > 0)
                s.insert(e[pos].se);
            else
                s.erase(s.find(-e[pos].se));
            pos++;
        }
        if (sz(s) == 0)
            best[i] = -1;
        else
            best[i] = *s.begin();
    }
}

int main()
{
    //freopen("a.in", "r", stdin);
    int n, X;
    scanf("%d %d", &n, &X);
    exper b[n];
    rep(i, 0, n)
        b[i].read();
    sort(b, b + n);
    solve(n, b, X);
    set<int> ppp;
    rep(i, 0, n)
    {
        ppp.insert(b[i].l - 1);
        ppp.insert(b[i].l);
        ppp.insert(b[i].r);
        ppp.insert(b[i].r + 1);
    }
    vector<exper> a;
    rep(i, 1, X + 1)
        if (best[i] != -1)
        {
            if (best[i] != -1 && (best[i - 1] != best[i] || ppp.count(i - 1) && ppp.count(i)))
                a.push_back(exper(i, i, best[i]));
            else
                a[sz(a) - 1].r = i;
        }
    n = sz(a);
    //rep(i, 0, n)
    //    cout << a[i].l << " " << a[i].r << " " << a[i].cost << endl;
    ll dp[X + 1];
    dp[X] = 0 + 1LL * X * inf;
    MinQueue q[n];
    repb(j, X - 1, -1)
    {
        rep(i, 0, n)
        {
            if (j + a[i].l <= X)
                q[i].add(dp[j + a[i].l]);
            if (j + a[i].r + 1 <= X)
                q[i].del(dp[j + a[i].r + 1]);
        }
        dp[j] = 0;
        rep(i, 0, n)
            if (j + a[i].r <= X)
                dp[j] = max(dp[j], q[i].get() - (1LL * j * inf + a[i].cost));
            else
                break;
        dp[j] += 1LL * j * inf;
    }
    /*rep(i, 0, X + 1)
        cout << dp[i] - 1LL * i * inf << " ";
    cout << endl;*/
    printf("%lld\n", dp[0]);
    return 0;
}
