#include <iostream>
#include <vector>
#include <algorithm>
#include <stdio.h>
using namespace std;

const int MAXN = 31;

struct TNode {
	int l, r;
	TNode *left, *right;
	int min, max;
	int fl[MAXN];
	bool can;
};

vector<int> num;

TNode *new_node(int l, int r) {
	return new TNode{ l, r, nullptr, nullptr, -1, -1, false };
}

TNode *build_tree(int l, int r) {
	TNode *node = new_node(l, r);
	if (r - l > 1) {
		int mid = (r + l) / 2;
		node->left = build_tree(l, mid);
		node->right = build_tree(mid, r);
	} else {
		node->min = node->max = num[l];
	}
	return node;
}

void fill_tree(TNode *node, int y, int q) {
	if (node->r - node->l == 1) {
		if (q != -1) {
			node->min = node->max = q;
		}
		node->can = true;
		return;
	}
	if (q == -1) {
		fill_tree(node->left, y, q);
		fill_tree(node->right, y, q);
	} else {
		if (node->left->r <= y) {
			fill_tree(node->right, y, q);
		} else {
			fill_tree(node->left, y, q);
		}
	}
	node->min = node->left->min;
	node->max = node->right->max;
	if (!node->left->can || !node->right->can) {
		node->can = false;
		return;
	}
	bool t = true;
	int x = 0;
	for (int i = 0; i < MAXN; i++) {
		if (node->left->fl[i] != 0 && node->left->fl[i] + node->right->fl[i] == 0) {
			t = false;
			break;
		}
		if (node->left->fl[i] != 0) {
			node->fl[i] = node->left->fl[i];
		} else {
			node->fl[i] = node->right->fl[i];
		}
		if (node->left->fl[i] == 1) {
			x |= (1 << i);
		}
		if (node->right->fl[i] == 1) {
			x |= (1 << i);
		}
	}
	if (!t) {
		node->can = false;
		return;
	}
	int u1 = node->left->max, u2 = node->right->min;
	int l = -1, r = MAXN, v1, v2;
	while (r - l > 1) {
		int mid = (r + l) / 2;
		v1 = (u1 >> mid);
		v2 = (u2 >> mid);
		if ((v1 ^ v2) == 0) {
			r = mid;
		} else {
			l = mid;
		}
	}
	int i = l;
	v1 = ((u1 >> i) & 1);
	v2 = ((u2 >> i) & 1);
	if (v1 == v2) {
	}
	if (v1 == 1) {
		if (node->fl[i] == 0) {
			node->fl[i] = 1;
		} else if (node->fl[i] == -1) {
			t = false;
		}
	} else {
		if (node->fl[i] == 0) {
			node->fl[i] = -1;
		} else if (node->fl[i] == 1) {
			t = false;
		}
	}
	if (!t) {
		node->can = false;
	} else {
		node->can = true;
	}
	return;
}

inline int get_ans(TNode *node) {
	if (!node->can) {
		return -1;
	}
	int x = 0;
	for (int i = 0; i < MAXN; i++) {
		if (node->fl[i] == 1) {
			x |= (1 << i);
		}
	}
	return x;
}

int main() {
	int n;
	scanf("%d", &n);
	num.resize(n + 1, 0);
	for (int i = 1; i <= n; i++) {
		scanf("%d", &num[i]);
	}
	TNode *tree = build_tree(1, n + 1);
	fill_tree(tree, 0, -1);
	int ans = get_ans(tree);
	printf("%d\n", ans);
	int m, y, q;
	scanf("%d", &m);
	for (int i = 0; i < m; i++) {
		scanf("%d%d", &y, &q);
		fill_tree(tree, y, q);
		int ans = get_ans(tree);
		printf("%d\n", ans);
	}
	return 0;
}