#include <iostream>
#include <stack>
#include <vector>
#include <string>
#include <bitset>
#include <list>

using namespace std;

typedef long long ll;
typedef pair<bool, bool> bbp;

ll n;
vector<bitset<30>> v;
bitset<30> ans;
bitset<30> st;

/*
pair<bool, bool> tsort(ll l, ll r, ll pos) { //can, need
	ll swp = 0;
	bool swt = false;

	for (ll j = l; j < n; j++) {
		if (v[j][pos] != v[0][pos]) { swt = true; swp = j; }
		else if (swt) {
			return { false, false };
		}
	}

	if (pos == 0) {}

	if (swt) {
		bbp p1 = tsort(l, swp, pos - 1);
		bbp p2 = tsort(swp, r, pos - 1);

		if (!p1.first || !p2.first || p1.second != p2.second) {
			return{ false, false };
		}
		else {
			ans[pos - 1] = p1.second;
		}

		if (v[0][pos] == 1) {
			return { true, true };
		}
		else {
			return { true, false };
		}
	}
	else {
		ans[pos] = 0;
		return{ true, false };
	}
}*/

struct seg {
	ll l;
	ll r;
	list<seg> sub;
	ll subord; // 0 - ord 1 - rev 2 - none
};

bool gen(ll pos, seg s) {
	if (pos == 0) { return true; }
	
	if (s.subord == 2) { return false; }
	if (st[pos]) {
		if (s.sub.size() == 2 && s.subord != ans[pos]) { return false; }
	}
	else if (s.sub.size() == 2) {
		st[pos] = 1;
		ans[pos] = s.subord;
	}

	for (auto it : s.sub) {
		if (!gen(pos - 1, it)) {
			return false;
		}
	}
	return true;
}

seg build(ll l, ll r, ll pos) {
	seg res;
	res.l = l;
	res.r = r;

	if (pos == 0) {
		return res;
	}

	for (ll i = l; i < r; i++) {
		if (v[i][pos - 1] != v[l][pos - 1]) {
			res.sub.push_back(build(l, i, pos - 1));
			l = i;
		}
	}
	res.sub.push_back(build(l, r, pos - 1));

	if (res.sub.size() > 2) {
		res.subord = 2;
	}
	else {
		res.subord = (v[res.l][pos - 1] > v[r - 1][pos - 1]);
	}

	return res;
}

int main() {
	cin >> n;

	v.resize(n);

	for (ll i = 0; i < n; i++) {
		ll x;
		cin >> x;
		v[i] = x;
	}

	list<seg> segs;
	ll ord;
	
	ll l = 0;
	for (ll i = l; i < n; i++) {
		if (v[i][29] != v[l][29]) {
			segs.push_back(build(l, i, 29));
			l = i;
		}
	}
	segs.push_back(build(l, n, 29));
	if (segs.size() > 2) {
		ord = 2;
	}
	else {
		ord = v[l][29] > v[n - 1][29];
	}

	if (ord == 2) { cout << -1; }
	else {
		bool k = true;
		ans[29] = ord;
		for (auto s : segs) {
			k = k && gen(28, s);
		}

		if (k) { ll a = ans.to_ullong(); cout << a << "\n"; }
		else { cout << -1 << "\n"; }
	}

	ll q;
	cin >> q;
	for (ll t = 0; t < q; t++) {
		ll p, r;
		cin >> p >> r;
		p--;
		v[p] = r;

		ans = 0;
		st = 0;

		list<seg> segs;
		ll ord;

		ll l = 0;
		for (ll i = l; i < n; i++) {
			if (v[i][29] != v[l][29]) {
				segs.push_back(build(l, i, 29));
				l = i;
			}
		}
		segs.push_back(build(l, n, 29));
		if (segs.size() > 2) {
			ord = 2;
		}
		else {
			ord = v[l][29] > v[n - 1][29];
		}

		if (ord == 2) { cout << -1; }
		else {
			bool k = true;
			ans[29] = ord;
			for (auto s : segs) {
				k = k && gen(28, s);
			}

			if (k) { ll a = ans.to_ullong(); cout << a << "\n"; }
			else { cout << -1 << "\n"; }
		}
	}

	return 0;
}