#include <iostream>
#include <cstdio>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>

using namespace std;
typedef pair <int, int> par;

vector <pair <int, char> > form(string & s) {
	vector <pair <int, char> > res;
	res.clear();
	pair <int, char> cur = { 0, s[0] };
	for (int i = 0; i < s.size(); i++) {
		if (cur.second == s[i]) cur.first++; else {
			res.push_back(cur);
			cur.first = 1;
			if (cur.second == '-') cur.second = '+'; else cur.second = '-';
		}
	}
	if (cur.first) res.push_back(cur);
	return res;
}

struct st {
	int pr, nx, val;
	st() {}
	st(int p, int val, int n) : val(val), pr(p), nx(n) {}
};

vector <pair <int, bool> > mv;
int lft;
st arr[1000100];

void merge(int id) {
	int pr;
	if (arr[id].pr >= 0) pr = arr[arr[id].pr].pr; else pr = -1;
	int nx;
	if (arr[id].nx < mv.size()) nx = arr[arr[id].nx].nx; else nx = mv.size();
	int ns = 0;
	if (arr[id].pr >= 0) ns += arr[arr[id].pr].val;
	if (arr[id].nx < mv.size()) ns += arr[arr[id].nx].val;
	ns += arr[id].val;
	if (pr >= 0) arr[pr].nx = id;
	if (nx < mv.size()) arr[nx].pr = id;
	arr[id].pr = pr;
	arr[id].nx = nx;
	arr[id].val = ns;
}

void rel(int id) {
	int pr = arr[id].pr, nx = arr[id].nx;
	if (pr >= 0 && !mv[pr].second && arr[pr].val > arr[id].val) {
		mv[id].second = false;
		lft--;
		merge(id);
		if (arr[id].nx < mv.size() && mv[nx].second) rel(arr[id].nx);
	} else 
	if (nx < mv.size() && !mv[nx].second && arr[nx].val > arr[id].val) {
		mv[id].second = false;
		lft--;
		merge(id);
		if (arr[id].pr >= 0 && mv[pr].second) rel(arr[id].pr);
	}
}

int main() {
	//freopen("input.txt", "r", stdin);
	ios::sync_with_stdio(false);
	int q;
	cin >> q;
	for (int t = 0; t < q; t++) {
		string s, f;
		cin >> s >> f;
		vector <pair <int, char> > ts;
		ts = form(s);
		int i = 0;
		bool un = false;
		for (pair <int, char> cur : ts) {
			char prev = f[i++];
			for (int count = 1; count < cur.first; count++) {
				if (f[i++] != prev) {
					un = true;
					break;
				}
			}
			if (un) break;
		}
		if (un) {
			cout << "No\n";
		}
		else {
			lft = 0;
			i = 0;
			mv.clear();
			for (pair <int, char> cur : ts) {
				pair <int, bool> tp;
				tp.first = cur.first;
				tp.second = (f[i] != cur.second);
				i += cur.first;
				lft += (tp.second);
				mv.push_back(tp);
			}
			vector <par> vs;

			for (int j = 0; j < mv.size(); j++) {
				arr[j] = st(j - 1, mv[j].first, j + 1);
			}
			for (int i = 0; i < mv.size(); i++) for (int j = 0; j < mv.size(); j++) {
				if (mv[j].second) rel(j);
			}
			if (lft) cout << "No\n"; else cout << "Yes\n";
		}
	}
	return 0;
}