#define make_pair mp
#define push_back pb
#define pop_back pob
#define first X
#define second Y
#define _p(x, y) pair<x, y>

#include <iostream>
#include <vector>
#include <string>
#include <stdio.h>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <iterator>
#include <queue>
#include <climits>

using namespace std;

typedef long long i64;
const int INF = 1000000007;
const i64 LINF = 1000000000000000007;
#define endl '\n'

typedef i64 vint;

int zn(int a) {
	return a / abs(a);
}

struct Vect {
	
	vint x, y;
	
	explicit Vect(vint tx = 0, vint ty = 0) {
		x = tx;
		y = ty;
	}

	vint len2() {
		return x * x + y * y;
	}

	double len() {
		return sqrt(len2());
	}

	Vect operator+(Vect a) {
		return Vect(x + a.x, y + a.y);
	}

	void operator+=(Vect a) {
		x += a.x;
		y += a.y;
	}

	Vect operator-(Vect a) {
		return Vect(x - a.x, y - a.y);
	}

	void operator-=(Vect a) { 
		x -= a.x;
		y -= a.y;
	}

	vint operator%(Vect a) {
		return x * a.y - a.x * y;
	}

	vint operator*(Vect a) {
		return x * a.x + y * a.y;
	}

	Vect operator*(vint a) {
		return Vect(x * a, y * a);
	}

	void operator*=(vint a) {
		x *= a;
		y *= a;
	}

};

Vect invect() {
	int x, y;
	scanf("%d%d", &x, &y);
	return Vect(x, y);
}

void quest(int i, int j, int z) {
	printf("? 3 %d %d %d\n", i + 1, j + 1, z + 1);
	fflush(stdout);
}

void ans(int i, int j, int z) {
	printf("! 3 %d %d %d\n", i + 1, j + 1, z + 1);
	fflush(stdout);
}

int main() {

	int n;
	cin >> n;

	vector < Vect > vs(n);
	for (int i = 0; i < n; i++) {
		vs[i] = invect();
	}

	int q;
	cin >> q;

	vector < vector < vector < char > > > vars(n, vector < vector < char > >(n, vector < char >(n, false)));

	int s;
	Vect a, b;
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			for (int z = j + 1; z < n; z++) {
				for (int k = 0; k < n && !vars[i][j][z]; k++) {
					if (k == i || k == j || k == z)
						continue;
					s = ((vs[k].x < vs[i].x && vs[k].y == vs[i].y) + (vs[k].x < vs[j].x && vs[k].y == vs[j].y) + (vs[k].x < vs[z].x && vs[k].y == vs[z].y));

					a = vs[i];
					b = vs[j]; 
					if (a.y > b.y)
						swap(a, b);
					if ((b - a) % (vs[k] - a) > 0) {
						s += (a.y < vs[k].y && vs[k].y < b.y);
					}

					a = vs[i];
					b = vs[z];
					if (a.y > b.y)
						swap(a, b);
					if ((b - a) % (vs[k] - a) > 0) {
						s += (a.y < vs[k].y && vs[k].y < b.y);
					}

					a = vs[z];
					b = vs[j];
					if (a.y > b.y)
						swap(a, b);
					if ((b - a) % (vs[k] - a) > 0) {
						s += (a.y < vs[k].y && vs[k].y < b.y);
					}

					if (s % 2)
						vars[i][j][z] = true;
				}
			}
		}
	}

	bool done;
	string buff;
	for (int cq = 0; cq < q; cq++) {
		done = false;
		for (int i = 0; i < n && !done; i++) {
			for (int j = i + 1; j < n && !done; j++) {
				for (int z = j + 1; z < n && !done; z++) {
					if (vars[i][j][z])
						continue;
					quest(i, j, z);
					cin >> buff;
					if (buff == "Yes") {
						done = true;
						ans(i, j, z);
					}
				}
			}
		}
	}

	return 0;
}