#define first X
#define second Y
#define push_back pb
#define pop_back pob
#define make_pair mp
#define _p(x, y) pair<x, y>

#include <iostream>
#include <set>
#include <map>
#include <stdio.h>
#include <string>
#include <vector>
#include <queue>
#include <algorithm>
#include <cmath>
#include <iterator>
#include <climits>

using namespace std;

typedef long long i64;
#define endl '\n'

const int INF = 1000000007;
const i64 LINF = 1000000000000000007;

struct dsu {

	vector < int > data, sz;

	explicit dsu(int n) {
		data.resize(n);
		sz.resize(n, 1);
		for (int i = 0; i < n; i++) {
			data[i] = i;
		}
	}

	int get(int a) {
		if (data[a] == a) {
			return a;
		}

		return data[a] = get(data[a]);
	}

	int unite(int a, int b) {

		if (a == -1)
			return b;
		if (b == -1)
			return a;

		a = get(a);
		b = get(b);

		if (a == b)
			return a;

		if (sz[a] > sz[b]) {
			data[b] = a;
			sz[a] += sz[b];
			return a;
		}
		else {
			data[a] = b;
			sz[b] += sz[a];
			return b;
		}

		return -1;
	}

};

struct seg {

	int l, r;
	int size;
	char c;
	bool ch;

	explicit seg(int tl, int tr, int ts, int tc, bool ch = false) {
		l = tl;
		r = tr;
		size = ts;
		c = tc;
		this->ch = ch;
	}

};

int main() {

#ifdef _DEBUG
	freopen("A.txt", "r", stdin);
#endif

	ios::sync_with_stdio(NULL);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;

	string s1, s2;
	vector < seg > gr;
	int l, r;
	bool bad;
	queue < int > q;
	int cur;
	int nid, pid;
	int ns, nl, nr;
	char nc;
	bool changed;
	for (int tc = 0; tc < n; tc++) {
		gr.clear();
		bad = false;
		cin >> s1 >> s2;

		if (s1 == s2) {
			cout << "Yes" << endl;
			continue;
		}

		for (int i = 0; i < s1.size() && !bad; i++) {
			if (!i || s1[i - 1] != s1[i]) {
				gr.pb(seg(i, i - 1, 0, s1[i], s1[i] != s2[i]));
			}

			if ((s1[i] == s2[i] && gr.back().ch) || (s1[i] != s2[i] && !gr.back().ch)) {
				bad = true;
				continue;
			}
			gr[gr.size() - 1].r++;
			gr[gr.size() - 1].size++;
		}
		dsu desu(gr.size());
		for (int i = 0; i < gr.size() && !bad; i++) {

			if (i && gr[i - 1].ch && gr[i].ch) {
				bad = true;
				continue;
			}

			gr[i].l = i - 1;
			gr[i].r = i + 1;
			if (i == gr.size() - 1)
				gr[i].r = -1;
			if (!gr[i].ch) {
				q.push(i);
			}
		}

		while (q.size() && !bad) {
			changed = false;
			cur = q.front();
			q.pop();
			if (gr[cur].l != -1) {
				nid = gr[cur].l;
				if (gr[nid].ch && gr[nid].size < gr[cur].size) {
					nr = gr[cur].r;
					nl = gr[nid].l;
					ns = gr[cur].size + gr[nid].size;

					if (nl != -1) {
						ns += gr[nl].size;
						nl = gr[nl].l;
					}

					nc = gr[cur].c;
					cur = desu.unite(desu.unite(cur, nid), gr[nid].l);
					gr[cur].c = nc;
					gr[cur].ch = false;
					gr[cur].size = ns;
					gr[cur].l = nl;
					gr[cur].r = nr;

					if ((gr[cur].l != -1 && gr[gr[cur].l].c == gr[cur].c) || (gr[cur].r != -1 && gr[gr[cur].r].c == gr[cur].c)) {
						bad = true;
						continue;
					}

					changed = true;
				}
			}

			if (gr[cur].r != -1 && !bad) {
				nid = gr[cur].r;
				if (gr[nid].ch && gr[nid].size < gr[cur].size) {
					nr = gr[nid].r;
					nl = gr[cur].l;
					ns = gr[cur].size + gr[nid].size;

					if (nr != -1) {
						ns += gr[nr].size;
						nr = gr[nr].r;
					}

					nc = gr[cur].c;
					cur = desu.unite(desu.unite(cur, nid), gr[nid].r);
					gr[cur].c = nc;
					gr[cur].ch = false;
					gr[cur].size = ns;
					gr[cur].l = nl;
					gr[cur].r = nr;

					if ((gr[cur].l != -1 && gr[gr[cur].l].c == gr[cur].c) || (gr[cur].r != -1 && gr[gr[cur].r].c == gr[cur].c)) {
						bad = true;
						continue;
					}

					changed = true;
				}
			}

			if (changed) {
				q.push(cur);
			}
		}

		for (int i = 0; i < gr.size() && !bad; i++) {
			if (gr[desu.get(i)].ch)
				bad = true;
		}

		if (bad)
			cout << "No" << endl;
		else
			cout << "Yes" << endl;

		while (q.size())
			q.pop();
	}

	return 0;
}