#include <bits/stdc++.h>

using namespace std;

struct node{
    int x, y, sz;
    node *l, *r;

    node () {}

    node (int x) : x(x), y(rand()), sz(1), l(nullptr), r(nullptr) {}
};

int get_sz(node *T){
    if (T == nullptr)
        return 0;
    return T->sz;
}

void recalc(node *T){
    T->sz = get_sz(T->l) + get_sz(T->r) + 1;
    return;
}

node* merge(node *L, node *R){
    if (L == nullptr)
        return R;
    if (R == nullptr)
        return L;

    if (L->y > R->y){
        L->r = merge(L->r, R);
        recalc(L);
        return L;
    }

    R->l = merge(L, R->l);
    recalc(R);
    return R;
}

pair<node*, node*> split(node *T, int key, int le = 0){
    if (T == nullptr)
        return {nullptr, nullptr};

    if (get_sz(T->l) + le <= key){
        auto tmp = split(T->r, key, le + get_sz(T->l));
        T->r = tmp.second;
        recalc(T);
        return {tmp.first, T};
    }

    auto tmp = split(T->l, key, le);
    T->l = tmp.second;
    recalc(T);
    return {tmp.second, T};
}

int main()
{
    //ifstream cin("sequence.in");
    //ofstream cout("sequence.out");
    //ios_base::sync_with_stdio(0);
    freopen("sequence.in", "r", stdin);
    freopen("sequence.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    srand(time(NULL));

    node *root = nullptr;

    long long x;
    while (cin >> x){
        node *v = new node(x);
        root = merge(root, v);
    }
    for (int i = 0; i < 1000000; i++)
        cin >> x;

    for (int i = (int)ve.size() - 1; i >= 0; i--)
        cout << ve[i] << ' ';
    cout << '\n';
    return 0;
}
