#include <iostream>
#include <stack>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>
#include <queue>
#include <map>
#include <set>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ld, ld> pll;
#define all(s) s.begin(), s.end()
struct edge {
	int w, to, num;
};
vector<vector<edge> > g, gr;
bool operator<(pair<pair<ll, pair<ll, map<ll, ll> > >, ll> a, pair<pair<ll, pair<ll, map<ll, ll> > >, ll> b) {
	if (a.first.first < b.first.first)
		return 1;
	if (a.first.first == b.first.first && a.first.second.first > b.first.second.first)
		return 1;
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	g.resize(n);
	gr.resize(n);
	for (int j = 0; j < m; j++) {
		int s;
		cin >> s;
		int from = -1;
		for (int i = 0; i < s; i++) {
			if (from == -1) {
				cin >> from;
				from--;
			}
			int w, to;
			cin >> w >> to;
			to--;
			g[from].push_back(edge{ w, to, j });
			gr[to].push_back(edge{ w, from, j });
			from = to;
		}
	}
	vector<ll> d(n, 1e15);
	d[0] = 0;
	set<pair<ll, ll> > q;
	q.insert({ d[0], 0 });
	while(!q.empty()){
		int v = q.begin()->second;
		q.erase(q.begin());
		for (auto t : g[v]) {
			if (d[v] + t.w < d[t.to]) {
				q.erase({ d[t.to], t.to });
				d[t.to] = d[v] + t.w;
				q.insert({ d[t.to], t.to });
			}
		}
	}
	ll len = d[n - 1];
	vector<ll> level(n, 1e7);
	vector < pair<ll, map<ll, ll> > > dp(n);
	vector<vector<pair<int, int> > > p(n);
	queue<int> qe;
	qe.push(n - 1);
	level[n - 1] = 0;
	while (!qe.empty()) {
		int v = qe.front();
		qe.pop();
		for (auto t : gr[v]) {
			if (level[v] + 1 < level[t.to] && d[t.to] == d[v] - t.w) {
				level[t.to] = level[v] + 1;
				qe.push(t.to);
			}
			if (level[v] + 1 == level[t.to]) {
				for (auto t1 : p[v]) {
					if (t1.second == t.num) {
						if (dp[v].first - dp[v].second[t.num] * dp[v].second[t.num] + (dp[v].second[t.num] + t.w) * (dp[v].second[t.num] + t.w) > dp[t.to].first) {
							dp[t.to].first = dp[v].first - dp[v].second[t.num] * dp[v].second[t.num] + (dp[v].second[t.num] + t.w) * (dp[v].second[t.num] + t.w);
							dp[t.to].second = dp[v].second;
							dp[t.to].second[t.num] += t.w;
							p[t.to].clear();
							p[t.to].push_back({ v, t.num });
						}
						else
							if (dp[v].first - dp[v].second[t.num] * dp[v].second[t.num] + (dp[v].second[t.num] + t.w) * (dp[v].second[t.num] + t.w) == dp[t.to].first) {
								dp[t.to].second = dp[v].second;
								dp[t.to].second[t.num] += t.w;
								p[t.to].push_back({ v, t.num });
							}
					}
					else {
						if (dp[v].first - dp[v].second[t.num] * dp[v].second[t.num] + t.w * t.w > dp[t.to].first) {
							dp[t.to].first = dp[v].first - dp[v].second[t.num] * dp[v].second[t.num] + t.w * t.w;
							dp[t.to].second = dp[v].second;
							dp[t.to].second[t.num] = t.w;
							p[t.to].clear();
							p[t.to].push_back({ v, t.num });
						}else
							if (dp[v].first - dp[v].second[t.num] * dp[v].second[t.num] + t.w * t.w == dp[t.to].first) {
								dp[t.to].second = dp[v].second;
								dp[t.to].second[t.num] = t.w;
								p[t.to].push_back({ v, t.num });
							}
					}

				}
				if (p[v].size() == 0) {
					if (dp[v].first - dp[v].second[t.num] * dp[v].second[t.num] + t.w * t.w > dp[t.to].first) {
						dp[t.to].first = dp[v].first - dp[v].second[t.num] * dp[v].second[t.num] + t.w * t.w;
						dp[t.to].second = dp[v].second;
						dp[t.to].second[t.num] = t.w;
						p[t.to].clear();
						p[t.to].push_back({ v, t.num });
					}
					else
						if (dp[v].first - dp[v].second[t.num] * dp[v].second[t.num] + t.w * t.w == dp[t.to].first) {
							dp[t.to].second = dp[v].second;
							dp[t.to].second[t.num] = t.w;
							p[t.to].push_back({ v, t.num });
						}
				}
			}
		}
	}
	cout << d[n - 1] << ' ' << dp[0].first;
}