#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>

using namespace std;
#define ll long long

const ll INF = 1e9;
const int MAXN = 500001;
ll t[2 * MAXN];
int n;

void build() {
	for (int i = n; i < n + n; ++i)
		t[i] = INF * (i - n);
	for (int i = n - 1; i > 0; --i)
		t[i] = min(t[2 * i], t[2 * i + 1]);
}

ll get(int l, int r) {
	ll ans = INF * INF;
	for (l += n, r += n; l < r; l /= 2, r /= 2) {
		if (l & 1)
			ans = min(ans, t[l++]);
		if (r & 1)
			ans = min(ans, t[--r]);
	}
	return ans;
}

void change(int i, ll x) {
	i += n;
	if (t[i] >= x)
		return;
	t[i] = x;
	for (i /= 2; i > 0; i /= 2)
		t[i] = min(t[2 * i + 1], t[2 * i]);
}



int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	int am;
	cin >> am >> n;
	n++;
	build();
	vector <int> l(am), r(am), c(am);

	for (int i = 0; i < am; ++i)
		cin >> l[i] >> r[i] >> c[i];

	for (int i = n - 1; i >= 0; --i) {
		for (int it = 0; it < am; ++it) {
			if (i + r[it] >= n)
				continue;

			int lwas = i + l[it], rwas = i + r[it];
			ll got = get(lwas, rwas + 1);
			change(i, got - c[it]);
		}
	}
	cout << t[n] << '\n';
}