#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

struct Vector {
    ll x, y;

    Vector(): x(0), y(0) {}
    Vector(ll x, ll y): x(x), y(y) {}

    Vector operator-(const Vector &other) const {
        return Vector(x - other.x, y - other.y);
    }

    Vector to(const Vector &other) const {
        return other - *this;
    }

    ll cross(const Vector &other) const {
        return x * other.y - y * other.x;
    }
};

istream& operator>>(istream &in, Vector &v) {
    in >> v.x >> v.y;
    return in;
}

typedef Vector Vec;

const int MAX_N = 5000;

int n;
Vec pts[MAX_N];

ull triArea(int i1, int i2, int i3) {
    Vec p1 = pts[i1], p2 = pts[i2], p3 = pts[i3];
    return abs(p1.to(p2).cross(p1.to(p3)));
}

void solve() {
    ull minArea = 0;
    int idx[] = {-1, -1, -1};
    for (int i1 = 0; i1 < n; i1++)
    for (int i2 = i1 + 1; i2 < n; i2++)
    for (int i3 = i2 + 1; i3 < n; i3++) {
        cout << "? " << i1 + 1 << " " << i2 + 1 << " " << i3 + 1 << endl;
        cout.flush();
        string ans;
        cin >> ans;
        if (ans[0] == 'Y') {
            ull na = triArea(i1, i2, i3);
            if (minArea == 0 || na < minArea) {
                minArea = na;
                idx[0] = i1;
                idx[1] = i2;
                idx[2] = i3;
            }
        }
    }

    cout << "! ";
    for (int i = 0; i < 3; i++)
        cout << idx[i] + 1 << " ";
    cout << endl;
    cout.flush();
}

int main() {
    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> pts[i];

    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        solve();
    }
}
