#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <stack>

using namespace std;

struct Point {
	long long x, y, i;
	Point() {}
	Point(long long x, long long y, long long i) : x(x), y(y), i(i) {}
	long long operator ^(const Point a) const {
		long long ans = x * a.y - y * a.x;
		if (ans > 0)
			return 1;
		if (ans < 0)
			return -1;
		return 0;
	}
	Point operator - (const Point a) const {
		return{ x - a.x, y - a.y, -1 };
	}
	bool operator ==(const Point a) const {
		return x == a.x && y == a.y;
	}
};

vector < vector < Point > > conv;

const long long MX = 300;

int main() {
	iostream::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);

	int n;
	cin >> n;

	Point O{ (long long)1e9, (long long)1e9, -1 };

	vector < Point > all(n);
	for (int i = 0; i < n; i++) {
		long long x, y;
		cin >> x >> y;
		all[i] = { x, y, i };
		if (all[i].x < O.x || (all[i].x == O.x && all[i].y < O.y))
			O = all[i];

	}

	vector < vector < long long > > w;


	sort(all.begin(), all.end(), [O](const Point a, const Point b) {
		if (a == O)
			return true;
		if (b == O)
			return false;
		return ((a - O) ^ (b - O)) > 0;
	}
	);
	vector < Point > cur;
	cur.push_back(all[1]);
	for (int i = 1; i < n - 1; i++) {
		w.push_back({ all[0].i, all[i].i, all[i + 1].i });
		vector < Point > temp;
		while (cur.size() > 1 && ((all[i + 1] - cur.back()) ^ (cur.back() - cur[cur.size() - 2])) > 0) {
			temp.push_back(cur.back());
			cur.pop_back();
		}
		if (temp.size()) {
			w.emplace_back();
			w[w.size() - 1].push_back(all[i + 1].i);
			for (auto j : temp)
				w[w.size() - 1].push_back(j.i);
			w[w.size() - 1].push_back(cur.back().i);
		}
		cur.push_back(all[i + 1]);
	}


	int q;
	cin >> q;

	while (q--) {
		for (auto a : w) {
			cout << "? " << a.size() << ' ';
			for (int i : a)
				cout << i + 1 << ' ';
			cout << endl;
			string s;
			cin >> s;
			if (s == "Yes") {
				cout << "! " << a.size() << ' ';
				for (int i : a)
					cout << i + 1 << ' ';
				cout << endl;
				break;
			}
		}
	}

	return 0;
}