#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <stack>

using namespace std;

const long long MX = 1e5 + 1;
long long dp[MX];
const long long INF = 1e9, IINF = 1e18;

struct min_queue {
	stack < long long > r, rm, l, lm;
	void push(long long x) {
		r.push(x);
		rm.push(min(rm.empty() ? IINF : rm.top(), x));
	}
	void pop() {
		if (l.empty()) {
			while (!r.empty()) {
				long long x = r.top();
				l.push(x);
				lm.push(min(lm.empty() ? IINF : lm.top(), x));
				r.pop();
				rm.pop();
			}
		}
		l.pop();
		lm.pop();
	}
	long long get() {
		return min((lm.empty() ? IINF : lm.top()), (rm.empty() ? IINF : rm.top()));
	}
};

int main() {
	iostream::sync_with_stdio(0);

	int n, a;
	cin >> n >> a;

	vector < pair < pair < long long, long long >, long long > > q(n);
	vector < pair < pair < int, int >, int > > ev;
	for (int i = 0; i < n; i++) {
		long long l, r, c;
		cin >> l >> r >> c;
		q[i] = { { l, r }, c };
		ev.push_back({ { l, c }, r });
		ev.push_back({ { r + 1, -c }, r });
	}

	sort(ev.begin(), ev.end());

	vector < pair < int, int > > price(a + 1, { -1, 1e9 });
	multiset < pair < int, int > > vals;
	int pn = 0;
	for (int i = 0; i <= a; i++) {
		while (pn < ev.size() && ev[pn].first.first == i) {
			int x = ev[pn].second;
			if (x > 0)
				vals.insert({ x, ev[pn].second });
			else
				vals.erase(vals.find({ -x, ev[pn].second }));
			pn++;
		}
		if (!vals.empty())
			price[i] = *vals.begin();
	}

	vector < pair < pair < long long, long long >, long long > > nw;
	int pr = -1, l = -1;
	for (int i = 0; i <= a; i++) {
		if (pr == price[i].first)
			continue;
		if (pr != -1)
			nw.push_back({ {l, price[i - 1].second}, pr });
		l = i;
		pr = price[i].first;
	}
	if (pr != -1)
		nw.push_back({ { l, price[a].second }, pr });
	q = nw;
	n = q.size();

	vector < min_queue > all(n);
	for (int i = 0; i <= a; i++) {
		for (int j = 0; j < n; j++) {
			int l = q[j].first.first, r = q[j].first.second, c = q[j].second;
			if (i - r < 0) {
				if (i - l + 1 >= 0)
					all[j].push(dp[i - l + 1] - (i - l + 1) * INF);
				continue;
			}
			
			long long worst = all[j].get();
			worst += i * INF;
			dp[i] = max(dp[i], worst - c);
			if (i - l + 1 >= 0)
				all[j].push(dp[i - l + 1] - (i - l + 1) * INF);
			all[j].pop();
		}
	}

	long long mx = 0;
	for (long long i = 0; i <= a; i++)
		mx = max(mx, dp[i]);

	cout << mx;

	return 0;
}