#include <iostream>
#include <string>
#include <algorithm>
#include <map>
#include <vector>

using namespace std;


int n;
const int BITS = 32;

vector<vector<bool>> bits;
vector<int> inp;

int vote(int l, int r, int bit)
// 0 - we need to NOT flip
// 1 - we need to flip
// 2 - we don't care
// 3 - we failed
{
	if (bit == -1)
		return 2;
	int ans = 0;
	// first, check if we don't care
	bool id = bits[bit][l];
	bool flag = true;
	int edge = -1;
	for (int i = l; i < r; ++i)
	{
		if (bits[bit][i] != id)
		{
			flag = false;
			edge
			break;
		}
	}
	if (flag)
		return 2;
	if (bits[bit].get(0, 0, n, l, edge) && bits[bit].get(0, 0, n, edge, r))
	{
		if (bits[bit].w[l])
			return 1;
		return 0;
	}
	else
	{
		return 3;
	}
}


int solve(int l, int r, int bit, int v, bool q)
{
	if (bit == -1)
		return 0;
	if (v == 3)
		return -1;
	int ans = 0;
	if ((v == 1) || ((v == 2) && q))
		ans = (1 << bit);
	if (v != 2)
	{
		int edge = bits[bit].getedge(l, r);
		int v1 = vote(l, edge, bit - 1);
		int v2 = vote(edge, r, bit - 1);
		if (v1 == 3) return -1;
		if (v2 == 3) return -1;
		if (v1 != 2 && v2 != 2 && v1 != v2) return -1;
		int qn = 0;
		if (v1 == 1)
			qn = 1;
		if (v2 == 1)
			qn = 1;
		int s1 = solve(l, edge, bit - 1, v1, qn);
		int s2 = solve(edge, r, bit - 1, v2, qn);
		return ans | s1 | s2;
	}
	else
	{
		return ans | solve(l, r, bit - 1, vote(l, r, bit - 1), 0);
	}
	return ans;
}

int main()
{
	cin >> n;
	for (int i = 0; i < n; ++i)
	{
		int t;
		cin >> t;
		inp.push_back(t);
	}

	bits.resize(BITS);
	for (int i = 0; i < BITS; ++i)
	{
		bits[i].w.resize(n);
		for (int b = 0; b < n; ++b)
		{
			bits[i].w[b] = (inp[b] >> i) & 1;
		}
		bits[i].init();
		bits[i].build(0, 0, n);
	}
	int sol = solve(0, n, BITS - 1, vote(0, n, BITS - 1), 0);
	cout << sol << endl;
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i)
	{
		int v, x;
		cin >> v >> x;
		v--;
		inp[v] = x;
		for (int bit = 0; bit < BITS; ++bit)
		{
			bits[bit].modify(0, 0, n, v, (x >> bit) & 1);
		}
		int sol = solve(0, n, BITS - 1, vote(0, n, BITS - 1), 0);
		cout << sol << endl;
	}
	return 0;
}