#include <iostream>
#include <string>
#include <vector>
#include <tuple>
#include <algorithm>


using namespace std;

struct seg
{
	char s;
	char t;
	int len;
	bool diff() { return s != t; };
	bool compress()
	{
		int pressure = -1;
		if (prev)
			pressure = max(pressure, prev->rlen);
		if (next)
			pressure = max(pressure, next->rlen);
		if (pressure > rlen)
		{
			s = t;
			if (prev)
			{
				rlen += prev->rlen;
				if (prev->prev)
					prev->prev->next = this;
				prev = prev->prev;
			}
			if (next)
			{
				rlen += next->rlen;
				if (next->next)
					next->next->prev = this;
				next = next->next;
			}
			return true;
		}
		return false;
	}
	seg* prev;
	seg* next;
	int rlen;
	bool fake = false;
};

bool solve()
{
	string s, t;
	cin >> s >> t;

	int n = s.length();
	for (int i = 1; i < n; ++i)
	{
		if ((s[i] == s[i - 1]) && (t[i] != t[i - 1])) return false;
	}

	vector<seg*> segs;
	int ll = 1;
	for (int i = 1; i < n; ++i)
	{
		if (s[i] != s[i - 1])
		{
			seg* q = new seg();
			q->s = s[i - 1];
			q->t = t[i - 1];
			q->len = ll;
			q->rlen = ll;
			ll = 0;
			if (!segs.empty())
			{
				q->prev = segs.back();
				segs.back()->next = q;
			}
			segs.push_back(q);
		}
		ll++;
	}
	seg* q = new seg();
	q->s = s[n - 1];
	q->t = t[n - 1];
	q->len = ll;
	q->rlen = ll;
	ll = 0;
	if (!segs.empty())
	{
		q->prev = segs.back();
		segs.back()->next = q;
	}
	segs.push_back(q);

	int sz = segs.size();
	for (int i = 1; i < sz; ++i)
	{
		if (segs[i]->diff() && segs[i - 1]->diff())
			return false;
	}
	vector<vector<seg*>> G;
	for (int i = 0; i < sz; i++)
	{
		if (segs[i]->diff())
		{
			G.push_back(vector<seg*>());
			for (; (i < sz) && segs[i]->diff(); i += 2)
				(G.end() - 1)->push_back(segs[i]);
		}
	}
	for (auto g : G)
	{
		if (g.front()->prev) g.front()->prev->prev = nullptr;
		if (g.back()->next) g.back()->next->next = nullptr;
		if (!g.front()->prev && !g.front()->next) return false;
		while (true)
		{
			bool flag = false;
			for (seg* cur : g)
			{
				bool succ = cur->compress();
				flag |= succ;
			}
			if (!flag)
			{
				if (!g.front()->prev && !g.front()->next)
					break;
				else
					return false;
			}
		}
	}
	return true;
}

int main()
{
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) cout << (solve() ? "Yes" : "No") << endl;
	return 0;
}