#include <iostream>
#include <vector>
#include <bitset>

using namespace std;

struct diff
{
	vector<long long> w;
	vector<bitset<512>> b;
	void init()
	{
		b.resize(w.size() * 4);
	}

	void build(long long v, long long vl, long long vr)
	{
		long long vm = (vl + vr) / 2;
		if (vr - vl == 1)
		{
			b[v].set(w[vl], true);
			return;
		}
		build(2 * v + 1, vl, vm);
		build(2 * v + 2, vm, vr);
		b[v] = b[2 * v + 1] | b[2 * v + 2];
	}

	bitset<512> get(long long v, long long vl, long long vr, long long l, long long r)
	{
		if (vl >= l && vr <= r)
			return b[v];
		if (r <= vl || l >= vr)
			return bitset<512>(0);
		long long vm = (vl + vr) / 2;
		return get(2 * v + 1, vl, vm, l, r) | get(2 * v + 2, vm, vr, l, r);
	}
};

struct sum
{
	vector<long long> w;
	vector<long long> b;
	void init()
	{
		b.resize(w.size() * 4);
	}

	void build(long long v, long long vl, long long vr)
	{
		long long vm = (vl + vr) / 2;
		if (vr - vl == 1)
		{
			b[v] = w[vl];
			return;
		}
		build(2 * v + 1, vl, vm);
		build(2 * v + 2, vm, vr);
		b[v] = b[2 * v + 1] + b[2 * v + 2];
	}

	long long get(long long v, long long vl, long long vr, long long l, long long r)
	{
		if (vl >= l && vr <= r)
			return b[v];
		if (r <= vl || l >= vr)
			return 0;
		long long vm = (vl + vr) / 2;
		return get(2 * v + 1, vl, vm, l, r) + get(2 * v + 2, vm, vr, l, r);
	}
};

int main()
{
	long long n, m;
	cin >> n >> m;
	vector<long long> d1(n);
	vector<long long> d2(m);
	vector<long long> p1(n);
	vector<long long> p2(m);
	long long sp1 = 0;
	long long sp2 = 0;
	for (long long i = 0; i < n; ++i)
	{
		cin >> d1[i];
	}
	for (long long i = 0; i < n; ++i)
	{
		cin >> p1[i];
		sp1 += p1[i];
	}
	for (long long i = 0; i < m; ++i)
	{
		cin >> d2[i];
	}
	for (long long i = 0; i < m; ++i)
	{
		cin >> p2[i];
		sp2 += p2[i];
	}

	diff dt1;
	dt1.w = d1;
	dt1.init();
	dt1.build(0, 0, n);
	diff dt2;
	dt2.w = d2;
	dt2.init();
	dt2.build(0, 0, m);

	sum pt1;
	pt1.w = p1;
	pt1.init();
	pt1.build(0, 0, n);
	sum pt2;
	pt2.w = p2;
	pt2.init();
	pt2.build(0, 0, m);

	long long mp = -1;
	long long ml1, ml2, mr1, mr2;

	for (long long l1 = 0; l1 < n; ++l1)
	{
		for (long long r1 = l1; r1 < n; ++r1)
		{
			for (long long l2 = 0; l2 < m; ++l2)
			{
				for (long long r2 = l2; r2 < m; ++r2)
				{
					long long total = (r1 - l1 + 1) + (r2 - l2 + 1);
					long long dist = (dt1.get(0, 0, n, l1, r1 + 1) | dt2.get(0, 0, m, l2, r2 + 1)).count();
					if (dist < total)
						continue;
					long long pr = pt1.get(0, 0, n, l1, r1 + 1) + pt2.get(0, 0, m, l2, r2 + 1);
					if (mp < pr)
					{
						mp = pr;
						ml1 = l1;
						ml2 = l2;
						mr1 = r1;
						mr2 = r2;
					}
				}
			}
		}
	}

	if (sp1 > mp)
	{
		mp = sp1;
		ml1 = 0;
		mr1 = n - 1;
		ml2 = -1;
		mr2 = -1;
	}

	if (sp2 > mp)
	{
		mp = sp2;
		ml1 = -1;
		mr1 = -1;
		ml2 = 0;
		mr2 = m - 1;
	}

	cout << mp << endl;
	cout << ml1 + 1 << " " << mr1 + 1 << endl;
	cout << ml2 + 1 << " " << mr2 + 1 << endl;
	return 0;
}