#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const ld EPS = 1e-2;

struct P {
    ll x, y;
    P(ll x, ll y) : x(x), y(y) {}

    ld operator^(P b) {
        return ld((x * b.y - y * b.x)) / 2.;
    }

    P operator-(P b) {
        return P(x - b.x, y - b.y);
    }
};

struct R {
    ll a, b, c;
    R(ll a, ll b, ll c) : a(a), b(b), c(c) {}
};

vector<P> p;
vector<R> rects;

bool check(int x, int a, int b, int c) {
    if (x == a || x == b || x == c) {
        return false;
    }

    ld now = fabs((p[a] - p[x]) ^ (p[c] - p[x])) + fabs((p[a] - p[x]) ^ (p[b] - p[x])) + fabs((p[b] - p[x]) ^ (p[c] - p[x]));
    ld real = fabs(fabs((p[a] - p[b]) ^ (p[c] - p[b])));

    if (fabs(now - real) < EPS) {
        return true;
    }
    return false;
}

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);

    int n;
    cin >> n;

    ll x, y;
    for (int i = 0; i < n; ++i) {
        cin >> x >> y;
        p.push_back(P(x, y));
    }
    int q;
    cin >> q;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            for (int k = j + 1; k < n; ++k) {
                bool flag = true;
                for (int c = 0; c < n; ++c) {
                    if (check(c, i, j, k)) {
                        flag = false;
                    }
                }
                if (flag) {
                    rects.push_back({i, j, k});
                }
            }
        }
    }


    for (int f = 0; f < q; ++f) {
            for (auto x : rects) {
                    cout << "? 3 " << x.a + 1 << " " << x.b + 1 << " " << x.c + 1 << endl;
                    string res;
                    cin >> res;
                    if (res == "Yes") {
                        cout << "! 3 " << x.a + 1 << " " << x.b + 1 << " " << x.c + 1 << endl;
                    }
            }
        }
    }

    return 0;
}
