import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.LinkedList;
import java.util.StringTokenizer;

public class A {
	static BufferedReader bf;
	
	public static void main(String[] args) throws IOException {
		bf = new BufferedReader(new InputStreamReader(System.in));
		
		int n = Integer.parseInt(read());

		LinkedList<Line> arr = new LinkedList<>();

		int last = -1;

		for (int i = 0; i < n - 1; i++) {
			ask(i, i + 1);

			String ans = read();

			if (ans.equals("Yes")) {
				arr.add(new Line(i).buf(Math.min(i - last, n - i - 1)));

				while (true) {
					Line l = arr.removeLast();

					if (arr.isEmpty()) {
						arr.add(l);

						break;
					}

					if (arr.getLast().end + 1 == l.start) {
						l = arr.removeLast().union(l);

						if (arr.isEmpty()) {
							last = -1;
						} else {
							last = arr.getLast().end;
						}

						arr.add(l.buf(Math.min(l.start - last - 1, n - l.end - 1) + (l.end - l.start + 1) / 2));
					} else {
						arr.add(l);
						break;
					}
				}

				last = arr.getLast().end;
				i = last;
			}
		}
		
		System.out.println("! " + arr.getLast().str);
	}

	public static class Line {
		public String str;
		public int start;
		public int end;

		public Line(int i) {
			str = "()";
			start = i;
			end = i + 1;
		}

		public Line(String str, int s, int e) {
			this.str = str;
			start = s;
			end = e;
		}

		public Line union(Line that) {
			String str = this.str + that.str;

			return new Line(str, this.start, that.end);
		}

		public Line buf(int maxL) throws IOException {
			int left = (end - start + 1) / 2;
			int right = maxL + 1;

			int centrum = (start + end) / 2;

			while (left + 1 < right) {
				int mid = (left + right) / 2;

				ask(centrum - mid + 1, centrum + mid);

				if (read().equals("Yes")) {
					left = mid;
				} else {
					right = mid;
				}
			}

			StringBuilder st = new StringBuilder();

			for (int i = centrum - left + 1; i < start; i++) {
				st.append("(");
			}

			st.append(str);

			for (int i = end + 1; i <= centrum + left; i++) {
				st.append(")");
			}

			return new Line(st.toString(), centrum - left + 1, centrum + left);
		}
	}

	private static void ask(int i, int j) {
		i++;
		j++;
		System.out.println("? " + i + " " + j);
		System.out.flush();
	}

	private static String read() throws IOException {
		StringTokenizer st = new StringTokenizer(bf.readLine());

		return st.nextToken();
	}
}
