import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class B {
	static BufferedReader br;
	static PrintWriter out;

	public static void main(String[] args) throws IOException {
		br = new BufferedReader(new FileReader(new File("servers.in")));
		out = new PrintWriter(new File("servers.out"));

		solve();

		br.close();
		out.close();
	}

	private static void solve() throws IOException {
		StringTokenizer st = new StringTokenizer(br.readLine());
		int n = Integer.parseInt(st.nextToken());
		
		if (n == 1) {
			out.println(0);
			return;
		}
		
		int[] arr = new int[n];

		st = new StringTokenizer(br.readLine());
		for (int i = 0; i < n; i++) {
			arr[i] = Integer.parseInt(st.nextToken());
		}

		Pair[] gape = new Pair[n + 1];

		gape[0] = new Pair(Integer.MIN_VALUE, Integer.MAX_VALUE);
		gape[n] = new Pair(Integer.MIN_VALUE, Integer.MAX_VALUE);

		for (int i = 1; i < n; i++) {
			st = new StringTokenizer(br.readLine());

			gape[i] = new Pair(Integer.parseInt(st.nextToken()), Integer.parseInt(st.nextToken()));
		}

		Pair[] ans1 = new Pair[n];
		Pair[] ans2 = new Pair[n];

		ans1[0] = new Pair(0, gape[1].right);
		ans2[n - 1] = new Pair(0, gape[n - 1].right);
		
		
		for (int k = 1; k < n; k++) {
			if (ans1[k - 1].left > gape[k].left) {
				ans1[k] = new Pair(ans1[k - 1].left, Math.min(ans1[k - 1].right, gape[k].right));
			} else {				
				ans1[k] = gape[k].union(ans1[k - 1]).build(arr[k]);
			}
		}

		for (int k = n - 2; k > -1; k--) {
			if (ans2[k + 1].left > gape[k + 1].left) {
				ans2[k] = new Pair(ans2[k + 1].left, Math.min(ans2[k + 1].right, gape[k + 1].right));
			} else {				
				ans2[k] = gape[k + 1].union(ans2[k + 1]).build(arr[k]);
			}
		}

//		int t = ans2[0].left;
//		
//		boolean flag = true;
//		
//		for (int i = 0; i < n; i++) {
//			if (t < gape[i + 1].left && t + arr[i] >= gape[i + 1].left) {
//				t = gape[i + 1].left;
//				continue;
//			} else if (t >= gape[i + 1].left && gape[i + 1].right >= t) {
//				continue;
//			}
//			
//			flag = false;
//			break;
//		}
//		
//		if (flag) {
//			out.println(ans2[0].left);
//		} else {
//			out.println(-1);
//		}
		
		for (int i = 0; i < n; i++) {
			Pair ans = ans1[i].union(ans2[i]);
//			System.err.println(ans1[i] + " " + ans2[i]);
			if (ans.left > ans.right) {
				out.println(-1);
			} else {
				out.println(Math.max(0, ans.left));
			}
			
			
		}
		
//		t = ans1[n - 1].left;
//		
//		flag = true;
//		
//		for (int i = n - 1; i > -1; i--) {
//			if (t < gape[i].left && t + arr[i] >= gape[i].left) {
//				t = gape[i].left;
//				continue;
//			} else if (t >= gape[i].left && gape[i].right >= t) {
//				continue;
//			}
//			
//			flag = false;
//			break;
//		}
//		
//		if (flag) {
//			out.println(ans1[n - 1].left);
//		} else {
//			out.println(-1);
//		}
//		
	}

	public static class Pair {
		int left;
		int right;

		public Pair(int l, int r) {
			left = l;
			right = r;
		}

		public Pair union(Pair p) {
			int l = Math.max(left, p.left);
			int r = Math.min(right, p.right);

			return new Pair(l, r);
		}

		public Pair build(int k) {
			if (left > right) {
				return new Pair(left, right);
			}
			
			int l = left - k;
			int r = right;

			return new Pair(l, r);
		}

		@Override
		public String toString() {
			return "( " + left + "; " + right + " )";
		}
	}
}
