import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class D {
	static BufferedReader br;
	static PrintWriter out;

	public static void main(String[] args) throws IOException {
		br = new BufferedReader(new FileReader(new File("internship.in")));
		out = new PrintWriter(new File("internship.out"));

		solve();

		br.close();
		out.close();
	}

	private static void solve() throws IOException {
		StringTokenizer st = new StringTokenizer(br.readLine());

		int n = Integer.parseInt(st.nextToken());
		int m = Integer.parseInt(st.nextToken());

		Pair[] p = new Pair[n + m];

		for (int i = 0; i < n + m; i++) {
			p[i] = new Pair(0, 0);
		}

		int[] a = new int[n];
		st = new StringTokenizer(br.readLine());

		for (int i = 0; i < n; i++) {
			a[i] = Integer.parseInt(st.nextToken());
			p[a[i] - 1].left = i;
		}

		int[] x = new int[n];
		st = new StringTokenizer(br.readLine());

		long[] pref1 = new long[n + 1];
		pref1[0] = 0;

		for (int i = 0; i < n; i++) {
			x[i] = Integer.parseInt(st.nextToken());
			pref1[i + 1] = pref1[i] + x[i];
		}

		int[] b = new int[m];
		st = new StringTokenizer(br.readLine());

		for (int i = 0; i < m; i++) {
			b[i] = Integer.parseInt(st.nextToken());
			p[b[i] - 1].right = i;
		}

		int[] y = new int[m];
		st = new StringTokenizer(br.readLine());

		long[] pref2 = new long[m + 1];
		pref2[0] = 0;

		for (int i = 0; i < m; i++) {
			y[i] = Integer.parseInt(st.nextToken());
			pref2[i + 1] = pref2[i] + y[i];
		}

		long max = 0;
		int l1 = -0;
		int l2 = -0;
		int r1 = -0;
		int r2 = -0;

		for (int i = 0; i < n; i++) {
			for (int j = i; j < n; j++) {
				long sum = 0;
				boolean[] used = new boolean[m];

				for (int k = i; k <= j; k++) {
					used[p[a[k] - 1].right] = true;
					sum += x[k];
				}

				int last = -1;

				long maxsumm = 0;
				int left = -1;
				int right = -1;

				long s = 0;
				
				for (int k = 0; k < m; k++) {
					if (used[k]) {
						if (maxsumm < s) {
							left = last + 1;
							right = k - 1;
							maxsumm = s;
						}

						last = k;
					} else {
						s += y[k];
					}
				}

				sum += maxsumm;

				if (sum > max) {
					l1 = i;
					l2 = left;
					r1 = j;
					r2 = right;

					max = sum;
				}
			}
		}

		l1++;
		l2++;
		r1++;
		r2++;
		out.println(max);
		out.println(l1 + " " + r1);
		out.println(l2 + " " + r2);
	}

	public static class Pair {
		int left;
		int right;

		public Pair(int l, int r) {
			left = l;
			right = r;
		}

		@Override
		public String toString() {
			return "( " + left + "; " + right + " )";
		}
	}
}
