#include <bits/stdc++.h>
using namespace std;
int n;
bool used[5001];

struct Point {
    long long x, y;
    long long num;
    double angle;
};

long long vecPr(Point a, Point b, Point c) {
    Point A, B;
    A.x = b.x - a.x;
    A.y = b.y - a.y;

    B.x = c.x - b.x;
    B.y = c.y - b.y;

    long long ans = A.x * B.y - B.x * A.y;

    if (ans < 0) return -1;
    else if (ans > 0) return 1;
    return 0;
}

bool cmp(Point a, Point b) {
    return a.angle < b.angle;
}

void ask(vector <Point> a) {
    cout << "? " << a.size();
    for (auto i: a)
        cout << " " << i.num;
    cout << endl;
}

void output(vector <Point> a) {
    cout << "! " << a.size();
    for (auto i: a)
        cout << " " << i.num;
    cout << endl;
}

vector <Point> Graham(vector <Point> a) {
    vector <Point> obol;
    obol.push_back(a[0]);
    obol.push_back(a[1]);
    for (int i = 2; i < a.size(); i++) {
        Point B = obol.back(); obol.pop_back();
        Point A = obol.back(); obol.pop_back();
        while (!obol.empty() && vecPr(A, B, a[i]) < 0) {
            B = A;
            A = obol.back(); obol.pop_back();
        }
        obol.push_back(A);
        obol.push_back(B);
        obol.push_back(a[i]);
    }
    return obol;
}

bool inside(Point a, vector <Point> obol) {
    for (int i = 0; i < obol.size(); i++)
        if (a.x == obol[i].x && a.y == obol[i].y) return 0;

    int sgn = vecPr(obol.back(), a, obol[0]);
    for (int i = 1; i < obol.size(); i++)
        if (vecPr(obol[i - 1], a, obol[i]) != sgn) return 0;

    return 1;
}

main() {
    cin >> n;
    vector <Point> a(n);
    Point lev = {1000000000, 1000000000};
    Point inf = lev;
    for (int i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
        a[i].num = i + 1;
        if (lev.x > a[i].x)
            lev = a[i];
        else if (lev.x == a[i].x && lev.y > a[i].y)
            lev = a[i];
    }

    for (int i = 0; i < n; i++) {
        if (a[i].x == lev.x && a[i].y == lev.y)
            a[i].angle = -1000000000;
        else
            a[i].angle = atan2(a[i].y - lev.y, a[i].x - lev.x);
    }
    sort(a.begin(), a.end(), cmp);

    int q;
    cin >> q;
    for (int m = 0; m < q; m++) {
        memset(used, 0, sizeof(used));
        vector <Point> obol = Graham(a);

        bool out = 0;

        while (!out) {
            for (auto i: obol)
                used[i.num] = 1;

            Point in;
            bool b = 0;
            for (int i = 0; i < n; i++) //find point inside obol
                if (inside(a[i], obol)) {
                    in = a[i];
                    b = 1;
                    break;
                }
            if (!b) {                       //no points inside
                output(obol);
                out = 1;
                break;
            }

            int it = n - 1;
            for (int i = 1; i < obol.size(); i++)
                if (vecPr(obol[0], in, obol[i]) > 0) {
                    it = i;
                    break;
                }
            vector <Point> obol1, obol2, obol3;
            for (int i = 0; i < it; i++)
                obol1.push_back(obol[i]);
            obol1.push_back(in);

            obol2.push_back(obol[0]);
            obol2.push_back(in);
            for (int i = it; i < obol.size(); i++)
                obol2.push_back(obol[i]);

            obol3.push_back(in);
            obol3.push_back(obol[it - 1]);
            obol3.push_back(obol[it]);

            string ans;

            ask(obol1);
            cin >> ans;
            if (ans[0] == 'Y') {
                obol = obol1;
                continue;
            }

            ask(obol2);
            cin >> ans;
            if (ans[0] == 'Y') {
                obol = obol2;
                continue;
            }

            ask(obol3);
            cin >> ans;
            if (ans[0] == 'Y') {
                obol = obol3;
                continue;
            }
        }
        if (!out)
            output(obol);
    }
}
