#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

int n;
vector<int> v;
vector<int> ans(30, 2);

bool in(int a, int p) {
    return (a & (1 << p));
}

bool build(int l, int r, int z) {
    if (z < 0)
        return 1;
    int changed = 0;
    int last = -1;
    for (int j = l; j < r; ++j) {
       int cur = in(v[j], z);
       if (last != -1 && cur != last) {
            if (!changed) {
                changed = j;
            }
            else
                return 0;
       }
       last = cur;
    }
    if (changed) {
        if (ans[z] != 2)
            return 0;
        else
            ans[z] = in(v[l], z);
        bool t1 = build(l, changed, z - 1);
        bool t2 = build(changed, r, z - 1);
        if (!t1 || !t2)
            return 0;
        else
            return 1;
    }
    else {
        return build(l, r, z - 1);
    }
}

int main() {
    int n, q;
    cin >> n;
    v.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> v[i];
    build(0, n, 29);
    int res = 0;
    for (int i = 0; i < ans.size(); ++i)
        if (ans[i] == 1)
            res += (1 << i);
    cout << res << endl;
    cin >> q;
    int pl, val;
    for (int k = 0; k < q; ++k) {
        cin >> pl >> val;
        v[pl - 1] = val;
        ans = vector<int> (30, 2);
        if (build(0, n, 29)) {
            int res = 0;
            for (int i = 0; i < ans.size(); ++i)
                if (ans[i] == 1)
                    res += (1 << i);
            cout << res << endl;
        }
        else
            cout << -1 << endl;
    }
};

/*
3
0 1 4
3
2 7
3 3
1 4
*/


