#include <iostream>
#include <vector>
#include <cmath>
#include <stack>
#include <algorithm>
using namespace std;
struct vec {
    long long x, y;
    vec(long long a = 0,long long b = 0) : x(a), y(b){}
    vec operator-(vec v) {
        return vec(x - v.x, y - v.y);
    }
    vec operator+(vec v) {
        return vec(x + v.x, y + v.y);
    }
    bool operator==(vec v) {
        return ((v.x == x) && (v.y == y));
    }
    long long operator%(vec v) {
        return x * v.y - y * v.x;
    }
};
vector <vec> p;
int n;
long long s_tr(int a, int b, int c) {
    return abs((p[b] - p[a]) % (p[c] - p[a]));
}
int check(int a, int b, int c) {
    for (int i = 0; i < n; i++) {
        if ((p[a] == p[i]) || (p[b] == p[i]) || (p[c] == p[i]))
            continue;
        if (s_tr(a, b, c) == s_tr(a, b, i) + s_tr(a, c, i) + s_tr(b, c, i))
            return 0;
    }
    return 1;
}
int ask(int a, int b, int c) {
    cout << "? 3 " << a + 1 << " " << b + 1 << " " << c + 1 << endl;
    string s;
    cin >> s;
    if (s == "Yes")
        return 1;
    return 0;
}
main() {
    cin >> n;
    p.resize(n);
    for (int i = 0; i < n; i++)
        cin >> p[i].x >> p[i].y;
    int q;
    cin >> q;
    for (int s = 0; s < q; s++) {
        bool f = 1;
        for (int i = 0; i < n; i++)
            for (int j = i + 1; j < n; j++)
                for (int k = j + 1; k < n; k++) {
                    if (f && check(i, j, k) && (ask(i, j, k))) {
                        cout << "! 3 " << i + 1 << " " << j + 1 << " " << k + 1 << endl;
                        f = 0;
                    }
                }
    }
}
