#include <cmath>
#include <algorithm>
#include <fstream>
#include <bitset>
#include <set>
#include <map>
#include <string>
#include <cassert>
#include <ctime>
#include <random>

using namespace std;

const string FILENAME = "trains";
ifstream cin(FILENAME + ".in");
ofstream cout(FILENAME + ".out");

template<class T> inline void chkmin(T& a, T b) { if (a > b) a = b; }
template<class T> inline void chkmax(T& a, T b) { if (a < b) a = b; }

typedef long long ll;
typedef long double ld;

const int MAXN = 1e5;
const ll INF = 1e9;

int d[MAXN];
ll sq[MAXN];
vector<pair<int, int>> edge;
vector<ll> weight;

void Relax(int a, int b, ll w) {
	if (d[a] + w < d[b]) {
		d[b] = d[a] + w;
		sq[b] = sq[a] + w * w;
	}
	if (d[a] + w == d[b])
		chkmax(sq[b], sq[a] + w * w);
}

int main() {
	int n, qm;
	cin >> n >> qm;
	int m = 0;
	for (int i = 0; i < qm; ++i) {
		int s;
		cin >> s;
		m += s;
		int prev;
		cin >> prev;
		--prev;
		for (int i = 0; i < s; ++i) {
			int w;
			cin >> w;
			int v;
			cin >> v;
			--v;
			weight.push_back(w);
			edge.push_back(make_pair(prev, v));
			prev = v;
		}
	}
	for (int i = 1; i < n; ++i)
		d[i] = INF;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			Relax(edge[j].first, edge[j].second, weight[j]);
		}
	}
	cout << d[n - 1] << ' ' << sq[n - 1] << '\n';
}

