#include <algorithm>
#include <fstream>
#include <cmath>
#include <random>
#include <cassert>
#include <ctime>
#include <set>
#include <map>
#include <bitset>
#include <string>
#include <vector>
#include <utility>

using namespace std;

template<class t> inline void chkmin(t& a, t b) { if (a > b) a = b; }
template<class t> inline void chkmax(t& a, t b) { if (a < b) a = b; }

typedef long long ll;
typedef long double ld;

const string FILENAME = "storage";
ifstream cin(FILENAME + ".in");
ofstream cout(FILENAME + ".out");

const int MAXN = 1e6 + 57;

int pref[MAXN];
int indx[MAXN];
int bck[MAXN];
int bgn[MAXN];
bitset<MAXN> used;

bool Check(string& s, string& t) {
	int n = s.size();
	assert(n <= 4 || (n == 8 && s == "++-+--+-"));
	if (n == 0) return false;
	//bool notTheSame = 0;
	for (int i = 1; i < n; ++i) {
		if (t[i] != t[i - 1] && (s[i] != t[i] || s[i - 1] != t[i - 1]))
			return false;
		//if (t[i] != t[i - 1])
		//	notTheSame = 1;
	}
	int m = 1;
	if (s[0] != t[0]) ++m;
	for (int i = 0; i < n; ++i) {
		if (i == 0 || s[i] != s[i - 1]) {
			indx[m - 1] = i;
			pref[m] = pref[m - 1];
			++m;
		}
		++pref[m - 1];
	}
	pref[m] = pref[m - 1];
	indx[m - 1] = n;
	if (s[n - 1] != t[n - 1]) {
		indx[m - 1] = -1;
		indx[m] = n;
	}
	for (int i = 0; i <= m; ++i) {
		used[i] = 0;
		bck[i] = i;
		bgn[i] = i;
	}
	int j1 = 0, j2 = j1;
	for (int i1 = 0, i2 = 0; i1 < n; i1 = i2) {
		++i2;
		while (i2 < n && t[i2] == t[i2 - 1]) ++i2;
		while (indx[j2] != i2) ++j2;
		for (int j = j1 + 1; j < j2; j += 2) {
			if (pref[j + 1] - pref[j]
				< max(pref[j] - pref[bgn[j - 1]], pref[bck[j + 1] + 1] - pref[j + 1])) {
				bgn[bck[j + 1]] = bgn[j - 1];
				bck[bgn[j - 1]] = bck[j + 1];
				used[j] = true;
			}
		}
		for (int j = j2 - 2; j > j1; j -= 2) {
			if (used[j]) continue;
			if (pref[j + 1] - pref[j]
				< max(pref[j] - pref[bgn[j - 1]], pref[bck[j + 1] + 1] - pref[j + 1])) {
				bgn[bck[j + 1]] = bgn[j - 1];
				bck[bgn[j - 1]] = bck[j + 1];
			}
		}
		if (bck[j1] != j2 - 1 || bgn[j2 - 1] != j1)
			return false;
		j1 = j2;
	}
	return true;
}

int main() {
	cout << '\n';
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		string s, t;
		cin >> s >> t;
		if (Check(s, t))
			cout << "Yes\n";
		else
			cout << "No\n";
	}
}