#include <bits/stdc++.h>


// INT -> LL

using namespace std;

typedef long double ld;


struct point {
    int x, y;
    point() {};
    point(int a, int b) : x(a), y(b) {};
};

vector< point > points;

struct triangle {
    int a, b, c;
    triangle(int x, int y, int z) : a(x), b(y), c(z) {};
};

ld get_angle(point a, point b, point c) {
    int v1x = a.x - b.x;
    int v1y = a.y - b.y;
    int v2x = c.x - b.x;
    int v2y = c.y - b.y;

    ld v1_len = sqrt(v1x * v1x + v1y * v1y);
    ld v2_len = sqrt(v2x * v2x + v2y * v2y);


    ld mult = 1.0 * v1x * v2y - v1y * v2x;
    mult /= v1_len * v2_len;

    if (mult > 1) {
        mult = 1;
    }
    ld res = asin(mult);
    return res;
}

bool inside(int other, triangle t) {
    ld ang1 = get_angle(points[t.a], points[other], points[t.b]), ang2 = get_angle(points[t.b], points[other], points[t.c]), ang3 = get_angle(points[t.c], points[other], points[t.a]);
    //cout << "ang1 : " << ang1 << " " << ang2 << " " << ang3 << endl;
    ld sum_ang = ang1 + ang2 + ang3;
    //cout << "sum_ang : " << sum_ang << endl;
    ld eps = 0.0000001;
    return (sum_ang - 3.14159265 < eps && sum_ang - 3.14159265 > -eps);

}

inline bool ask(triangle t) {
    cout << "? " << t.a + 1 << " " << t.b + 1 << " " << t.c + 1 << endl;
    string res;
    cin >> res;
    return (res[0] == 'Y' || res[0] == 'y');
}

inline void print (triangle t) {
    cout << "! " << t.a + 1 << " " << t.b + 1 << " " << t.c + 1 << endl;
}

int main()
{
    /*
    points.push_back(*(new point(4, 2)));
    points.push_back(*(new point(3, 0)));
    points.push_back(*(new point(0, 2)));
    points.push_back(*(new point(2, 4)));

    cout << inside(0, *(new triangle(1, 2, 3))) << endl;
    */

    int n, q;
    cin >> n;
    points.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> points[i].x >> points[i].y;
    }
    cin >> q;



    vector< triangle > triangles;



    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            for (int k = j + 1; k < n; ++k) {
                bool ok = true;
                for (int other = 0; other < n; ++other) {
                    if (other == i || other == j || other == k) continue;
                    triangle cur_triangle = *(new triangle(i, j, k));
                    if (inside(other, cur_triangle)) {
                        ok = false;
                        break;
                    }
                }
                if (ok) {
                    triangles.push_back(*(new triangle(i, j, k)));
                }
            }
        }
    }

    /*
    for (auto t : triangles) {
        cout << t.a << " " << t.b << " " << t.c << endl;
    }
    */

    while (q--) {
        for (auto t : triangles) {
            bool res = ask(t);
            if (res) {
                print(t);
                break;
            }
        }
    }
    return 0;

}
