#include <algorithm>
#include <iostream>
#include <cstdio>
#include <vector>
#include <cmath>
using namespace std;
#define int long long

struct dot {
	int x, y, id;
	dot (int x = 0, int y = 0) : x(x), y(y) {}
	int operator | (dot A) {
		return ((x - A.x) * (x - A.x) + (y - A.y) * (y - A.y));
	}
};

struct vec {
	int x, y;
	vec (int x = 0, int y = 0) : x(x), y(y) {}
	vec(dot A, dot B) {
		x = B.x - A.x;
		y = B.y - A.y;
	}
	int operator * (vec A) {
		return x * A.x + y * A.y;
	}
	int operator % (vec A) {
		return x * A.y - y * A.x;
	}
};

vec operator >> (dot A, dot B) {
	return vec(A, B);
}

int sgn(int x) {
	if (x == 0)
		return 0;
	if (x < 0)
		return -1;
	return 1;
}

bool inside(dot A, dot B, dot C, dot P) {
	if ((sgn(((A >> C) % (A >> B))) * sgn(((A >> P) % (A >> B)))) <= 0)
		return false;
	return true;
}

bool doins(dot A, dot B, dot C, dot P) {
	return inside(A, B, C, P) && inside(B, C, A, P) && inside(C, A, B, P); 
}

dot read_dot(int i) {
	dot A;
	cin >> A.x >> A.y;
	A.id = i;
	return A;
}
int n;
vector <dot> arr;

vector <vector <dot> > imp;

dot cmp_dot;

bool cmp_hull (dot A, dot B) {
	if (((cmp_dot >> A) % (cmp_dot >> B)) == 0) {
		return (cmp_dot|A) < (cmp_dot|B);
	}
	return (((cmp_dot >> A) % (cmp_dot >> B)) > 0);
}

bool cmp(dot A, dot B) {
	return (A.y < B.y || (A.y == B.y && A.x < B.x));
}

void sol() {
	for (auto x : imp) {
		cout << "? " << x.size();
		for (auto y : x) {
			cout << " " << y.id;
		}
		cout << endl;
		string resp;
		cin >> resp;
		if (resp == "Yes") {

			cout << "! " << x.size();
			for (auto y : x) {
				cout << " " << y.id;
			}
			cout << endl;			

			return;
		}
	}
	// vector <int> arr2(1e9);
}


void build (vector <dot> arr) {
	if (arr.size() == 3) {
		imp.push_back(arr);
		return;
	}
	cmp_dot = *min_element(arr.begin(), arr.end(), cmp);
	sort(arr.begin(), arr.end(), cmp_hull);
	vector <dot> ans;
	ans.push_back(cmp_dot);
	vector <dot> draft;
	for (auto A : arr) {
		if (A.x == cmp_dot.x && A.y == cmp_dot.y) {continue;}
		while (ans.size() > 1 && ((ans[ans.size() - 2] >> ans.back()) % (ans.back() >> A)) <= 0) {
			draft.push_back(ans.back());
			ans.pop_back();
		}
		ans.push_back(A);
	}
	arr.clear();
	if (draft.empty()) {
		imp.push_back(ans);
		return;
	}
	if (ans.size() == 3 && draft.size() == 1) {
		imp.push_back(vector <dot> ({ans[0], ans[1], draft[0]}));
		imp.push_back(vector <dot> ({ans[1], ans[2], draft[0]}));
		imp.push_back(vector <dot> ({ans[2], ans[0], draft[0]}));
		return;
	}
	int pt = 0;
	for (int i = 2; i < ans.size(); i++) {
		vector <dot> curr;
		curr.push_back(ans[0]);
		curr.push_back(ans[i]);
		curr.push_back(ans[i - 1]);
		while (pt < draft.size() && doins(ans[0], ans[i], ans[i - 1], draft[pt])) {
			curr.push_back(draft[pt++]);
		}
		build(curr);
	}
}

signed main() {
	cin >> n;
	arr.resize(n);
	for (int i = 0; i < n; i++) {
		arr[i] = read_dot(i + 1);
	}
	int q;
	cin >> q;

	build(arr);

	// cmp_dot = *min_element(arr.begin(), arr.end(), cmp);
	// sort(arr.begin(), arr.end(), cmp_hull);
	// for (int i = 1; i < n - 1; i++) {
	// 	imp.push_back(vector <dot> ({arr[0], arr[i], arr[i + 1]}));
	// }
	// vector <dot> curr;
	// for (int i = 2; i < n - 1; i++) {
	// 	if (((arr[i - 1] >> arr[i]) % (arr[i] >> arr[i + 1])) <= 0) {
	// 		if (curr.size() == 0) {
	// 			curr.push_back(arr[i - 1]);
	// 			curr.push_back(arr[i]);
	// 		}
	// 		curr.push_back(arr[i + 1]);
	// 	} else {
	// 		if (not curr.empty()) {
	// 			imp.push_back(curr);
	// 			curr.clear();
	// 		}
	// 	}
	// }
	// if (not curr.empty()) {
	// 	imp.push_back(curr);
	// }


	for (int i = 0; i < q; i++) {
		sol();
	}
	return 0;
}