#include <algorithm>
#include <iostream>
#include <cstdio>
#include <vector>
#include <cmath>
using namespace std;


struct dot {
	int x, y, id;
	dot (int x = 0, int y = 0) : x(x), y(y) {}
};

struct vec {
	int x, y;
	vec (int x = 0, int y = 0) : x(x), y(y) {}
	vec(dot A, dot B) {
		x = B.x - A.x;
		y = B.y - A.y;
	}
	int operator * (vec A) {
		return x * A.x + y * A.y;
	}
	int operator % (vec A) {
		return x * A.y - y * A.x;
	}
};

vec operator >> (dot A, dot B) {
	return vec(A, B);
}

bool inside(dot A, dot B, dot C, dot P) {
	if ((((A >> C) % (A >> B)) * ((A >> P) % (A >> B))) <= 0)
		return false;
	return true;
}

bool doins(dot A, dot B, dot C, dot P) {
	return inside(A, B, C, P) && inside(B, C, A, P) && inside(C, A, B, P); 
}

dot read_dot(int i) {
	dot A;
	cin >> A.x >> A.y;
	A.id = i;
	return A;
}
int n;
vector <dot> arr;


void sol() {
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			for (int t = j + 1; t < n; t++) {
				dot A = arr[i];
				dot B = arr[j];
				dot C = arr[t];
				cout << "? 3 " << A.id << " " << B.id << " " << C.id << endl;
				string resp;
				cin >> resp;
				if (resp == "Yes") {
					bool all_outside = true;
					for (int x = 0; x < n; x++) {
						if (x != i && x != j && x != t) {
							all_outside &= (not doins(A, B, C, arr[x]));
						}
					}
					if (all_outside) {
						cout << "! 3 " << A.id << " " << B.id << " " << C.id << endl;
						return;
					}
				}
			}
		}
	}
}


int main() {
	cin >> n;
	arr.resize(n);
	for (int i = 0; i < n; i++) {
		arr[i] = read_dot(i + 1);
	}
	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		sol();
	}
	return 0;
}