#include <algorithm>
#include <iostream>
#include <iterator>
#include <cstdio>
#include <vector>
#include <set>
using namespace std;
#define int long long
const int INF = 1e10;


bool valid(pair <int, int> A) {
	return A.first <= A.second;
}

pair <int, int> intersect(pair <int, int> A, pair <int, int> B) {
	if (not valid(A) || not valid(B)) {
		return make_pair(INF, 0);
	}
	return {max(A.first, B.first), min(A.second, B.second)};
}

int cal(pair <int, int> A) {
	if (valid(A))
		return A.first;
	return -1;
}

signed main() {
	freopen("servers.in", "r", stdin);
	freopen("servers.out", "w", stdout);

	int n;
	cin >> n;
	
	vector <int> buffer(n);
	for (int i = 0; i < n; i++) {
		cin >> buffer[i];
	}
	vector <pair <int, int> > lim(n - 1);
	for (int i = 1; i < n; i++) {
		cin >> lim[i - 1].first >> lim[i - 1].second;
	}
	int MAXN = 5500;
	vector <vector <bool> > dp_right(n, vector <bool> (MAXN, false));
	for (int i = 0; i < MAXN; i++) {
		dp_right[n - 1][i] = true;
	}
	for (int i = n - 2; i >= 0; i--) {
		for (int t = 0; t < MAXN; t++) {
			if (t > lim[i].second || t + buffer[i] < lim[i].first) {
				dp_right[i][t] = false;
			} else if (t <= lim[i].second && t >= lim[i].first) {
				dp_right[i][t] = dp_right[i + 1][t];
			} else {
				dp_right[i][t] = dp_right[i + 1][lim[i].first];
			}
		}
	}
	vector <int> dp_right_2(n);
	for (int i = 0; i < n; i++) {
		if (count(dp_right[i].begin(), dp_right[i].end(), true) == 0) {
			dp_right_2[i] = -1;
		} else {
			for (int j = 0; j < MAXN; j++) {
				if (dp_right[i][j] == true) {
					dp_right_2[i] = j;
					break;
				}
			}
		}
	}

	reverse(buffer.begin(), buffer.end());
	reverse(lim.begin(), lim.end());


	vector <vector <bool> > dp_left(n, vector <bool> (MAXN, false));
	for (int i = 0; i < MAXN; i++) {
		dp_left[n - 1][i] = true;
	}
	for (int i = n - 2; i >= 0; i--) {
		for (int t = 0; t < MAXN; t++) {
			if (t > lim[i].second || t + buffer[i] < lim[i].first) {
				dp_left[i][t] = false;
			} else if (t <= lim[i].second && t >= lim[i].first) {
				dp_left[i][t] = dp_left[i + 1][t];
			} else {
				dp_left[i][t] = dp_left[i + 1][lim[i].first];
			}
		}
	}
	vector <int> dp_left_2(n);
	for (int i = 0; i < n; i++) {
		if (count(dp_left[i].begin(), dp_left[i].end(), true) == 0) {
			dp_left_2[i] = -1;
		} else {
			for (int j = 0; j < MAXN; j++) {
				if (dp_left[i][j] == true) {
					dp_left_2[i] = j;
					break;
				}
			}
		}
	}
	reverse(dp_left_2.begin(), dp_left_2.end());

	for (int i = 0; i < n; i++) {
		if (dp_right_2[i] == -1 || dp_left_2[i] == -1) {
			cout << -1;
		} else {
			cout << max(dp_right_2[i], dp_left_2[i]);
		}
		cout << endl;
	}


	fclose(stdin);
	fclose(stdout);
	return 0;
}