#include <bits/stdc++.h>

using namespace std;

struct Point {
    long long x, y;

    Point() {}

    Point(long long x, long long y) : x(x), y(y) {}

    long long dist() {
        return x * x + y * y;
    }

    const Point operator - (Point p) {
        return Point(x - p.x, y - p.y);
    }

    const long long operator * (Point p) {
        return x * p.x + y * p.y;
    }

};

const long long operator ^ (const Point p1, const Point p2) {
    return p1.x * p2.y - p1.y * p2.x;
}

const bool operator < (const Point p1, const Point p2) {
    if ((p1 ^ p2) != 0) {
        return (p1 ^ p2) > 0;
    }
    return p1.x * p1.x + p1.y * p1.y < p2.x * p2.x + p2.y * p2.y;
}

const int MAX_N = 10010;
const long long INF = 1e18;

int n, m;
pair<Point, int> a[MAX_N];
int st[MAX_N];
int stsz = 0;

bool que(int x, int y, int z) {
    cout << "? 3 " << x + 1 << " " << y + 1 << " " << z + 1 << endl;
    string ans;
    cin >> ans;
    return ans[0] == 'Y';
}

void tri(int x, int y, int z) {
    for (int i = 0; i < n; i++) {
        if (i != x && i != y && i != z) {
            Point p1 = a[y].first - a[x].first;
            Point p3 = a[z].first - a[x].first;
            Point p2 = a[i].first - a[x].first;
            if (((p1 ^ p2) < 0 && (p2 ^ p3) < 0) || ((p1 ^ p2) > 0 && (p2 ^ p3) > 0)) {
                p1 = a[x].first - a[y].first;
                p3 = a[z].first - a[y].first;
                p2 = a[i].first - a[y].first;
                if (((p1 ^ p2) < 0 && (p2 ^ p3) < 0) || ((p1 ^ p2) > 0 && (p2 ^ p3) > 0)) {
                    p1 = a[x].first - a[z].first;
                    p3 = a[y].first - a[z].first;
                    p2 = a[i].first - a[z].first;
                    if (((p1 ^ p2) < 0 && (p2 ^ p3) < 0) || ((p1 ^ p2) > 0 && (p2 ^ p3) > 0)) {
                        if (que(a[x].second, a[y].second, a[i].second)) {
                            tri(x, y, i);
                        } else if (que(y, z, i)) {
                            tri(y, z, i);
                        } else {
                            tri(x, z, i);
                        }
                        return;
                    }
                }
            }
        }
    }
    cout << "! 3 " << a[x].second + 1 << " " << a[y].second + 1 << " " << a[z].second + 1 << endl;
}

int main() {
    cin >> n;
    Point mn = Point(INF, INF);
    int mni = 0;
    for (int i = 0; i < n; i++) {
        long long x, y;
        cin >> x >> y;
        a[i] = {Point(x, y), i};
        if (a[i].first.y < mn.y || (a[i].first.y == mn.y && a[i].first.x < mn.x)) {
            mn = a[i].first;
            mni = i;
        }
    }
    for (int i = 0; i < n; i++) {
        a[i].first = a[i].first - mn;
    }
    swap(a[mni], a[0]);
    sort(a + 1, a + n);
    st[stsz++] = 0;
    for (int i = 1; i < n; i++) {
        while (stsz >= 2) {
            Point p1 = a[i].first - a[st[stsz - 2]].first;
            Point p2 = a[st[stsz - 1]].first - a[st[stsz - 2]].first;
            if ((p1 ^ p2) > 0) {
                stsz--;
            } else {
                break;
            }
        }
        st[stsz++] = i;
    }
    cin >> m;
    int start = 0;
    bool used[n];
    fill(used, used + n, 0);
    for (int i = 0; i < stsz; i++) {
        used[a[st[i]].second] = 1;
    }
    for (int i = 0; i < n; i++) {
        if (!used[a[i].second]) {
            start = i;
            break;
        }
    }
    for (int q = 0; q < m; q++) {
        if (stsz == n) {
            cout << "! ";
            for (int i = 0; i < n; i++) {
                cout << a[st[i]].second + 1 << " ";
            }
            cout << endl;
            continue;
        }
        for (int i = 0; i < stsz; i++) {
            if (que(a[start].second, a[st[i]].second, a[st[(i + 1) % stsz]].second)) {
                tri(start, st[i], st[(i + 1) % stsz]);
                break;
            }
        }
    }
}
