#include <bits/stdc++.h>

using namespace std;

struct Point {
    long long x, y;

    Point() {}

    Point(long long x, long long y) : x(x), y(y) {}

    long long dist() {
        return x * x + y * y;
    }

    const Point operator - (Point p) {
        return Point(x - p.x, y - p.y);
    }

    const long long operator * (Point p) {
        return x * p.x + y * p.y;
    }

};

const long long operator ^ (const Point p1, const Point p2) {
    return p1.x * p2.y - p1.y * p2.x;
}

const bool operator < (const Point p1, const Point p2) {
    return (p1 ^ p2) > 0;
}

const int MAX_N = 10010;
const long long INF = 1e18;

int n, m;
pair<Point, int> a[MAX_N];
int st[MAX_N];
int stsz = 0;

bool que(int x, int y, int z) {
    cout << "? 3 " << x + 1 << " " << y + 1 << " " << z + 1 << endl;
    string ans;
    cin >> ans;
    return ans[0] == 'Y';
}

bool queinran(int start, int L, int R) {
    if (L < R) {
        cout << "? " << R - L + 1 << " ";
        for (int i = L; i < R; i++) {
            cout << a[st[i]].second + 1 << " ";
        }
    } else {
        cout << "? " << stsz + R - L + 1 << " ";
        for (int i = L; i < stsz; i++) {
            cout << a[st[i]].second + 1 << " ";
        }
        for (int i = 0; i < R; i++) {
            cout << a[st[i]].second + 1 << " ";
        }
    }
    cout << a[start].second + 1 << endl;
    string ans;
    cin >> ans;
    return ans[0] == 'Y';
}

void tri(int x, int y, int z) {
    bool used[n];
    fill(used, used + n, 0);
    for (int t = 0; t < n; t++) {
        int i = rand() % n;
        while (used[i]) {
            i = rand() % n;
        }
        used[i] = 1;
        if (i != x && i != y && i != z) {
            Point p1 = a[y].first - a[x].first;
            Point p3 = a[z].first - a[x].first;
            Point p2 = a[i].first - a[x].first;
            if (((p1 ^ p2) < 0 && (p2 ^ p3) < 0) || ((p1 ^ p2) > 0 && (p2 ^ p3) > 0)) {
                p1 = a[x].first - a[y].first;
                p3 = a[z].first - a[y].first;
                p2 = a[i].first - a[y].first;
                if (((p1 ^ p2) < 0 && (p2 ^ p3) < 0) || ((p1 ^ p2) > 0 && (p2 ^ p3) > 0)) {
                    p1 = a[x].first - a[z].first;
                    p3 = a[y].first - a[z].first;
                    p2 = a[i].first - a[z].first;
                    if (((p1 ^ p2) < 0 && (p2 ^ p3) < 0) || ((p1 ^ p2) > 0 && (p2 ^ p3) > 0)) {
                        if (que(a[x].second, a[y].second, a[i].second)) {
                            tri(x, y, i);
                        } else if (que(a[y].second, a[z].second, a[i].second)) {
                            tri(y, i, z);
                        } else {
                            tri(i, z, x);
                        }
                        return;
                    }
                }
            }
        }
    }
    cout << "! 3 " << a[x].second + 1 << " " << a[y].second + 1 << " " << a[z].second + 1 << endl;
}

int main() {
    srand(239568);
    cin >> n;
    Point mn = Point(INF, INF);
    int mni = 0;
    for (int i = 0; i < n; i++) {
        long long x, y;
        cin >> x >> y;
        a[i] = {Point(x, y), i};
        if (a[i].first.y < mn.y || (a[i].first.y == mn.y && a[i].first.x < mn.x)) {
            mn = a[i].first;
            mni = i;
        }
    }
    for (int i = 0; i < n; i++) {
        a[i].first = a[i].first - mn;
    }
    swap(a[mni], a[0]);
    sort(a + 1, a + n);
    st[stsz++] = 0;
    for (int i = 1; i < n; i++) {
        while (stsz >= 2) {
            Point p1 = a[i].first - a[st[stsz - 2]].first;
            Point p2 = a[st[stsz - 1]].first - a[st[stsz - 2]].first;
            if ((p1 ^ p2) > 0) {
                stsz--;
            } else {
                break;
            }
        }
        st[stsz++] = i;
    }
    cin >> m;
    int start = 0;
    bool used[n];
    fill(used, used + n, 0);
    for (int i = 0; i < stsz; i++) {
        used[a[st[i]].second] = 1;
    }
    for (int i = 0; i < n; i++) {
        if (!used[a[i].second]) {
            start = i;
            break;
        }
    }
    for (int q = 0; q < m; q++) {
        if (stsz == n) {
            cout << "! " << stsz << " ";
            for (int i = 0; i < n; i++) {
                cout << a[st[i]].second + 1 << " ";
            }
            cout << endl;
            continue;
        }
        for (int i = rand() % stsz; ; i = (i + 1) % stsz) {
            int j = (i + 1) % stsz;
            while (1) {
                Point p1 = a[st[i]].first - a[start].first;
                Point p2 = a[st[j]].first - a[start].first;
                if ((p1 ^ p2) <= 0) {
                    break;
                }
                j = (j + 1) % stsz;
            }
            while (1) {
                Point p1 = a[st[i]].first - a[start].first;
                Point p2 = a[st[j]].first - a[start].first;
                if ((p1 ^ p2) <= 0) {
                    break;
                }
                i = (i - 1 + stsz) % stsz;
            }
            if (queinran(start, i, j)) {
                int L = i;
                int R = (j - 1 + stsz) % stsz;
                if (R < L) {
                    R += stsz;
                }
                while (R - L > 1) {
                    int M = (R + L) / 2;
                    if (queinran(start, L % stsz, (M + 1) % stsz)) {
                        R = M;
                    } else {
                        L = M;
                    }
                }
                tri(start, st[L % stsz], st[R % stsz]);
                break;
            } else {
                i = (j - 2 + stsz) % stsz;
            }
        }
    }
}
