#include <iostream>
#include <vector>
#include <deque>


using namespace std;

vector<vector<pair<int, int> > > path(1000, vector<pair<int, int> > (0));

const int INF = 100000000;

vector<int> dejxtra(int v, int n) {
    vector<int> t(n, INF);
    t[v] = 0;
    vector<int> r(n, INF);
    r[v] = -2;
    for (auto k : path[v]) {
        r[k.first] = min(r[k.first], k.second);
    }
    while (true) {
        int min_dist = INF;
        int u1 = -1;
        for (int i = 0; i < n; i++) {
            if (min_dist > r[i] and r[i] >= 0) {
                u1 = i;
                min_dist = r[i];
            }
        }
        if (min_dist == INF) break;
        t[u1] = min_dist;
        r[u1] = -2;
        for (auto k : path[u1]) {
            if (r[k.first] != -2) {
                r[k.first] = min(r[k.first], min_dist + k.second);
            }
        }
    }
    return t;
}


int main() {
    vector<int> u;
    int n, m, a, b, c, d;
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        cin >> a >> b >> c >> d;
        path[b - 1].push_back(make_pair(d - 1, c * c));
        path[d - 1].push_back(make_pair(b - 1, c * c));
    }
    u = dejxtra(0, n);
    cout << u[n - 1] << endl;
}
