#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>
using namespace std;
#define rep(i, n) for (int i = 0; i < n; i++)
#define repp(i, a, b) for (int i = a; i < b; i++)
typedef long long ll;
typedef pair<int, int> pii;
const int inf = 2e9;
const ll infl = 1e18;
const int N = 1001;
struct PATH {
	int ind, par;
	ll curq;
	PATH(int _ind, int _par, ll _curq) {
		ind = _ind;
		par = _par;
		curq = _curq;
	}
	bool operator < (const PATH &p) const {
		return ind < p.ind;
	}
};
struct EDGE {
	int to, w, ind;
};
set<PATH> vp[N];
vector<EDGE> g[N];
vector<int> dist;
vector<ll> qual;
void dijk(int s) {
	dist[s] = 0;
	set<pii> sp;
	sp.insert({ 0, s });
	while (!sp.empty()) {
		int fr = sp.begin()->second;
		sp.erase(sp.begin());
		for (auto t : g[fr]) {
			int to = t.to;
			int w = t.w;
			int ind = t.ind;
			if (dist[to] > w + dist[fr]) {
				sp.erase({ dist[to], to });
				dist[to] = w + dist[fr];
				sp.insert({ dist[to], to });
				vp[to].clear();
				auto it = vp[fr].lower_bound(PATH(ind, 0, 0));
				if (it != vp[fr].end() && it->ind == ind) {
					vp[to].insert(PATH(ind, it->par, it->curq + w));
					qual[to] = qual[it->par] + (it->curq + w) * (it->curq + w);
				}
				else {
					vp[to].insert(PATH(ind, fr, w));
					qual[to] = qual[fr] + w * w;
				}
			}
			else if (dist[to] == w + dist[fr]) {
				auto it = vp[fr].lower_bound(PATH(ind, 0, 0));
				if (it != vp[fr].end() && it->ind == ind) {
					vp[to].insert(PATH(ind, it->par, it->curq + w));
					qual[to] = qual[it->par] + (it->curq + w) * (it->curq + w);
				}
				else {
					vp[to].insert(PATH(ind, fr, w));
					qual[to] = qual[fr] + w * w;
				}
			}
		}
	}
}
int main() {
	ios_base::sync_with_stdio(0);
	int n, m;
	cin >> n >> m;
	dist.resize(n, inf);
	qual.resize(n);
	rep(i, m) {
		int q, fr;
		cin >> q >> fr;
		fr--;
		rep(j, q) {
			int w, to;
			cin >> w >> to;
			to--;
			g[fr].push_back({ to, w, i });
			fr = to;
		}
	}
	dijk(0);
	cout << dist[n - 1] << " " << qual[n - 1];
}