#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

int n;
vector<pair<int, int>> channels;
vector<int> buffers;

bool correct(int server, int time)
{
	int l, r, cur, lbuff, rbuff;
	l = server;
	r = server;
	lbuff = buffers[l];
	rbuff = buffers[r];
	cur = time;
	while (l > 0 || r < n - 1)
	{
		if (l > 0 && cur > channels[l - 1].second)
			return false;
		if (r < n - 1 && cur > channels[r].second)
			return false;
		while (l > 0 && cur >= channels[l - 1].first && cur <= channels[l - 1].second)
		{
			l -= 1;
			lbuff = buffers[l];
		}
		while (r < n - 1 && cur >= channels[r].first && cur <= channels[r].second)
		{
			r += 1;
			rbuff = buffers[r];
		}
		if (l > 0 && channels[l - 1].first - cur > lbuff)
			return false;
		if (r < n - 1 && channels[r].first - cur > rbuff)
			return false;
		if (l > 0 && cur > channels[l - 1].second)
			return false;
		if (r < n - 1 && cur > channels[r].second)
			return false;
		if (l > 0)
			cur = channels[l - 1].first;
		else
			cur = 1000000001;
		if (r < n - 1)
			cur = fmin(cur, channels[r].first);
	}

	return true;
}

int main()
{
	int a, i, b;
	cin >> n;

	if (n == 1)
		cout << "0" << endl;
	else
	{

		for (i = 0; i < n; i++)
		{
			cin >> a;
			buffers.push_back(a);
		}

		for (i = 0; i < n - 1; i++)
		{
			cin >> a >> b;
			pair<int, int> p;
			p.first = a;
			p.second = b;
			channels.push_back(p);
		}

		for (i = 0; i < n; i++)
		{
			int minl;
			if (i == 0)
				minl = channels[0].first - buffers[i];
			else if (i == n - 1)
				minl = channels[i - 1].first - buffers[i];
			else
				minl = fmin(channels[i - 1].first, channels[i].first) - buffers[i];
			if (minl < 0)
				minl = 0;

			int maxr;
			if (i == 0)
				maxr = channels[0].second;
			else if (i == n - 1)
				maxr = channels[i - 1].second;
			else
				maxr = fmax(channels[i - 1].second, channels[i].second);

			int k;
			bool fnd = false;

			for (k = minl; k < maxr + 1; k++)
			{
				if (correct(i, k))
				{
					fnd = true;
					cout << k << endl;
					break;
				}
			}

			if (!fnd)
				cout << "-1" << endl;
		}
	}

    return 0;
}

