#include <algorithm>
#include <vector>
#include <string>
#include <iostream>
#include <set>

using namespace std;

struct dot
{
	long long x, y;
	dot(int a, int b)
	{
		x = a;
		y = b;
	}
	dot()
	{}
};

vector<dot> arr;

long long kos(dot a, dot b, dot c)
{
	return (b.x - a.x)*(c.y - a.y) - (c.x - a.x)*(b.y - a.y);
}
bool check(int a, int b, int c)
{
	for (int i = 0; i < arr.size(); ++i)
	{
		if (i == a || i == b || i == c) continue;

		long long r, d, t;
		r = kos(arr[a], arr[b], arr[i]);
		d = kos(arr[b], arr[c], arr[i]);
		t = kos(arr[c], arr[a], arr[i]);

		if (r < 0 && d < 0 && t < 0)
			return 0;
		if (r > 0 && d > 0 && t > 0)
			return 0;
	}

	return 1;
}
vector<vector<int>> triangles;

void out(int i)
{
	cout << "? 3 " << triangles[i][0] + 1 << ' ' << triangles[i][1] + 1 << ' ';
	cout << triangles[i][2] + 1 << endl;
}
int main()
{
	srand(339);

	ios::sync_with_stdio(0);
	//cin.tie(0);

	int n;
	cin >> n;

	arr.resize(n);
	int i;
	for (i = 0; i < n; ++i)
		cin >> arr[i].x >> arr[i].y;

	int q;
	cin >> q;
	
	

	int j, k;
	for (i = 0; i < n; ++i)
		for (j = i + 1; j < n; ++j)
		{
			for (k = j + 1; k < n; ++k)
			{
				if (check(i, j, k))
					triangles.push_back({ i, j, k });
			}
		}

	random_shuffle(triangles.begin(), triangles.end());

	for (i = 0; i < q; ++i)
	{
		for (k = 0; k < triangles.size(); ++k)
		{
			out(k);
			string a;
			cin >> a;

			if (a == "Yes")
			{
				cout << "! 3 " << triangles[k][0] + 1 << ' ' << triangles[k][1] + 1 << ' ';
				cout << triangles[k][2] + 1 << endl;
				break;
			}
		}

	}

	return 0;
}