#include <iostream>
#include <vector>
#include <cassert>

using namespace std;

const int MAXN = 1010;
const int INF = 2e9;
vector <pair <int, int> > g[MAXN];
bool used[MAXN];
pair <int, int> dp[MAXN];


void relax(int v, int u, int t){
    if (dp[u].first > dp[v].first + t){
        dp[u] = make_pair(dp[v].first + t, dp[v].second + t * t);
    }
    else if ((dp[u].first == dp[v].first + t) and (dp[u].second < dp[v].second + t * t)){
        dp[u] = make_pair(dp[v].first + t, dp[v].second + t * t);
    }
}
int main(){
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++){
        int s;
        cin >> s;
        if (s != 1){
            cout << "☻" << endl;
            return 0;
        }
        int v, u, t;
        cin >> v >> t >> u;
        v -= 1;
        u -= 1;
        g[v].push_back(make_pair(u, t));
        //g[u].push_back(make_pair(v, t));
    }
    for (int i = 0; i < n; i++){
        dp[i] = make_pair(INF, INF);
    }
    dp[0] = make_pair(0, 0);
    for (int i = 0; i < n; i++){
        pair <int, int> cur = make_pair(INF, INF);
        int v = 0;
        for (int j = 0; j < n; j++){
            if ((!used[j]) and (cur > dp[j])){
                v = j;
                cur = dp[j];
            }
        }
        if (cur == make_pair(INF, INF)){
            break;
        }
        used[v] = true;
        for (int j = 0; j < g[v].size(); j++){
            int u = g[v][j].first;
            int t = g[v][j].second;
            relax(v, u, t);
        }
    }
    assert(dp[n - 1] != make_pair(INF, INF));
    cout << dp[n - 1].first << ' ' << dp[n - 1].second << endl;
}
