#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

pair<int, int> inter(const pair<int, int> &a, const pair<int, int> &b)
{
	int left = max(a.first, b.first);
	int right = min(a.second, b.second);
	return make_pair(left, right);
}

bool pass_left(const vector<pair<int, int>> &lr, const vector<int> &t, int time, int ind)
{
	if (ind <= 0)
		return true;
	pair<int, int> intr = inter(make_pair(time, time + t[ind]), lr[ind]);
	if (intr.second < intr.first)
		return false;
	return pass_left(lr, t, intr.first, ind - 1);
}

bool pass_right(const vector<pair<int, int>> &lr, const vector<int> &t, int time, int ind)
{
	if (ind >= t.size() - 1)
		return true;
	pair<int, int> intr = inter(make_pair(time, time + t[ind]), lr[ind + 1]);
	if (intr.second < intr.first)
		return false;
	return pass_right(lr, t, intr.first, ind + 1);
}

int main()
{
	const int INF = (int)1e9 + 7;
	int n;
	cin >> n;
	vector<int> t(n);
	for (int i = 0; i < n; ++i)
		cin >> t[i];
	vector<pair<int, int>> lr(n + 1);
	for (int i = 1; i < n; ++i)
		cin >> lr[i].first >> lr[i].second;
	lr[0] = lr[n] = make_pair(0, INF);
	if (n > 500)
	{
		for (int i = 0; i < n; ++i)
		{
			int left = max(0, max(lr[i].first - t[i], lr[i + 1].first - t[i])) - 1;
			int right = min(lr[i].second, lr[i + 1].second) + 1;
			while (right - left > 1)
			{
				int middle = (right + left) / 2;
				if (pass_left(lr, t, middle, i) && pass_right(lr, t, middle, i))
					right = middle;
				else
					left = middle;
			}
			if (right == min(lr[i].second, lr[i + 1].second) + 1)
				cout << -1 << endl;
			else
				cout << right << endl;
		}
	}
	else
	{
		for (int i = 0; i < n; ++i)
		{
			int ans = -1;
			for (int time = max(0, max(lr[i].first - t[i], lr[i + 1].first - t[i])); time <= min(lr[i].second, lr[i + 1].second); ++time)
			{
				if (pass_left(lr, t, time, i) && pass_right(lr, t, time, i))
				{
					ans = time;
					break;
				}
			}
			cout << ans << endl;
		}
	}
    return 0;
}

