#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>
#include <string>

using namespace std;

struct Vec {
    int x, y;

    explicit Vec(int x = 0, int y = 0) {
        this->x = x;
        this->y = y;
    }

    Vec operator+(const Vec &other) {
        return Vec(x + other.x, y + other.y);
    }
    Vec operator-(const Vec &other) {
        return Vec(x - other.x, y - other.y);
    }

    long long operator%(const Vec &other) {
        return 1ll * x * other.y - 1ll * y * other.x;
    }
};

vector<Vec> pts;

long long area(int i, int j, int k) {
    return abs((pts[i] - pts[k]) % (pts[j] - pts[k]));
}

typedef pair<pair<int, int>, int> triple;

bool cmp(triple s, triple t) {
    return area(s.first.first, s.first.second, s.second) < area(t.first.first, t.first.second, t.second);
}

vector<triple> triples;

int main()
{
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        Vec p;
        cin >> p.x >> p.y;
        pts.push_back(p);
    }
    int q;
    cin >> q;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            for (int k = j + 1; k < n; k++) {
                triples.push_back(make_pair(make_pair(i, j), k));
            }
        }
    }
    sort(triples.begin(), triples.end(), cmp);
    printf("%d %d %d\n", triples[0].first.first, triples[0].first.second, triples[0].second);
    for (int t = 0; t < q; t++) {
        for (int i = 0; i < (int) triples.size(); i++) {
            int a = triples[i].first.first;
            int b = triples[i].first.second;
            int c = triples[i].second;
            a++;
            b++;
            c++;
            cout << "? 3 " << a << " " << b << " " << c  << "\n";
            fflush(stdout);
            string t;
            cin >> t;
            if (t == "Yes") {
                cout << "! 3 " << a << " " << b << " " << c  << "\n";
                break;
            }
        }
    }
    return 0;
}
