#include <iostream>
#include <cstring>
#include <cmath>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;

const int N = 2e6;

struct pt
{
    ll x, y, ind;
};

ll x[N], y[N];

vector <pt> xr, yr;

bool cmp(pt a, pt b)
{
    return (a.x < b.x) || (a.x == b.x && a.y < b.y);
}

bool cmp1(pt a, pt b)
{
    return (a.y < b.y) || (a.y == b.y && a.x < b.x);
}

bool cc(pt a, pt b, pt c)
{
    int aa = b.y - a.y;
    int bb = a.x - b.x;
    int cc = -aa * a.x - bb * a.y;
    return aa * c.x + bb * c.y + cc <= 0;
}

bool cc1(pt a, pt b, pt c)
{
    int aa = b.y - a.y;
    int bb = a.x - b.x;
    int cc = -aa * a.x - bb * a.y;
    return aa * c.x + bb * c.y + cc >= 0;
}

bool prove(int l, int m)
{

    if (m - l + 1 < 3)
        return 0;

    vector <ll> ar;
    vector <pt> st0, st1;

    st0.push_back(xr[l]);
    st1.push_back(xr[l]);

    for (int i = l + 1; i <= m; i++)
    {
        while (st0.size() > 1 && cc(st0[st0.size() - 2], st0[st0.size() - 1], xr[i]))
            st0.pop_back();
        st0.push_back(xr[i]);
        while (st1.size() > 1 && cc1(st1[st1.size() - 2], st1[st1.size() - 1], xr[i]))
            st1.pop_back();
        st1.push_back(xr[i]);
    }

    for (int i = 0; i < st0.size(); i++)
        ar.push_back(st0[i].ind);
    for (int i = st1.size() - 2; i > 0; i--)
        ar.push_back(st1[i].ind);
    if (ar.size() < 3)
        return 0;
    cout << "? " << ar.size() << ' ';
    for (int i = 0; i < ar.size(); i++)
        cout << ar[i] + 1 << ' ';
    cout << endl;
    string pp;
    cin >> pp;
    if (pp == "Yes")
        return 1;
    else
        return 0;
}



bool prove1(int l, int m)
{

    if (m - l + 1 < 3)
        return 0;

    vector <ll> ar;
    vector <pt> st0, st1;

    vector <pt> xx;

    for (int i = l; i <= m; i++)
        xx.push_back(yr[i]);

    sort(xx.begin(), xx.end(), cmp);

    st0.push_back(xx[l]);
    st1.push_back(xx[l]);

    for (int i = l + 1; i <= m; i++)
    {
        while (st0.size() > 1 && cc(st0[st0.size() - 2], st0[st0.size() - 1], xx[i]))
            st0.pop_back();
        st0.push_back(xx[i]);
        while (st1.size() > 1 && cc1(st1[st1.size() - 2], st1[st1.size() - 1], xx[i]))
            st1.pop_back();
        st1.push_back(xx[i]);
    }

    for (int i = 0; i < st0.size(); i++)
        ar.push_back(st0[i].ind);
    for (int i = st1.size() - 2; i > 0; i--)
        ar.push_back(st1[i].ind);
    if (ar.size() < 3)
        return 0;
    cout << "? " << ar.size() << ' ';
    for (int i = 0; i < ar.size(); i++)
        cout << ar[i] + 1 << ' ';
    cout << endl;
    string pp;
    cin >> pp;
    if (pp == "Yes")
        return 1;
    else
        return 0;
}

void check(int l, int m)
{
    vector <ll> ar;
    vector <pt> st0, st1;

    vector <pt> xx;

    for (int i = l; i <= m; i++)
        xx.push_back(yr[i]);

    sort(xx.begin(), xx.end(), cmp);

    st0.push_back(xx[l]);
    st1.push_back(xx[l]);

    for (int i = l + 1; i <= m; i++)
    {
        while (st0.size() > 1 && cc(st0[st0.size() - 2], st0[st0.size() - 1], xx[i]))
            st0.pop_back();
        st0.push_back(xx[i]);
        while (st1.size() > 1 && cc1(st1[st1.size() - 2], st1[st1.size() - 1], xx[i]))
            st1.pop_back();
        st1.push_back(xx[i]);
    }

    for (int i = 0; i < st0.size(); i++)
        ar.push_back(st0[i].ind);
    for (int i = st1.size() - 2; i > 0; i--)
        ar.push_back(st1[i].ind);

    cout << "! " << ar.size() << ' ';
    for (int i = 0; i < ar.size(); i++)
        cout << ar[i] + 1 << ' ';
    cout << endl;
}
int main()
{
    ll n, m;
    cin >> n;

    set <pair <ll, ll> > s;

    for (int i = 0; i < n; i++)
    {
        cin >> x[i] >> y[i];
        if (s.count(make_pair(x[i], y[i])));
            return -1;
        s.insert(make_pair(x[i], y[i]));
        pt e;
        e.x = x[i];
        e.y = y[i];
        e.ind = i;
        xr.push_back(e);
    }
    sort(xr.begin(), xr.end(), cmp);

    int q;
    cin >> q;
    for (int k = 0; k < q; k++)
    {

        yr.clear();

        ll l = -1, r = n - 1;
        while (l + 1 < r)
        {
            ll m = (l + r) / 2;
            if (prove(0, m))
                r = m;
            else
                l = m;
        }
        int pr = r;

        //cout << pr << endl;

        l = 0, r = n;
        while (l + 1 < r)
        {
            int m = (l + r) / 2;
            if (prove(m, pr))
                l = m;
            else
                r = m;
        }

        int lr = l;

        //cout << lr << ' ' << pr << endl;

        for (int i = lr; i <= pr; i++)
            yr.push_back(xr[i]);
        sort(yr.begin(), yr.end(), cmp1);

        l = -1, r = n - 1;
        while (l + 1 < r)
        {
            int m = (l + r) / 2;
            if (prove1(0, m))
                r = m;
            else
                l = m;
        }
        pr = r;

        //cout << pr << endl;

        l = 0, r = n;
        while (l + 1 < r)
        {
            int m = (l + r) / 2;
            if (prove1(m, pr))
                l = m;
            else
                r = m;
        }

        lr = l;

        check(lr, pr);
    }
    return 0;
}
