#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1e6;

vector <long long> p;
vector <long long> r;
vector <char> z;
string s,t;

void make_set(long long v)
{
    p[v] = v;
    r[v] = 1;
    z[v] = s[v];
}

long long find_set (long long a)
{
    if (a == p[a])
        return a;
    return p[a] = find_set(p[a]);
}

void union_set(long long a,long long b)
{
    a = find_set(a);
    b = find_set(b);
    if (a != b)
    {
        p[a] = b;
        long long x = r[a];
        r[a] += r[b];
        r[b] += x;
    }
}

bool ok(string s,string t)
{
    if (s.size() != t.size())
        return false;
    z.clear();
    p.clear();
    r.clear();
    z.resize(s.size());
    p.resize(s.size());
    r.resize(s.size());

    for (int i = 0; i < s.size(); i++)
        make_set(i);


    for (int i = 0; i < s.size() - 1; i++)
        if (s[i] == s[i + 1])
            {
                union_set(i,i + 1);
            }

    while (1)
    {
        bool f = 0;
        for (int i = 0; i < s.size() - 1;i++)
        {
            int x = find_set(i);
            int y = find_set(i + 1);

            if (x != y && z[x] == z[y])
            {
                union_set(x,y);
                f = 1;
            }

            if (z[x] != z[y])
            {
                if (z[x] != t[i] && r[x] < r[y])
                {
                    union_set(x,y);
                    z[x] = z[y];
                    f = 1;
                }
                if (z[y] != t[i + 1] && r[y] < r[x])
                {
                    union_set(x,y);
                    z[y] = z[x];
                    f = 1;
                }
            }

        }
        if (!f)
            break;
    }
    for (int i = 0; i < t.size(); i++)
        if (t[i] != z[find_set(i)])
            return false;
    return true;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie();
    long long q;
    cin >> q;
    for (int y = 0; y < q; y++)
    {
        cin >> s >> t;
        if (ok(s,t))
            cout << "Yes" << endl;
        else
            cout << "No" << endl;
    }

}
