// ConsoleApplication1.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <unordered_map>

using namespace std;

vector<pair<int, bool>> compress(string from) {
	vector<pair<int, bool>> sfrom;
	int n = (int)from.size();

	sfrom.push_back({ 1, (from[0] == '+') });
	for (int i = 1; i < n; i++) {
		if (from[i] == from[i - 1])
			sfrom.back().first++;
		else
			sfrom.push_back({ 1, from[i] == '+' });
	}
	return sfrom;
}

void solve(string from, string to) {

	vector<pair<int, bool>> sfrom, sto;

	int n = (int)from.size();

	sfrom = compress(from);
	sto = compress(to);

	int cur_block = 0;
	for (int i = 0; i < sto.size(); i++) {
		vector<pair<int, bool>> cur;
		int cur_size = 0;
		int start_block = cur_block;
		while (cur_size < sto[i].first && cur_block < sfrom.size()) {
			if (cur_block == start_block && i) {
				if (sfrom[cur_block].second == sto[i - 1].second) {
					cur_size += sfrom[cur_block].first + sto[i - 1].first;
					cur.push_back(sto[i - 1]);
					cur.push_back(sfrom[cur_block]);
					cur_block++;
				}
				else {
					cur_size += sfrom[cur_block].first;
					cur.push_back(sfrom[cur_block]);
					cur_block++;
				}
			}
			else {
				cur_size += sfrom[cur_block].first;
				cur.push_back(sfrom[cur_block]);
				cur_block++;
			}
		}

		if (cur_size != sto[i].first) {
			cout << "No" << endl;
			return;
		}

		auto m = max_element(cur.begin(), cur.end());

		if (m->second != sto[i].second) {
			cout << "No" << endl;
			return;
		}

		int l = (m - cur.begin());
		int r = l;

		int size = m->first;
		bool need = m->second;
		while (l > 0 || r < cur.size() - 1) {
			bool done_smth = false;
			if (l > 0) {
				if (cur[l - 1].second == need) {
					size += cur[l - 1].first;
					l--;
					done_smth = true;
				}
				else if (cur[l - 1].first < size) {
					cur[l - 1].second = need;
					size += cur[l - 1].first;
					l--;
					done_smth = true;
				}
			}

			if (r < cur.size() - 1) {
				if (cur[r + 1].second == need) {
					size += cur[r + 1].first;
					r++;
					done_smth = true;
				}
				else if (cur[r + 1].first < size) {
					cur[r + 1].second = need;
					size += cur[r + 1].first;
					r++;
					done_smth = true;
				}
			}

			if ((l != 0 || r != cur.size() - 1) && !done_smth) {
				cout << "No" << endl;
				return;
			}
		}

	}

	cout << "Yes" << endl;
}

int main()
{

	string from, to;
	int n;
	cin >> n;

	for (int i = 0; i < n; i++) {
		cin >> from >> to;
		solve(from, to);
	}

    return 0;
}

