// ConsoleApplication1.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <unordered_map>
#include <cassert>

using namespace std;

vector<pair<int, bool>> compress(string from) {
	vector<pair<int, bool>> sfrom;
	int n = (int)from.size();

	sfrom.push_back({ 1, (from[0] == '+') });
	for (int i = 1; i < n; i++) {
		if (from[i] == from[i - 1])
			sfrom.back().first++;
		else
			sfrom.push_back({ 1, from[i] == '+' });
	}
	return sfrom;
}

struct Node {
	Node *L = nullptr, *R = nullptr;

	int length = 0;
	bool type = 1;
};

Node* ov_start;

bool solve_block(vector<pair<int, bool>> cur, int length) {
	int n = int(cur.size());
	Node *start = ov_start = nullptr;
	for (int i = 0; i < n; i++) {
		Node *ne = new Node();
		if (!ov_start)
			ov_start = ne;
		ne->length = cur[i].first;
		ne->type = cur[i].second;
		ne->L = start;
		if (start)
			start->R = ne;
		start = ne;
	}


	Node *N = ov_start;
	for (N = ov_start; N;) {
		bool done_smth = false;

		if (!N->type) {
			if (N->R) {
				N = N->R;
				continue;
			}
			else
				break;
		}

		while (N->L && (N->L->length < N->length || N->L->type == N->type)) {

			N->length += N->L->length;
			if (N->L->L) {
				N->L->L->R = N;
			}
			N->L = N->L->L;
			done_smth = true;
		}

		while (N->R && (N->R->length < N->length || N->R->type == N->type)) {
			N->length += N->R->length;
			if (N->R->R) {
				N->R->R->L = N;
			}
			
			N->R = N->R->R;
			done_smth = true;
		}

		if (done_smth && (N->L || N->R))
			continue;
		else if (done_smth) {
			break;
		}
		else if (N->R)
			N = N->R;
		else break;
	}

	if (N->length == length && N->type) {
		return true;
	}
	else
		return false;

}

void solve(string from, string to) {

	vector<pair<int, bool>> sfrom, sto;

	int n = (int)from.size();

	sfrom = compress(from);
	sto = compress(to);
	bool ans = true;
	int cur_block = 0;
	for (int i = 0; i < sto.size(); i++) {
		vector<pair<int, bool>> cur;
		int cur_size = 0;
		int start_block = cur_block;
		while (cur_size < sto[i].first && cur_block < sfrom.size()) {
			if (cur_block == start_block && i) {
				if (sfrom[cur_block].second == sto[i - 1].second) {
					cur_size += sfrom[cur_block].first + sto[i - 1].first;
					cur.push_back(sto[i - 1]);
					cur.push_back(sfrom[cur_block]);
					cur_block++;
				}
				else {
					cur_size += sfrom[cur_block].first;
					cur.push_back(sfrom[cur_block]);
					cur_block++;
				}
			}
			else {
				cur_size += sfrom[cur_block].first;
				cur.push_back(sfrom[cur_block]);
				cur_block++;
			}
		}

		if (cur_size != sto[i].first) {
			cout << "No" << endl;
			return;
		}

		if (!sto[i].second) {
			for (int j = 0; j < cur.size(); j++) {
				cur[j].second = !cur[j].second;
			}
		}

		ans = ans && solve_block(cur, sto[i].first);

	}


	cout << (ans ? "Yes" : "No") << endl;
}

int main()
{

	string from, to;
	int n;
	cin >> n;

	for (int i = 0; i < n; i++) {
		cin >> from >> to;
		solve(from, to);
	}

	return 0;
}

