#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/STACK:512000000")

#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <queue>
#include <vector>
#include <unordered_set>
#include <unordered_map>
#include <cassert>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

#define pk push_back
#define mk make_pair
#define forn(i, n) for(int i = 0; i < (int)(n); i++)
#define for1(i, n) for(int i = 1; i <=(int)(n); i++)

void solve();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	solve();
}

const int MAXN = (int)1e6 + 7;
const int INF = (int)1e9 + 7;

int n;

struct DSU {
	int pr[MAXN], l[MAXN], r[MAXN];

	void init(int n) {
		forn(i, n) {
			pr[i] = i;
			l[i] = i, r[i] = i;
		}
	}

	int get(int v) {
		return (v == pr[v] ? v : pr[v] = get(pr[v]));
	}


	int get_sz(int v) {
		if (v < 0 || v >= n) return 0;
		v = get(v);
		return r[v] - l[v] + 1;
	}

	void uni(int u, int v) {
		u = get(u), v = get(v);
		if (u == v) return;
		pr[u] = v;
		r[v] = max(r[u], r[v]);
		l[v] = min(l[u], l[v]);
	}
} D;

struct str {
	int l, r, sz1, sz2;

	int get() {
		return max(sz1, sz2) - (r - l + 1);
	}

	friend bool operator <(const str &s1, const str &s2) {
		str cop1 = s1;
		str cop2 = s2;
		if (cop1.get() == cop2.get()) {
			return s1.l < s2.l;
		}
		return cop1.get() < cop2.get();
	}
};

int nxtl[MAXN], nxtr[MAXN];

vector<pii> v;

void add(int l, int r) {
	v.push_back({ l, r });
	nxtr[l] = r;
	nxtl[r] = l;
}

bool sol() {
	v.clear();

	string s, t;
	cin >> s >> t;
	n = s.length();
	int cur = -1;

	forn(i, n) nxtl[i] = nxtr[i] = -1;

	D.init(n);

	forn(i, n) {
		if (s[i] != t[i]) {
			if (cur == -1) {
				cur = i;
				continue;
			}
			if (s[i] == s[cur]) {
				D.uni(i, cur);
				continue;
			}
			add(cur, i - 1);
			cur = i;
			continue;
		}
		if (i > 0 && s[i - 1] == t[i - 1] && s[i] == s[i - 1]) {
			D.uni(i, i - 1);
		}
		if (cur == -1) continue;
		add(cur, i - 1);
		cur = -1;
	}
	if (cur != -1) {
		add(cur, n - 1);
	}
	for (int i = 0; i < (int)v.size(); i++) {
		if (i) {
			if (v[i].first == v[i - 1].second + 1) {
				return false;
			}
		}
		int indl = v[i].first, indr = v[i].second;
		if (indl - 1>= 0 && s[indl - 1] == s[indl]) return false;
		if (indr + 1 < n && s[indr + 1] == s[indr]) return false;
	}
	
	string cop = s;

	set<str> my_set;
	forn(i, v.size()) {
		int l = v[i].first, r = v[i].second;
		my_set.insert({ l, r, D.get_sz(l - 1), D.get_sz(r + 1) });
	}

	while (!my_set.empty()) {
		auto t = *my_set.rbegin();
		my_set.erase(t);

		if (t.get() <= 0) return false;

		bool ok = true;
		int l = t.l, r = t.r;
		int curl = l - D.get_sz(l - 1), curr = r + D.get_sz(r + 1);
		
		for (int i = l; i <= r; i++) {
			cop[i] = (cop[i] == '+' ? '-' : '+');
		}

		
		if (curl - 1 >= 0) {
			if (nxtl[curl - 1] != -1) {
				int nl = nxtl[curl - 1], nr = curl - 1;
				int sz1 = D.get_sz(nl - 1), sz2 = l - curl;

				str p = { nl, nr, sz1, sz2 };

				my_set.erase(p);

				p.sz2 = min(curr, n - 1) - max(curl, 0) + 1;
				my_set.insert(p);
			}
		}

		if (curr + 1 < n) {
			if (nxtr[curr + 1] != -1) {
				int nl = curr + 1, nr = nxtr[curr + 1];

				int sz1 = curr - r, sz2 = D.get_sz(nr + 1);

				str p = { nl, nr, sz1, sz2 };

				my_set.erase(p);

				p.sz1 = min(curr, n - 1) - max(curl, 0) + 1;
				my_set.insert(p);
			}
		}

		D.uni(l, l - 1);
		D.uni(r, r + 1);

	}

	return true;
}

void solve() {
	int test;
	scanf("%d", &test);
	while (test--) {
		bool ans = sol();
		printf(ans ? "Yes\n" : "No\n");
	}
}