#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <string>
#include <stack>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long long ldouble;

#define linf 8e18
#define inf 2e9
#define eps 1e-8
#define mk make_pair
#define all(x) x.begin(), x.end()

struct pnt {
	int in;
	int x, y;
	pnt(int x, int y, int in) : x(x), y(y), in(in) {}
};

struct vec {
	int x, y;
	vec(pnt a, pnt b) : x(b.x - a.x), y(b.y - a.y) {}
};

struct stk {
	vector<pnt> V;
	int sz() {
		return V.size();
	}
	pnt top() {
		return *V.rbegin();
	}
	pnt stop() {
		return V[V.size() - 2];
	}
	void push(pnt x) {
		V.push_back(x);
	}
	void del() {
		V.pop_back();
	}
};


ll vp(vec a, vec b) {
	return 1ll * a.x * b.y - 1ll * a.y * b.x;
}

ll sqr(ll a) {
	return a * a;
}

ll sqrR(pnt a, pnt b) {
	return sqr(a.x - b.x) + sqr(a.y - b.y);
}

pnt p0 = pnt(inf, inf, 0);

bool cmp(pnt a, pnt b) {
	if (vp(vec(p0, a), vec(p0, b)) != 0ll)
		return vp(vec(p0, a), vec(p0, b)) > 0ll;
	return sqrR(p0, a) < sqrR(p0, b);
}

int N;

int mod(int k, int md) {
	if (k > md)
		k %= md;
	return k;
}

bool Inc(vector<pnt> &CH, pnt &x) {
	ll Strue = 0;
	ll S = 0;
	for (int i = 0; i < CH.size() - 1; i++) {
		Strue += abs(vp(vec(CH[0], CH[i]), vec(CH[0], CH[i + 1])));
		S += abs(vp(vec(x, CH[i]), vec(x, CH[i + 1])));
	}
	S += abs(vp(vec(x, *CH.rbegin()), vec(x, CH[0])));
	return S == Strue;
}

bool ask(vector<pnt> &V) {
	cout << "? " << V.size() << " ";
	for (int i = 0; i < V.size(); i++)
		cout << V[i].in + 1 << " ";
	cout << endl;
	string an;
	cin >> an;
	return an == "Yes";
}


void rec(vector<pnt> &CH, vector<pnt> &In) {
	if (In.empty()) {
		cout << "! " << CH.size() << " ";
		for (int i = 0; i < CH.size(); i++)
			cout << CH[i].in + 1 << " ";
		cout << endl;

		return;
	}
	int xi = mod(rand(), In.size());
	pnt x = In[xi];
	int beg = mod(rand(), CH.size());
	int from = beg;
	pnt begp = CH[beg];
	int next = beg;

	bool f = 1;

	for (int i = 0; i < 2 * CH.size(); i++) {
		next = mod((next + 1), CH.size());
		pnt nextp = CH[next];
		if ((next == mod((from + 1), CH.size()))) {
			f = !f;
		}
		if (vp(vec(begp, x), vec(x, nextp)) >= 0 || f) {
			vector<pnt> CurIn, Cur;

			//check
			int b = beg;
			while (b != next) {
				Cur.push_back(CH[b]);
				b = mod((b + 1), CH.size());
			}
			Cur.push_back(x);

			if (ask(Cur)) {
				for (int j = 0; j < In.size(); j++) {
					auto inj = In[j];
					if (j != xi && Inc(Cur, inj))
						CurIn.push_back(In[j]);
				}

				rec(Cur, CurIn);
				return;
			}

			// end check
			beg = mod((next - 1 + CH.size()), CH.size());
			next = beg;
			begp = CH[beg];
		}
	}
}

int main() {
#ifdef _DEBUG
	//freopen("in.txt", "r", stdin); freopen("out.txt", "w", stdout);
#endif
	srand(23991723513781);
	vector<pnt> V;
	cin >> N;
	int mni = 0;
	for (int i = 0; i < N; i++) {
		int a, b;
		scanf("%d%d", &a, &b);
		V.push_back(pnt(a, b, i));
		if (mk(int(a), int(b)) < mk(p0.x, p0.y)) {
			mni = i;
			p0.x = a;
			p0.y = b;
		}
	}

	swap(V[mni], V[0]);

	sort(all(V), cmp);

	stk S;
	S.push(V[0]);
	S.push(V[1]);

	vector<pnt> In;

	for (int i = 2; i < N; i++) {
		while (S.sz() > 1) {
			vec a = vec(S.stop(), S.top());
			vec b = vec(S.top(), V[i]);
			if (vp(a, b) > 0ll) {
				break;
			}
			In.push_back(S.top());
			S.del();
		}
		S.push(V[i]);
	}

	vector<pnt> Cur;
	for (int i = 0; i < S.sz(); i++) {
		Cur.push_back(S.V[i]);
	}

	int M;
	cin >> M;
	for (int i = 0; i < M; i++) {
		rec(Cur, In);
	}

#ifdef _DEBUG
	system("pause");
#endif

	return 0;
}