#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <map>
#include <set>
#include <cstring>

using namespace std;

const int INF = 1e+9 + 1000;

pair<int, int> per(pair<int, int> p1, pair<int, int> p2) {
    int l = max(p1.first, p2.first);
    int r = min(p1.second, p2.second);
    if (l > r) return make_pair(-1, -1);
    return make_pair(l, r);
}

pair<int, int> per2(pair<int, int> m1, pair<int, int> m2, pair<int, int> c, int t1) {
    if (c.first == -1)
        return make_pair(-1, -1);
    int l1 = m1.first, l2 = c.first;
    int r1 = m1.second, r2 = c.second;
    int l, r;
    if (l2 > l1)
        l = l2;
    else
        l = l2 - t1;
    r = r2;
    return per(make_pair(l, r), m2);
}

int ans(pair<int, int> l, pair<int, int> r, int t, pair<int, int> m1, pair<int, int> m2) {
    if (l.first == -1 || r.first == -1) {
        return -1;
    }
    int l1, r1 = l.second;
    int l2, r2 = r.second;
    if (l.first > m1.first)
        l1 = l.first;
    else
        l1 = l.first - t;
     if (r.first > m2.first)
        l2 = r.first;
    else
        l2 = r.first - t;
    pair<int, int> k = per(make_pair(l1, r1), make_pair(l2, r2));
    return k.first;
}

int main() {
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    //freopen("errput.txt", "w", stderr);
    int n;
    cin >> n;
    if (n == 1) {
        cout << "0" << endl;
        return 0;
    }
    vector<int> t(n);
    for (int i = 0; i < n; ++i)
        cin >> t[i];
    vector<pair<int, int> > mov(n - 1);
    for (int i = 0; i < n - 1; ++i)
        cin >> mov[i].first >> mov[i].second;
    vector<pair<int, int> > left(n);
    vector<pair<int, int> > right(n);
    left[0] = make_pair(0, INF);
    left[1] = mov[0];
    for (int i = 2; i < n; ++i) {
        left[i] = per2(mov[i - 2], mov[i - 1], left[i - 1], t[i - 1]);
    }
    right[n - 1] = make_pair(0, INF);
    right[n - 2] = mov[n - 2];
    for (int i = n - 3; i >= 0; --i) {
        right[i] = per2(mov[i + 1], mov[i], right[i + 1], t[i + 1]);
    }
    if (right[0].first != -1) {
        if (right[0].first > mov[0].first)
            cout << right[0].first << endl;
        else
            cout << right[0].first - t[0] << endl;
    }
    else
        cout << "-1\n";
    for (int i = 1; i < n - 1; ++i) {
        cout << ans(left[i], right[i], t[i], mov[i - 1], mov[i]) << endl;
    }
    if (left[n - 1].first != -1) {
        if (left[n - 1].first > mov[n - 2].first)
            cout << left[n - 1].first;
        else
            cout << left[n - 1].first - t[n - 1] << endl;
    }
    else
        cout << "-1\n";
    return 0;
}
