#include <cstdio>
#include <bitset>
#include <vector>

using namespace std;

int n;
vector<bitset<32>> nums;
vector<pair<int, int>> seq, temp_seq;

void remake(int bit) {
    temp_seq.clear();
    int start = 0, current = 0;
    for (int i = 1; i <= n; ++i) {
        if (seq[current].second == i) {
            temp_seq.push_back(make_pair(start, i));
            start = i;
            ++current;
        } else if (nums[i][bit] != nums[i - 1][bit]) {
            temp_seq.push_back(make_pair(start, i));
            start = i;
        }
    }
    seq = temp_seq;
}

long long calc() {
    long long num = 0, step = 1LL << 32;
    bool ok;
    seq.assign(1, make_pair(0, n));
    for (int bit = 31; bit >= 0; --bit) {
        step >>= 1;

        ok = true;
        for (auto& p: seq)
            for (int i = p.first + 1; i < p.second; ++i)
                if (nums[i][bit] < nums[i - 1][bit])
                    ok = false;

        if (ok) {
            remake(bit);
            continue;
        }

        ok = true;
        for (auto& p: seq)
            for (int i = p.first + 1; i < p.second; ++i)
                if (nums[i][bit] > nums[i - 1][bit])
                    ok = false;

        if (ok) {
            remake(bit);
            num |= step;
            continue;
        }

        return -1;
    }
    return num;
}

int main() {
    scanf("%d", &n);
    nums.resize(n);
    long long x;
    for (int i = 0; i < n; ++i) {
        scanf("%lld", &x);
        nums[i] = x;
    }
    printf("%lld\n", calc());
    int q;
    scanf("%d", &q);
    for (int i = 0, p; i < q; ++i) {
        scanf("%d%lld", &p, &x);
        nums[--p] = x;
        printf("%lld\n", calc());
    }
    return 0;
}