#include <iostream>
#include <vector>

using namespace std;

struct Node {
    Node *prev = nullptr, *next = nullptr;

    int value = 0;
    bool sign = true;

    Node(Node* prev, int value, bool sign) {
        this->prev = prev;
        if (prev) {
            this->next = prev->next;
            prev->next = this;
        }
        this->value = value;
        this->sign = sign;
    }

    bool tryUnite() {
        //cout << value << ' ' << sign << endl;
        if (prev && prev->value < this->value) {
            value += prev->value;
            if (prev->prev) {
                value += prev->prev->value;
                if (prev->prev->prev) {
                    prev->prev->prev->next = this;
                    prev = prev->prev->prev;
                } else
                    prev = nullptr;
            } else
                prev = nullptr;
            //cout << -1 << endl;
            return -1;
        }
        if (next && next->value < this->value) {
            this->value += next->value;
            if (next->next) {
                this->value += next->next->value;
                if (next->next->next) {
                    next->next->next->prev = this;
                    next = next->next->next;
                } else
                    next = nullptr;
            } else
                next = nullptr;
            //cout << 1 << endl;
            return 1;
        }
        return 0;
    }
};

struct List {
    Node *head = nullptr, *tail = nullptr;

    void add(int value, bool sign) {
        Node *result = new Node(tail, value, sign);
        if (!head)
            head = result;
        tail = result;
    }

    List(string& s) {
        int start = 0;
        for (int i = 1, len = s.length(); i <= len; ++i)
            if (i == len || s[i] != s[i - 1]) {
                this->add(i - start, s[start] == '+');
                start = i;
            }
    }
};

int main() {
    int q;
    cin >> q;
    while (q--) {
        string s, t;
        cin >> s >> t;

        List data = List(s);

        Node *ptr, *_ptr;

        for (ptr = data.head; ptr != nullptr; ptr = ptr->next) {
            if (ptr->sign)
                while (ptr->tryUnite() != 0);
            _ptr = ptr;
        }


        if (_ptr->value == s.length() && _ptr->sign)
            cout << "Yes" << endl;
        else
            cout << "No" << endl;

    }
    return 0;
}