#include <iostream>
#include <vector>

using namespace std;

const long long unit_cost = (long long)1e9;

int n, a;
vector<int> l, r, c;

long long search(int cnt, long long cost) {
    long long ans = unit_cost * cnt - cost;
    for (int i = 0; i < n; ++i) {
        if (cnt + r[i] > a) continue;
        long long midans = search(cnt + l[i], cost + c[i]);
        for (int j = l[i] + 1; j <= r[i]; j++) {
            midans = min(midans, search(cnt + j, cost + c[i]));
        }
        ans = max(ans, midans);
    }
    return ans;
}

int main() {
    cin >> n >> a;
    l.resize(n);
    r.resize(n);
    c.resize(n);
    const long long unit_cost = 1e9;
    if (n == 1) {
        vector<vector<long long>> d(a + 1, vector<long long>(a + 1, 0));
        vector<int> l(n), r(n), c(n);
        for (int i = 0; i < n; i++)
            cin >> l[i] >> r[i] >> c[i];
        long long ans = 0;
        for (int i = 0; i <= a; i++) {
            for (int j = 0; j <= a; j++) {
                ans = max(ans, d[i][j]);
                if (i == a || j == a) continue;
                for (int k = 0; k < n; k++) {
                    if (j + r[k] > a) continue;
                    for (int cnt = l[k]; cnt <= r[k]; cnt++) {
                        d[i + 1][j + cnt] = max(d[i + 1][j + cnt], d[i][j] + unit_cost * l[k] - c[k]);
                    }
                }
            }
        }
        cout << ans << endl;
        return 0;
    }
    for (int i = 0; i < n; i++)
        cin >> l[i] >> r[i] >> c[i];
    cout << search(0, 0) << endl;
    return 0;
}