#pragma comment(linker, "/Stack:128000000")
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <queue>

using namespace std;

typedef long long LL;

const LL INFll = (LL) 1e18;
const LL k = (LL)1e9;

int n, a;

struct Exp {
  int L, R, c;

  bool operator<(const Exp &e) const {
    return R != e.R ? R < e.R : L != e.L ? L > e.L : c < e.c;
  }
};

vector<Exp> exps;
vector<LL> mem;

LL dfs(int cur) {
  if (mem[cur] != -1) return mem[cur];

  LL opt = 0;
  for (int i = 0; i < n; ++i) {
    if (cur - exps[i].R >= 0) {
      LL d = INFll;
      for (int j = exps[i].L; j <= exps[i].R; ++j)
        d = min(d, dfs(cur - j) - exps[i].c + k * j);
      opt = max(opt, d);
    }
  }
  return mem[cur] = opt;
}

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#elif 1
# define PROB "anti"
  freopen(PROB".in", "r", stdin);
  freopen(PROB".out", "w", stdout);
#endif
  cin.tie(0);
  cin.sync_with_stdio(0);

  cin >> n >> a;
  exps.resize(n);
  mem.resize(a + 1, 0);

  for (int i = 0; i < n; ++i) {
    cin >> exps[i].L >> exps[i].R >> exps[i].c;
  }

  sort(exps.begin(), exps.end());

  LL ans = 0;

  mem[0] = 0;

  for (int cur = 1; cur <= a; ++cur) {
    for (int i = 0; i < n && exps[i].R <= cur; ++i) {
      LL tmp = INFll;
      for (int j = exps[i].L; j <= exps[i].R; ++j) {
        tmp = min(tmp, mem[cur - j] - exps[i].c + j * k);
      }
      mem[cur] = max(mem[cur], tmp);
    }
    ans = max(ans, mem[cur]);
  }

  cout << ans << endl;
  return 0;
}