#include <bits/stdc++.h>


using namespace std;


#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()


struct BigInteger
{
	vector<int> digits;
};


bool operator <(const BigInteger &a, const BigInteger &b) {
	if (sz(a.digits) > sz(b.digits)) {
		return 0;
	}
	if (sz(a.digits) < sz(b.digits)) {
		return 1;
	}
	for (int i = sz(a.digits) - 1; i >= 0; i--) {
		if (a.digits[i] < b.digits[i]) {
			return 1;
		}
		if (a.digits[i] > b.digits[i]) {
			return 0;
		}
	}
	return 0;
}


bool operator ==(const BigInteger &a, const BigInteger &b) {
	if (sz(a.digits) > sz(b.digits)) {
		return 0;
	}
	if (sz(a.digits) < sz(b.digits)) {
		return 0;
	}
	for (int i = sz(a.digits) - 1; i >= 0; i--) {
		if (a.digits[i] != b.digits[i]) {
			return 0;
		}
	}
	return 1;
}


bool operator >(const BigInteger &a, const BigInteger &b) {
	if (sz(a.digits) > sz(b.digits)) {
		return 1;
	}
	if (sz(a.digits) < sz(b.digits)) {
		return 0;
	}
	for (int i = sz(a.digits) - 1; i >= 0; i--) {
		if (a.digits[i] > b.digits[i]) {
			return 1;
		}
		if (a.digits[i] < b.digits[i]) {
			return 0;
		}
	}
	return 0;
}


BigInteger operator +(BigInteger a, BigInteger b) {
	if (sz(a.digits) < sz(b.digits)) {
		swap(a, b);
	}
	for (int i = 0; i < sz(a.digits); i++) {
		if (i < sz(b.digits)) {
			a.digits[i] += b.digits[i];
		}
		if (a.digits[i] >= 10) {
			a.digits[i] -= 10;
			if (i + 1 < sz(a.digits)) {
				a.digits[i + 1]++;
			} else {
				a.digits.push_back(1);
			}
		}
	}
	return a;
}


BigInteger operator -(BigInteger a, BigInteger b) {
	for (int i = 0; i < sz(a.digits); i++) {
		if (i < sz(b.digits)) {
			a.digits[i] -= b.digits[i];
		}
		if (a.digits[i] < 0) {
			a.digits[i] += 10;
			a.digits[i + 1]--;
		}
	}
	while (sz(a.digits) > 1 && !a.digits.back()) {
		a.digits.pop_back();
	}
	return a;
}


void print(const BigInteger &a) {
	for (int i = sz(a.digits) - 1; i >= 0; i--) {
		printf("%d", a.digits[i]);
	}
	printf("\n");
}


BigInteger a, b;


int main() {
	a.digits.clear(), b.digits.clear();
	string s;
	cin >> s;
	if (s[0] == '-') {
		for (int i = sz(s) - 1; i >= 1; i--) {
			a.digits.push_back(s[i] - '0');
		}
		cin >> s;
		if (s[0] == '-') {
			for (int i = sz(s) - 1; i >= 1; i--) {
				b.digits.push_back(s[i] - '0');
			}
			a = a + b;
			printf("-");
			print(a);
		} else {
			for (int i = sz(s) - 1; i >= 0; i--) {
				b.digits.push_back(s[i] - '0');
			}
			if (b > a || b == a) {
				b = b - a;
				print(b);
			} else {
				b = a - b;
				printf("-");
				print(b);
			}
		}
	} else {
		for (int i = sz(s) - 1; i >= 0; i--) {
			a.digits.push_back(s[i] - '0');
		}
		cin >> s;
		if (s[0] == '-') {
			for (int i = sz(s) - 1; i >= 1; i--) {
				b.digits.push_back(s[i] - '0');
			}
			if (a > b || a == b) {
				a = a - b;
				print(a);
			} else {
				a = b - a;
				printf("-");
				print(a);
			}
		} else {
			for (int i = sz(s) - 1; i >= 0; i--) {
				b.digits.push_back(s[i] - '0');
			}
			a = a + b;
			print(a);
		}
	}
	return 0;
}
