#include <bits/stdc++.h>

using namespace std;

const int maxN = 5005;

#define ll long long

struct Point
{
    ll x, y;
    int i;
    Point() {}
    Point(ll _x, ll _y, int _i) : x(_x), y(_y), i(_i) {}
};

Point operator - (Point p1, Point p2)
{
    return Point(p1.x - p2.x, p1.y - p2.y, p1.i);
}

Point operator + (Point p1, Point p2)
{
    return Point(p1.x + p2.x, p1.y + p2.y, p1.i);
}

ll ve(Point p1, Point p2)
{
    return p1.x * p2.y - p2.x * p1.y;
}

ll sk(Point p1, Point p2)
{
    return p1.x * p2.x + p1.y * p2.y;
}

ll dist2(Point p)
{
    return p.x * p.x + p.y * p.y;
}

ll sgn(ll x)
{
    return x < 0 ? -1 : (x == 0 ? 0 : 1);
}

Point arr[maxN];

int check(Point p, vector<Point>& ps)
{
    int was1 = 0, was2 = 0;

    for(int i = 0; i < ps.size(); i++)
    {
        if(ve(p - ps[i], ps[(i + 1) % ps.size()] - ps[i]) > 0) was1 = 1;
        else was2 = 1;
    }

    if(was1 && was2) return 0;
    return 1;
}

void print(vector<Point>& ps)
{
    cout << ps.size() << " ";
    for(auto p : ps) cout << p.i << " ";
    cout << endl;
}

int ask(vector<Point>& ps)
{
    cout << "? ";
    print(ps);

    string ans;
    cin >> ans;
    return ans[0] == 'Y';
}

void answer(vector<Point>& ps)
{
    cout << "! ";
    print(ps);
}

void solve(vector<Point> ps)
{
    if(ps.size() == 3) answer(ps);

    while(1)
    {
        random_shuffle(ps.begin(), ps.end());

        vector<Point> beg(3);
        for(int k = 0; k < 3; k++) beg[k] = ps[k];

        if(ask(beg))
        {
            vector<Point> nxt;
            for(auto p : ps)
            {
                if(p.i == beg[0].i || p.i == beg[1].i || p.i == beg[2].i || check(p, beg)) nxt.push_back(p);
            }
            solve(nxt);
            break;
        }
    }
}

int main()
{
    #ifdef DEBUG
      //  freopen("in.in", "r", stdin);
    #endif // DEBUG

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    for(int i = 0; i < n; i++)
    {
        cin >> arr[i].x >> arr[i].y;
        arr[i].i = i;
    }

    vector<Point> v;
    for(int i = 0; i < n; i++) v.push_back(arr[i]);

    int q;
    cin >> q;

    for(int i = 0; i < q; i++)
    {
        solve(v);
    }

    return 0;
}
