#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <map>
#include <string>
#include <set>
#include<math.h>
#include <random>
#include<time.h>


using namespace std;

typedef long long ll;

#define X first
#define Y second

const int MAXN = (int)1e5 + 7;
const double eps = (double)1e-5;


struct pt {
	double x, y;
	pt() {};
	pt(double x, double y) : x(x), y(y) {};
	pt(int x, int y) : x(double(x)), y(double(y)) {};
	pt(pt a, pt b)
	{
		x = b.x - a.x;
		y = b.y - a.y;
	}
};

double vp(pt a, pt b)
{
	return a.x * b.y - a.y * b.x;
}

bool cmp1(pair<pt, int> a, pair<pt, int> b)
{
	if (a.X.y == b.X.y)
		return a.X.x < b.X.x;
	return a.X.y < b.X.y;
}


pt core;

bool cmp2(pair<pt, int> a, pair<pt, int> b)
{
	pt q = pt(core, a.X);
	pt w = pt(core, b.X);
	return vp(q, w) >= 0;
}

double dist(pt a, pt b)
{
	return sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

bool is_p(pt a, pt b, pt t)
{
	return abs(dist(a, b) - dist(b, t) - dist(a, t)) < eps;
}

bool check(pt q, vector<pair<pt, int>> w)
{
	pt kek = pt(MAXN, (int)1e9 + 7);
	double aa = q.y - kek.y;
	double bb = -q.x + kek.x;
	double cc = -(q.x * aa + q.y * bb);
	for (int i = 1; i < w.size(); i++)
		if (is_p(w[i - 1].X, w[i].X, q))
			return false;
	int cnt = 0;

	for (int i = 1; i < w.size(); i++)
	{
		double aa1 = w[i].X.y - w[i - 1].X.y;
		double bb1 = -w[i].X.x + w[i - 1].X.x;
		double cc1 = -(aa1 * w[i].X.x + bb1 * w[i].X.y);
		double yy = ((aa1 * cc - aa * cc1) / (aa * bb1 - aa1 * bb));
		double xx = ((bb1 * cc - bb * cc1) / (aa1 * bb - bb1 * aa));
		if (is_p(w[i - 1].X, w[i].X, pt(xx, yy)) && is_p(q, kek, pt(xx, yy)))
			cnt++;
	}
	if (cnt % 2 == 0)
		return 1;
	else
		return 0;
}

pair<pt, int> a[MAXN];

int n, q;

vector<vector<int>> g;


int main()
{
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif // _DEBUG
	srand(time(0));
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		int x, y;
		cin >> x >> y;
		a[i].X = pt(x, y);
		a[i].Y = i;
	}
	for (int _ = 1; _ <= 5e7; _++)
			{
				int x = rand() % n;
				int y = rand() % n;
				int z = rand() % n;
				vector<pair<pt, int>> cur, cur1;
				for (int j = 0; j < n; j++)
				{
					if (j == x || j == y || j == z)
						cur.push_back(a[j]);
					else
						cur1.push_back(a[j]);
				}
				if (cur.size() < 3)
					continue;
				sort(cur.begin(), cur.end(), cmp1);
				core = cur[0].X;
				sort(cur.begin() + 1, cur.end(), cmp2);
				cur.push_back(cur[0]);
				bool f = 1;
				for (int j = 1; j < cur.size() - 1; j++)
				{
					pt q = pt(cur[j - 1].X, cur[j].X);
					pt w = pt(cur[j].X, cur[j + 1].X);
					if (vp(q, w) < 0)
					{
						f = 0;
						break;
					}
				}
				if (!f)
					continue;
				for (int j = 0; j < cur1.size(); j++)
					if (!check(cur1[j].X, cur))
					{
						f = 0;
						break;
					}
				if (!f)
					continue;
				vector<int> kek;

				for (int j = 0; j < cur.size() - 1; j++)
					kek.push_back(cur[j].Y);
				g.push_back(kek);
			}
	cin >> q;
	for (int zz = 0; zz < q; zz++)
	{
		random_shuffle(g.begin(), g.end());
		for (int j = 0; j < g.size(); j++)
		{
			cout << '?' << ' ' << g[j].size() << ' ';
			for (int i = 0; i < g[j].size(); i++)
				cout << g[j][i] + 1 << ' ';
			cout << endl;
			string s;
			cin >> s;
			if (s == "Yes")
			{
				cout << '!' << ' ' << g[j].size() << ' ';
				for (int i = 0; i < g[j].size(); i++)
					cout << g[j][i] + 1 << ' ';
				cout << endl;
				break;
			}
		}
	}
}